// Generated for IBM Rational SDL & TTCN Suite 6.3.0.2.22510 at Mon Nov 21 03:16:46 PM MET 2011
// Licensed Materials - Property of IBM 
// (c) Copyright IBM Corporation 1990, 2011.  All Rights Reserved.
// 
// U.S. Government Users Restricted Rights:  
// Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.

class postmaster {

  // Tools and signals
  final int SET_SDLENV = 27000;
  final int SESDLSIGNAL = 26001;
  final int SESTOPNOTIFY = 3003;

  // Return values from functions
  final int SPOK = 0;
  final int SPERROR = -1;

  // Timeout to wait indefinitely for a message
  final int SPWAITFOREVER = -1;

  // Service reply codes
  final int SDT_OK = 0;
  final int SDT_BUSY = 1;
  final int SDT_ERRSTR = 2;
  final int SDT_ERRCODE = 3;

  // Latest values from Read
  int Sender = 0;
  int Message = 0;
  String Data = "";

  public native int Init(int toolType);
  public native int SendToTool(int toolType, int message, String data);
  public native int SendToPid(int pId, int message, String data);
  public native int Broadcast(int message, String data);
  public native int Read(int timeOut);
  public native int Exit();
  
  private void ReadCallback(int sender, int message, String data) {
    Sender = sender;
    Message = message;
    Data = data;
  }

  static {
    System.loadLibrary("libsdtpost");
  }
}




