#
#  makefile for MSVC6.0 to build the host_smr.exe application
#

ccbindir = C:\Progra~1\Micros~4\VC98
sdtsource = C:\IBM\Rational\SDL_TTCN_Suite6.3\sdt\sdtdir\wini386\include
remsimsource = ..\source

cc = $(ccbindir)\bin\cl.exe
ld = $(ccbindir)\bin\link.exe
ccflags = -c -ML -nologo
#debug: ccflags = -c -MLd -Gm -Zi -Od -nologo
cppflags = /DSCTDEBCLCOM /DTARGETSIM /DHOST /DTCP /DWINDOWS /DIC86 /D_Windows
#debug: add /D_DEBUG
hostpostlib = $(sdtsource)\msvc50\libpost.lib
includes = /I$(ccbindir)\include /I$(sdtsource) /I$(remsimsource)
libs = kernel32.lib user32.lib ws2_32.lib
#debug: add bidsdfi.lib 
ldflags = -nologo -subsystem:console

#-D__DEBUG=2;__TRACE=1;__WARN=1;
#
  

host_smr.exe: tlayer.obj 
	$(ld) $(ldflags) tlayer.obj $(hostpostlib) $(libs) /NODEFAULTLIB:libcmt.lib /OUT:host_smr.exe

tlayer.obj: $(remsimsource)\tlayer.c $(remsimsource)\tcp.c $(remsimsource)\parser.c \
	$(remsimsource)\sp.h $(remsimsource)\spevent.h $(remsimsource)\tlayer.h
	$(cc) $(ccflags) $(includes) $(cppflags) /Fo$@ $(remsimsource)\tlayer.c

clean:  
	del host_smr.exe tlayer.obj 
