sdlsystem = demongame
ccbindir = D:\progra~1\devstu~1\vc
sdtsource = C:\tau35\sdt\sdtdir\wini386\include
sdlcsource = ..\example
remsimsource = ..\source

cc = $(ccbindir)\bin\cl.exe
ld = $(ccbindir)\bin\link.exe
#ccflags = -c -ML -nologo
ccflags = -c -MLd -Gm -Zi -Od -nologo
#debug: -c -MLd -Gm -Zi -Od -nologo
cppflags = /DSCTDEBCLCOM /DTARGETSIM /DTARGET /DTCP /DWINDOWS /DIC86 /D_Windows
#debug: add /D_DEBUG
hostpostlib = $(sdtsource)\msvc\libpost.lib
targetpostlib = post.obj
includes = /I$(ccbindir)\include /I$(sdtsource) /I$(remsimsource)
libs = kernel32.lib user32.lib ws2_32.lib
#debug: add bidsdfi.lib 
ldflags = -nologo -subsystem:console

#-D__DEBUG=2;__TRACE=1;__WARN=1;
#

sdtkernel = \
  sctmon.obj \
  sctos.obj \
  sctpost.obj \
  sctpred.obj \
  sctsdl.obj \
  sctutil.obj
  


$(sdlsystem).exe: $(sdlsystem).obj $(sdtkernel) $(targetpostlib)
	$(ld) $(ldflags) @<<
	$(sdlsystem).obj $(sdtkernel) $(targetpostlib) $(libs)
	/OUT:$(sdlsystem).exe
<<

$(sdlsystem).obj: $(sdlcsource)\$(sdlsystem).c
	$(cc) $(ccflags) $(includes) $(cppflags) @<<	
	/Fo$(sdlsystem).obj $(sdlcsource)\$(sdlsystem).c
<<

$(targetpostlib): $(remsimsource)\tlayer.c $(remsimsource)\tcp.c \
	$(remsimsource)\sp.h $(remsimsource)\spevent.h $(remsimsource)\tlayer.h
	$(cc) $(ccflags) $(includes) $(cppflags) @<<	
	/Fo$(targetpostlib) $(remsimsource)\tlayer.c
<<

sctmon.obj: $(sdtsource)\sctmon.c
	$(cc) $(ccflags) $(includes) $(cppflags) @<<	
	/Fo$@ $(sdtsource)\sctmon.c
<<

sctutil.obj: $(sdtsource)\sctutil.c
	$(cc) $(ccflags) $(includes) $(cppflags) @<<	
	/Fo$@ $(sdtsource)\sctutil.c
<<

sctpost.obj: $(sdtsource)\sctpost.c
	$(cc) $(ccflags) $(includes) $(cppflags) @<<	
	/Fo$@ $(sdtsource)\sctpost.c
<<

sctpred.obj: $(sdtsource)\sctpred.c
	$(cc) $(ccflags) $(includes) $(cppflags) @<<	
	/Fo$@ $(sdtsource)\sctpred.c
<<

sctsdl.obj: $(sdtsource)\sctsdl.c
	$(cc) $(ccflags) $(includes) $(cppflags) @<<	
	/Fo$@ $(sdtsource)\sctsdl.c
<<

sctos.obj: $(sdtsource)\sctos.c
	$(cc) $(ccflags) $(includes) $(cppflags) @<<	
	/Fo$@ $(sdtsource)\sctos.c
<<

