/*************************************************************
Generated for IBM Rational SDL & TTCN Suite 6.3.0.2.22510 at Mon Nov 21 03:16:40 PM MET 2011
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 1990, 2011.  All Rights Reserved.

U.S. Government Users Restricted Rights:  
Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/

CUCF_ERROR(ec_SUCCESS, "Ok")

/* Memory errors */
CUCF_ERROR(ec_MEM_NotEnoughMemory, "Not enough memory")

/* Buffer errors */
CUCF_ERROR(ec_BUF_DifferentBufferTypes, "Different buffer types in the BufCopyBuf")
CUCF_ERROR(ec_BUF_WrongBufferType, "Wrong buffer type")
CUCF_ERROR(ec_BUF_CloseNotInitialized, "Closing not initialized buffer")
CUCF_ERROR(ec_BUF_WorkWithNotInitialized, "Work with not initialized buffer")
CUCF_ERROR(ec_BUF_NullPtrToUserMemory, "NULL pointer to user memory")
CUCF_ERROR(ec_BUF_NotEnoughUserMemory, "Not enough user memory")
CUCF_ERROR(ec_BUF_OpenOpened, "Opening of already opened buffer")
CUCF_ERROR(ec_BUF_IllegalClose, "Closing buffer which is still opens in read or write mode")
CUCF_ERROR(ec_BUF_CloseWrongMode, "Closing buffer with wrong mode")
CUCF_ERROR(ec_BUF_OperationWrongMode, "Operation at wrong mode")
CUCF_ERROR(ec_BUF_NoMoreDataForRead, "No more data for read")
CUCF_ERROR(ec_BUF_TooBigNumberOfBits, "Too big number of bits")
CUCF_ERROR(ec_BUF_InvalidEncodingRules, "The combination of bit masks does not form a valid encoding rule")

/* Internal errors */
CUCF_ERROR(ec_INT_InternalError, "Internal error: \"%s\", line %d")
CUCF_ERROR(ec_INT_UnsupportedType, "Unsupported type")

/* Value errors */
CUCF_ERROR(ec_VAL_IllegalRealBase, "Illegal %s value base")
CUCF_ERROR(ec_VAL_WrongConstrainedValue, "Wrong %s constrained value, type: %s, path: %s")
CUCF_ERROR(ec_VAL_WrongConstrainedLength, "Wrong %s constrained length, type: %s, path: %s")
CUCF_ERROR(ec_VAL_WrongConstrainedAlphabet, "Wrong %s constrained alphabet, type: %s, path: %s")
CUCF_ERROR(ec_VAL_WrongEnumeratedValue, "%s value is out of range, type: %s, path: %s")
     
/* Decode errors */
CUCF_ERROR(ec_DEC_NoMoreDataForRead, "No more data for read at %s, type: %s, path: %s")
CUCF_ERROR(ec_DEC_WrongIdentifierOctet, "Wrong %s identifier octet, type: %s, path: %s")
CUCF_ERROR(ec_DEC_WrongLength, "Wrong %s length, type: %s, path: %s")
CUCF_ERROR(ec_DEC_TooBigTagNumber, "Too big tag number at %s, type: %s, path: %s")
CUCF_ERROR(ec_DEC_WrongConstructedLengthPrefix, "Wrong %s constructed length prefix, type: %s, path: %s")
CUCF_ERROR(ec_DEC_WrongUnusedBits, "Wrong %s unused bits, type: %s, path: %s")
CUCF_ERROR(ec_DEC_TooBigSubIdent, "Too big %s subidentifier, type: %s, path: %s")
CUCF_ERROR(ec_DEC_WrongRealPrefix, "Wrong %s prefix, type: %s, path: %s")
CUCF_ERROR(ec_DEC_UnsupportedRealBase, "Unsupported %s base, type: %s, path: %s")
CUCF_ERROR(ec_DEC_UnsupportedRealDecimalEncoding, "Unsupported %s decimal encoding, type: %s, path: %s")
CUCF_ERROR(ec_DEC_RequiredComponentIsAbsent, "%s required component is absent, type: %s, path: %s")
CUCF_ERROR(ec_DEC_ExtRequiredComponentIsAbsent, "%s required component at the extension group is absent, type: %s, path: %s")
CUCF_ERROR(ec_DEC_AbsentComponentIsPresent, "%s absent component is present, type: %s, path: %s")
CUCF_ERROR(ec_DEC_AbsentAlternativeIsPresent, "%s absent alternative is present, type: %s, path: %s")
CUCF_ERROR(ec_DEC_UnknownComponent, "Unknown %s component, type: %s, path: %s")
CUCF_ERROR(ec_DEC_UnknownAlternative, "Unknown %s alternative, type: %s, path: %s")
CUCF_ERROR(ec_DEC_NoOpenId, "No %s at open type, type: %s, path: %s")
CUCF_ERROR(ec_DEC_UnknownObject, "Unknown %s object, type: %s, path: %s")

/* Ascii errors */
#if defined(CODER_VMS_SDT) && !defined(CODER_REMOVE_ASCII)
CUCF_ERROR(ec_ERROR_DECODING_INTEGER, "Error when decoding integer from buffer")
CUCF_ERROR(ec_ERROR_DECODING_REAL, "Error when decoding real from buffer")
CUCF_ERROR(ec_ERROR_DECODING_BOOLEAN, "Error when decoding boolean from buffer")
CUCF_ERROR(ec_ERROR_DECODING_TIME, "Error when decoding time or duration from buffer")
CUCF_ERROR(ec_ERROR_DECODING_CHARSTRING, "Error when decoding character string from buffer")
CUCF_ERROR(ec_ERROR_DECODING_BIT, "Error when decoding bit from buffer")
CUCF_ERROR(ec_ERROR_DECODING_BITSTRING, "Error when decoding bit string from buffer")
CUCF_ERROR(ec_ERROR_DECODING_OCTET, "Error when decoding octet from buffer")
CUCF_ERROR(ec_ERROR_DECODING_OCTETSTRING, "Error when decoding octet string from buffer")
CUCF_ERROR(ec_ERROR_DECODING_SIGNALID, "Error when decoding signal id from buffer")
CUCF_ERROR(ec_ERROR_DECODING_STRUCT, "Error when decoding struct from buffer")
CUCF_ERROR(ec_ERROR_DECODING_CHOICE, "Error when decoding choice or union from buffer")
CUCF_ERROR(ec_ERROR_DECODING_POWERSET, "Error when decoding powerset from buffer")
CUCF_ERROR(ec_ERROR_DECODING_BAG, "Error when decoding bag from buffer")
CUCF_ERROR(ec_ERROR_DECODING_STRING, "Error when decoding string, powerset or object identifier from buffer")
CUCF_ERROR(ec_ERROR_DECODING_ARRAY, "Error when decoding array from buffer")
CUCF_ERROR(ec_ERROR_DECODING_REF, "Error when decoding ref,oref or own from buffer")
CUCF_ERROR(ec_ERROR_DECODING_USERDEF, "Error when decoding PId, userdef, C union, char * or void * from buffer")
CUCF_ERROR(ec_ERROR_UNKNOWN_TYPE_NODE, "Unknown type node as input")
CUCF_ERROR(ec_ERROR_DECODING_PARSTART, "Error when decoding start of signal parameter or variable")
CUCF_ERROR(ec_ERROR_DECODING_PAREND, "Error when decoding end of signal parameter or variable")
#endif /* CODER_VMS_SDT && !CODER_REMOVE_ASCII */

CUCF_ERROR(ec_INT_UnsupportedIntegerValue, "Unsupported integer value")

/* User errors */
#ifdef CODER_EC_USER
#include CODER_EC_USER
#endif
