/*************************************************************
Generated for IBM Rational SDL & TTCN Suite 6.3.0.2.22510 at Mon Nov 21 03:16:40 PM MET 2011
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 1990, 2011.  All Rights Reserved.

U.S. Government Users Restricted Rights:  
Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/

#ifndef __vms_check_h
#define __vms_check_h

#include "cucf.h"

#ifndef CODER_NOUSE_BIG_INTEGER

#define CUCFIsNotINTEGERRootValue(Type, Value) \
(((Type->TypeClass == type_ASN1_CINTEGER) && \
  (((Value).Number > (unsigned int)(INT_MAX + (Value).Sign)) || \
   ((((tASN1CInteger*)Type)->IntegerConstraint.ConstraintMask & 0x20) && \
    ((int)(((tASN1CInteger*)Type)->IntegerConstraint.LBound) > \
     ((Value).Sign ? -(int)((Value).Number) : (int)((Value).Number)))) || \
   ((((tASN1CInteger*)Type)->IntegerConstraint.ConstraintMask & 0x08) && \
    (((Value).Sign ? -(int)((Value).Number) : (int)((Value).Number)) > \
      (int)(((tASN1CInteger*)Type)->IntegerConstraint.UBound))))) || \
 ((Type->TypeClass == type_ASN1_BINTEGER) && \
  (((((tASN1BInteger*)Type)->IntegerConstraint.ConstraintMask & 0x20) && \
    (((tASN1BInteger*)Type)->IntegerConstraint.ConstraintMask & 0x10 ? \
     ((Value).Sign ? \
      (unsigned int)((Value).Number) > (unsigned int)((tASN1BInteger*)Type)->IntegerConstraint.LBound : 0 ) : \
     ((Value).Sign ? \
      1 : (unsigned int)((Value).Number) < (unsigned int)((tASN1BInteger*)Type)->IntegerConstraint.LBound))) || \
   ((((tASN1BInteger*)Type)->IntegerConstraint.ConstraintMask & 0x08) && \
    (((tASN1BInteger*)Type)->IntegerConstraint.ConstraintMask & 0x04 ? \
     ((Value).Sign ? \
      (unsigned int)((Value).Number) < (unsigned int)((tASN1BInteger*)Type)->IntegerConstraint.UBound : 1 ) : \
     ((Value).Sign ? \
      0 : (unsigned int)((Value).Number) > (unsigned int)((tASN1BInteger*)Type)->IntegerConstraint.UBound))))))

#define CUCFIsNotSTRINGRootValue(Type, Length) \
(((Type->TypeClass & 0x40) && \
  ((Length < ((tASN1CString*)Type)->SizeConstraint.LBound) || \
   ((((tASN1CString*)Type)->SizeConstraint.ConstraintMask & 0x80) && \
    (((tASN1CString*)Type)->SizeConstraint.UBound < Length)))) || \
 ((Type->TypeClass & 0x80) && \
  ((Length < ((tASN1BString*)Type)->SizeConstraint.LBound) || \
   ((((tASN1BString*)Type)->SizeConstraint.ConstraintMask & 0x80) && \
    (((tASN1BString*)Type)->SizeConstraint.UBound < Length)))))

#define CUCFIsNotCHARACTER_STRINGRootValue(Type, Length) \
(((Type->TypeClass & 0x40) && \
  ((Length < ((tASN1CCharString*)Type)->SizeConstraint.LBound) || \
   ((((tASN1CCharString*)Type)->SizeConstraint.ConstraintMask & 0x80) && \
    (((tASN1CCharString*)Type)->SizeConstraint.UBound < Length)))) || \
 ((Type->TypeClass & 0x80) && \
  ((Length < ((tASN1BCharString*)Type)->SizeConstraint.LBound) || \
   ((((tASN1BCharString*)Type)->SizeConstraint.ConstraintMask & 0x80) && \
    (((tASN1BCharString*)Type)->SizeConstraint.UBound < Length)))))

#define CUCFIsNotSTRUCT_OFRootValue(Type, Length) \
(((Type->TypeClass & 0x40) && \
  ((Length < ((tASN1CStructOf*)Type)->SizeConstraint.LBound) || \
   ((((tASN1CStructOf*)Type)->SizeConstraint.ConstraintMask & 0x80) && \
    (((tASN1CStructOf*)Type)->SizeConstraint.UBound < Length)))) || \
 ((Type->TypeClass & 0x80) && \
  ((Length < ((tASN1BStructOf*)Type)->SizeConstraint.LBound) || \
   ((((tASN1BStructOf*)Type)->SizeConstraint.ConstraintMask & 0x80) && \
    (((tASN1BStructOf*)Type)->SizeConstraint.UBound < Length)))))

#else /* CODER_NOUSE_BIG_INTEGER */

#define CUCFIsNotINTEGERRootValue(Type, Value) \
(((((tASN1CInteger*)Type)->IntegerConstraint.ConstraintMask & 0x20) && \
  ((Value) < ((tASN1CInteger*)Type)->IntegerConstraint.LBound)) || \
 ((((tASN1CInteger*)Type)->IntegerConstraint.ConstraintMask & 0x08) && \
  (((tASN1CInteger*)Type)->IntegerConstraint.UBound < (Value))))

#define CUCFIsNotSTRINGRootValue(Type, Length) \
((Length < ((tASN1CString*)Type)->SizeConstraint.LBound) || \
 ((((tASN1CString*)Type)->SizeConstraint.ConstraintMask & 0x80) && \
  (((tASN1CString*)Type)->SizeConstraint.UBound < Length)))

#define CUCFIsNotCHARACTER_STRINGRootValue(Type, Length) \
((Length < ((tASN1CCharString*)Type)->SizeConstraint.LBound) || \
 ((((tASN1CCharString*)Type)->SizeConstraint.ConstraintMask & 0x80) && \
  (((tASN1CCharString*)Type)->SizeConstraint.UBound < Length)))

#define CUCFIsNotSTRUCT_OFRootValue(Type, Length) \
((Length < ((tASN1CStructOf*)Type)->SizeConstraint.LBound) || \
 ((((tASN1CStructOf*)Type)->SizeConstraint.ConstraintMask & 0x80) && \
  (((tASN1CStructOf*)Type)->SizeConstraint.UBound < Length)))

#endif /* CODER_NOUSE_BIG_INTEGER */

#define CUCFIsNotBIT_STRINGRootValue(Type, Length)   CUCFIsNotSTRINGRootValue(Type, Length)
#define CUCFIsNotOCTET_STRINGRootValue(Type, Length) CUCFIsNotSTRINGRootValue(Type, Length)
#define CUCFIsNotSEQUENCE_OFRootValue(Type, Length)  CUCFIsNotSTRUCT_OFRootValue(Type, Length)
#define CUCFIsNotSET_OFRootValue(Type, Length)       CUCFIsNotSTRUCT_OFRootValue(Type, Length)

/**********************************************************************/

#if !defined(CODER_CHECK_NONE) && !defined(CODER_CHECK_NONE_VALUE)

/**********************************************************************/

#ifndef CODER_NOUSE_INTEGER

void CUCFCheckINTEGERConstraint(tCoder* Coder, tASN1TypeInfo* Type, tVMSInteger* vInt);

#ifndef CODER_NOUSE_BIG_INTEGER

#define CUCFCheckINTEGER(Coder, Type, vInt) \
if (((Type->TypeClass == type_ASN1_CINTEGER) && (((tASN1CInteger*)Type)->IntegerConstraint.ExtMarker == em_Absent)) || \
    ((Type->TypeClass == type_ASN1_BINTEGER) && (((tASN1BInteger*)Type)->IntegerConstraint.ExtMarker == em_Absent))) \
     CUCFCheckINTEGERConstraint(Coder, Type, vInt);
#else

#define CUCFCheckINTEGER(Coder, Type, vInt) \
if ((Type->TypeClass == type_ASN1_CINTEGER) && ((tASN1CInteger*)Type)->IntegerConstraint.ExtMarker == em_Absent) \
  CUCFCheckINTEGERConstraint(Coder, Type, vInt);

#endif

#endif

/**********************************************************************/

#if !defined(CODER_NOUSE_BIT_STRING) || !defined(CODER_NOUSE_OCTET_STRING)

void CUCFCheckStringConstraint(tCoder* Coder, tASN1TypeInfo* Type, tVMSULong Length);

#define CUCFCheckBIT_STRINGConstraint(Coder, Type, Length)   CUCFCheckStringConstraint(Coder, Type, Length)
#define CUCFCheckOCTET_STRINGConstraint(Coder, Type, Length) CUCFCheckStringConstraint(Coder, Type, Length)

#define CUCFCheckBIT_STRING(Coder, Type, Length)   CUCFCheckSTRING(Coder, Type, Length)
#define CUCFCheckOCTET_STRING(Coder, Type, Length) CUCFCheckSTRING(Coder, Type, Length)

#ifndef CODER_NOUSE_BIG_INTEGER

#define CUCFCheckSTRING(Coder, Type, Length) \
if (((Type->TypeClass & 0x40) && (((tASN1CString*)Type)->SizeConstraint.ExtMarker == em_Absent)) || \
    ((Type->TypeClass & 0x80) && (((tASN1BString*)Type)->SizeConstraint.ExtMarker == em_Absent))) \
     CUCFCheckStringConstraint(Coder, Type, Length);

#else

#define CUCFCheckSTRING(Coder, Type, Length) \
if ((Type->TypeClass & 0x40) && (((tASN1CString*)Type)->SizeConstraint.ExtMarker == em_Absent)) \
  CUCFCheckStringConstraint(Coder, Type, Length);

#endif /* CODER_NOUSE_BIG_INTEGER */

#endif /* !defined(CODER_NOUSE_BIT_STRING) || !defined(CODER_NOUSE_OCTET_STRING) */

/**********************************************************************/

#ifndef CODER_NOUSE_CHARACTER_STRING

void CUCFCheckCHARACTER_STRINGConstraint(tCoder* Coder, tASN1TypeInfo* Type, tVMSString* String);

#ifndef CODER_NOUSE_BIG_INTEGER

#define CUCFCheckCHARACTER_STRING(Coder, Type, Length) \
if (((Type->TypeClass & 0x40) && (((tASN1CCharString*)Type)->SizeConstraint.ExtMarker == em_Absent)) || \
    ((Type->TypeClass & 0x80) && (((tASN1BCharString*)Type)->SizeConstraint.ExtMarker == em_Absent))) \
     CUCFCheckCHARACTER_STRINGConstraint(Coder, Type, Length);

#else

#define CUCFCheckCHARACTER_STRING(Coder, Type, String) \
if ((Type->TypeClass & 0x40) && ((tASN1CCharString*)Type)->SizeConstraint.ExtMarker == em_Absent) \
  CUCFCheckCHARACTER_STRINGConstraint(Coder, Type, String);

#endif

#endif /* CODER_NOUSE_CHARACTER_STRING */

/**********************************************************************/

#ifndef CODER_NOUSE_ENUMERATED

#ifndef CODER_NOUSE_ENUMERATED_ITEMS
#ifndef CODER_NOUSE_BIG_INTEGER
void CUCFCheckENUMERATEDValue(tCoder* Coder, tASN1TypeInfo* Type, tVMSEnumerated_BValue* vEnumVal);
#else
void CUCFCheckENUMERATEDValue(tCoder* Coder, tASN1TypeInfo* Type, tVMSULong* vEnumVal);
#endif
#endif

void CUCFCheckENUMERATEDIndex(tCoder* Coder, tASN1TypeInfo* Type, tVMSULong vEnumIndex);

#endif /* CODER_NOUSE_ENUMERATED */

/**********************************************************************/

#if !defined(CODER_NOUSE_SEQUENCE_OF) || !defined(CODER_NOUSE_SET_OF)
void CUCFCheckStructOfConstraint(tCoder* Coder, tASN1TypeInfo* Type, tVMSULong Size);

#define CUCFCheckSEQUENCE_OFConstraint(Coder, Type, Length) CUCFCheckStructOfConstraint(Coder, Type, Length)
#define CUCFCheckSET_OFConstraint(Coder, Type, Length)      CUCFCheckStructOfConstraint(Coder, Type, Length)

#define CUCFCheckSEQUENCE_OF(Coder, Type, Length)   CUCFCheckSTRUCT_OF(Coder, Type, Length)
#define CUCFCheckSET_OF(Coder, Type, Length)        CUCFCheckSTRUCT_OF(Coder, Type, Length)

#ifndef CODER_NOUSE_BIG_INTEGER

#define CUCFCheckSTRUCT_OF(Coder, Type, Length) \
if (((Type->TypeClass & 0x40) && (((tASN1CStructOf*)Type)->SizeConstraint.ExtMarker == em_Absent)) || \
    ((Type->TypeClass & 0x80) && (((tASN1BStructOf*)Type)->SizeConstraint.ExtMarker == em_Absent))) \
     CUCFCheckStructOfConstraint(Coder, Type, Length);

#else

#define CUCFCheckSTRUCT_OF(Coder, Type, Length) \
if ((Type->TypeClass & 0x40) && ((tASN1CStructOf*)Type)->SizeConstraint.ExtMarker == em_Absent) \
  CUCFCheckStructOfConstraint(Coder, Type, Length);

#endif /* CODER_NOUSE_BIG_INTEGER */

#endif /* !defined(CODER_NOUSE_SEQUENCE_OF) || !defined(CODER_NOUSE_SET_OF) */

/**********************************************************************/

#else

/**********************************************************************/

#define CUCFCheckINTEGER(Coder, Type, Integer)
#define CUCFCheckINTEGERConstraint(Coder, Type, Integer)

#define CUCFCheckBIT_STRING(Coder, Type, Length)
#define CUCFCheckBIT_STRINGConstraint(Coder, Type, Length)

#define CUCFCheckOCTET_STRING(Coder, Type, Length)
#define CUCFCheckOCTET_STRINGConstraint(Coder, Type, Length)

#define CUCFCheckCHARACTER_STRING(Coder, Type, String)
#define CUCFCheckCHARACTER_STRINGConstraint(Coder, Type, String)

#define CUCFCheckENUMERATEDValue(Coder, Type, vEnumVal)
#define CUCFCheckENUMERATEDIndex(Coder, Type, vEnumIndex)

#define CUCFCheckSEQUENCE_OF(Coder, Type, Val)
#define CUCFCheckSEQUENCE_OFConstraint(Coder, Type, Val)

#define CUCFCheckSET_OF(Coder, Type, Val)
#define CUCFCheckSET_OFConstraint(Coder, Type, Val)

/**********************************************************************/

#endif

#endif /* __vms_check_h */
