/*************************************************************
Generated for IBM Rational SDL & TTCN Suite 6.3.0.2.22510 at Mon Nov 21 03:16:40 PM MET 2011
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 1990, 2011.  All Rights Reserved.

U.S. Government Users Restricted Rights:  
Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/

#ifndef __vms_type_h
#define __vms_type_h

#include "vms/vms_internal.h"

enum
{
  type_ASN1_BOOLEAN           = 1,    /* 000 00001 */
  type_ASN1_NULL              = 5,    /* 000 00101 */
  type_ASN1_OBJECT_IDENTIFIER = 6,    /* 000 00110 */
  type_ASN1_REAL              = 9,    /* 000 01001 */

  type_ASN1_INTEGER           = 2,    /* 000 00010 */
  type_ASN1_CINTEGER          = 66,   /* 010 00010 */
  type_ASN1_BINTEGER          = 130,  /* 100 00010 */

  type_ASN1_BIT_STRING        = 3,    /* 000 00011 */
  type_ASN1_CBIT_STRING       = 67,   /* 010 00011 */
  type_ASN1_BBIT_STRING       = 131,  /* 100 00011 */

  type_ASN1_OCTET_STRING      = 4,    /* 000 00100 */
  type_ASN1_COCTET_STRING     = 68,   /* 010 00100 */
  type_ASN1_BOCTET_STRING     = 132,  /* 100 00100 */

  type_ASN1_NumericString     = 18,   /* 000 10010 */
  type_ASN1_CNumericString    = 82,   /* 010 10010 */
  type_ASN1_BNumericString    = 146,  /* 100 10010 */

  type_ASN1_PrintableString   = 19,   /* 000 10011 */
  type_ASN1_CPrintableString  = 83,   /* 010 10011 */
  type_ASN1_BPrintableString  = 147,  /* 100 10011 */

  type_ASN1_IA5String         = 22,   /* 000 10110 */
  type_ASN1_CIA5String        = 86,   /* 010 10110 */
  type_ASN1_BIA5String        = 150,  /* 100 10110 */

  type_ASN1_VisibleString     = 26,   /* 000 11010 */
  type_ASN1_CVisibleString    = 90,   /* 010 11010 */
  type_ASN1_BVisibleString    = 154,  /* 100 11010 */

  type_ASN1_UTCTime           = 23,   /* 000 10111 */
  type_ASN1_GeneralizedTime   = 24,   /* 000 11000 */

  type_ASN1_ENUMERATED        = 10,   /* 000 01010 */
  type_ASN1_BENUMERATED       = 138,  /* 100 01010 */

  type_ASN1_SEQUENCE          = 16,   /* 000 10000 */
  type_ASN1_SET               = 17,   /* 000 10001 */

  type_ASN1_SEQUENCE_OF       = 48,   /* 001 10000 */
  type_ASN1_CSEQUENCE_OF      = 112,  /* 011 10000 */
  type_ASN1_BSEQUENCE_OF      = 176,  /* 101 10000 */

  type_ASN1_SET_OF            = 49,   /* 001 10001 */
  type_ASN1_CSET_OF           = 113,  /* 011 10001 */
  type_ASN1_BSET_OF           = 177,  /* 101 10001 */

  type_ASN1_CHOICE            = 32,   /* 001 00000 */
  type_ASN1_OPEN              = 64,   /* 010 00000 */
  type_ASN1_OPEN_ID           = 96,   /* 011 00000 */
  type_ASN1_DEFINED           = 128,  /* 100 00000 */
  type_ASN1_TAGGED            = 160   /* 101 00000 */
};

typedef unsigned char tCUCFTypeClass;

enum
{
  em_Absent  = 0,
  em_Present = 1
};
typedef unsigned char tASN1ExtMarker;

enum 
{
  ct_Required = 0,
  ct_Present  = 1,
  ct_Optional = 2,
  ct_Default  = 3,
  ct_Group    = 4,
  ct_Absent   = 5
};
typedef unsigned char tASN1ComponentType;

enum
{
  rs_NonRoot = 0,
  rs_Root = 1
};
typedef unsigned char tASN1RootStruct;

enum
{
  tc_UT = 0x00, /* (0 << 6), 00000000 */
  tc_AP = 0x40, /* (1 << 6), 01000000 */
  tc_CS = 0x80, /* (2 << 6), 10000000 */
  tc_PR = 0xC0  /* (3 << 6), 11000000 */
};
typedef unsigned char tASN1TagClass;

typedef CODER_TagNumber_TYPE tASN1TagClassNumber;

struct sASN1TypeInfo
{
  tCUCFTypeClass        TypeClass;
#ifdef CODER_VMS_VRTYPE
  tVMSPointer           VRType;
#endif
#ifdef CODER_TI_NAMES
  char*                 TypeName;
#endif
};

typedef const struct
{
  tCUCFTypeClass        TypeClass;
#ifdef CODER_VMS_VRTYPE
  tVMSPointer           VRType;
#endif
#ifdef CODER_TI_NAMES
  char*                 TypeName;
#endif
} tASN1Predefined;

typedef tASN1Predefined tASN1Boolean;          /* type_ASN1_BOOLEAN */
typedef tASN1Predefined tASN1Null;             /* type_ASN1_NULL */
typedef tASN1Predefined tASN1ObjectIdentifier; /* type_ASN1_OBJECT_IDENTIFIER */
typedef tASN1Predefined tASN1Real;             /* type_ASN1_REAL */
typedef tASN1Predefined tASN1Integer;          /* type_ASN1_INTEGER */
typedef tASN1Predefined tASN1BitString;        /* type_ASN1_BIT_STRING        */
typedef tASN1Predefined tASN1OctetString;      /* type_ASN1_OCTET_STRING      */
typedef tASN1Predefined tASN1NumericString;    /* type_ASN1_NumericString     */ 
typedef tASN1Predefined tASN1PrintableString;  /* type_ASN1_PrintableString   */
typedef tASN1Predefined tASN1IA5String;        /* type_ASN1_IA5String         */
typedef tASN1Predefined tASN1VisibleString;    /* type_ASN1_VisibleString     */
typedef tASN1Predefined tASN1UTCTime;          /* type_ASN1_UTCTime           */
typedef tASN1Predefined tASN1GeneralizedTime;  /* type_ASN1_GeneralizedTime   */

/****************************************
 INTEGER ConstraintMask: 
 1xxrxrxr - Both bounds are present
 01xrxrxr - Both bounds are absent
 001rxrxr - Low bound is present
 000r1rxr - Upper bound is present
 x0xrxr1x - Bounds are equal
 xxxRxRxR - Reserved bits
 ****************************************/

typedef struct
{
  unsigned char               ConstraintMask;
  tASN1ExtMarker              ExtMarker;
  CODER_INTEGER_LBOUND_TYPE   LBound;
  CODER_INTEGER_UBOUND_TYPE   UBound;
} tASN1IntegerConstraint;

typedef const struct
{
  tCUCFTypeClass        TypeClass;
#ifdef CODER_VMS_VRTYPE
  tVMSPointer           VRType;
#endif
#ifdef CODER_TI_NAMES
  char*                 TypeName;
#endif
#ifndef CODER_REMOVE_CONSTRAINTS
  tASN1IntegerConstraint IntegerConstraint;
#endif
} tASN1CInteger; /* type_ASN1_CINTEGER */

/****************************************
 BIG INTEGER ConstraintMask: 
 1xxxxxxr - Both bounds are present
 01xxxxxr - Both bounds are absent
 001xxxxr - Low bound is present
 x0x1xxxr - Low bound is less than 0
 00001xxr - Upper bound is present
 x0xxx1xr - Upper bound is less than 0
 x0xxxx1x - Bounds are equal
 xxxxxxxR - Reserved bit
 ****************************************/

typedef struct
{
  unsigned char    ConstraintMask;
  tASN1ExtMarker   ExtMarker;
  unsigned int     LBound;
  unsigned int     UBound;
} tASN1BIntegerConstraint;

typedef const struct
{
  tCUCFTypeClass            TypeClass;
#ifdef CODER_VMS_VRTYPE
  tVMSPointer               VRType;
#endif
#ifdef CODER_TI_NAMES
  char*                     TypeName;
#endif
#ifndef CODER_REMOVE_CONSTRAINTS
  tASN1BIntegerConstraint   IntegerConstraint;
#endif
} tASN1BInteger; /* type_ASN1_BINTEGER */


/***********************************************************
 SIZE ConstraintMask: 
 C=1 - Low bound is present
 10Crrrxr - Upper bound is present (Both bounds are present)
 10Crrr1r - Bounds are equal
 xxCRRRxR - Reserved bits
 ***********************************************************/

typedef struct
{
  unsigned char            ConstraintMask;
  tASN1ExtMarker           ExtMarker;
  CODER_SIZE_LBOUND_TYPE   LBound;
  CODER_SIZE_UBOUND_TYPE   UBound;
} tASN1SizeConstraint;

typedef const struct
{
  tCUCFTypeClass        TypeClass;
#ifdef CODER_VMS_VRTYPE
  tVMSPointer           VRType;
#endif
#ifdef CODER_TI_NAMES
  char*                 TypeName;
#endif
#ifndef CODER_REMOVE_CONSTRAINTS
  tASN1SizeConstraint   SizeConstraint;
#endif
} tASN1CString;

typedef tASN1CString tASN1CBitString;    /* type_ASN1_CBIT_STRING   */
typedef tASN1CString tASN1COctetString;  /* type_ASN1_COCTET_STRING */

typedef struct
{
  unsigned char    ConstraintMask;
  tASN1ExtMarker   ExtMarker;
  unsigned int     LBound;
  unsigned int     UBound;
} tASN1BSizeConstraint;

typedef const struct
{
  tCUCFTypeClass         TypeClass;
#ifdef CODER_VMS_VRTYPE
  tVMSPointer            VRType;
#endif
#ifdef CODER_TI_NAMES
  char*                  TypeName;
#endif
#ifndef CODER_REMOVE_CONSTRAINTS
  tASN1BSizeConstraint   SizeConstraint;
#endif
} tASN1BString;

typedef tASN1BString tASN1BBitString;    /* type_ASN1_BBIT_STRING   */
typedef tASN1BString tASN1BOctetString;  /* type_ASN1_BOCTET_STRING */

typedef const struct
{
  tCUCFTypeClass        TypeClass;
#ifdef CODER_VMS_VRTYPE
  tVMSPointer           VRType;
#endif
#ifdef CODER_TI_NAMES
  char*                 TypeName;
#endif
#ifndef CODER_REMOVE_CONSTRAINTS
  unsigned char*        Alphabet;
  tVMSULong             AlphabetLen;
  tASN1SizeConstraint   SizeConstraint;
#endif
} tASN1CCharString;

typedef tASN1CCharString tASN1CNumericString;     /* type_ASN1_CNumericString   */
typedef tASN1CCharString tASN1CPrintableString;   /* type_ASN1_CPrintableString */
typedef tASN1CCharString tASN1CIA5String;         /* type_ASN1_CIA5String       */
typedef tASN1CCharString tASN1CVisibleString;     /* type_ASN1_CVisibleString   */

typedef const struct
{
  tCUCFTypeClass         TypeClass;
#ifdef CODER_VMS_VRTYPE
  tVMSPointer            VRType;
#endif
#ifdef CODER_TI_NAMES
  char*                  TypeName;
#endif
#ifndef CODER_REMOVE_CONSTRAINTS
  unsigned char*         Alphabet;
  tVMSULong              AlphabetLen;
  tASN1BSizeConstraint   SizeConstraint;
#endif
} tASN1BCharString;

typedef tASN1BCharString tASN1BNumericString;     /* type_ASN1_BNumericString   */
typedef tASN1BCharString tASN1BPrintableString;   /* type_ASN1_BPrintableString */
typedef tASN1BCharString tASN1BIA5String;         /* type_ASN1_BIA5String       */
typedef tASN1BCharString tASN1BVisibleString;     /* type_ASN1_BVisibleString   */

typedef const struct
{
#ifdef CODER_TI_NAMES
  char*                 Name;
#endif
  tVMSEnumerated_Value  Value;
} tASN1Item;

typedef const struct
{
  tCUCFTypeClass        TypeClass;
#ifdef CODER_VMS_VRTYPE
  tVMSPointer           VRType;
#endif
#ifdef CODER_TI_NAMES
  char*                 TypeName;
#endif
  long                  ExtMarker;
#if !defined(CODER_NOUSE_ENUMERATED_ITEMS) || defined(CODER_VMS_PRINT)
  tASN1Item*            Items;
#endif
  CODER_NumOf_TYPE      NumOfItems;
} tASN1Enumerated;      /* type_ASN1_ENUMERATED */

typedef const struct
{
#ifdef CODER_TI_NAMES
  char*           Name;
#endif
  unsigned char   Sign;
  unsigned int    Number;
} tASN1BItem;

typedef const struct
{
  tCUCFTypeClass        TypeClass;
#ifdef CODER_VMS_VRTYPE
  tVMSPointer           VRType;
#endif
#ifdef CODER_TI_NAMES
  char*                 TypeName;
#endif
  long                  ExtMarker;
#if !defined(CODER_NOUSE_ENUMERATED_ITEMS) || defined(CODER_VMS_PRINT)
  tASN1BItem*           Items;
#endif
  CODER_NumOf_TYPE      NumOfItems;
} tASN1BEnumerated;     /* type_ASN1_BENUMERATED */

typedef const struct
{
  tASN1TypeInfo*        TypeInfo;
#ifdef CODER_TI_NAMES
  char*                 Name;
#endif
  tASN1ComponentType    Type;
  CODER_NumOf_TYPE      Index;
} tASN1Component;

typedef const struct
{
  tCUCFTypeClass        TypeClass;
#ifdef CODER_VMS_VRTYPE
  tVMSPointer           VRType;
#endif
#ifdef CODER_TI_NAMES
  char*                 TypeName;
#endif
  tASN1Component*       RootComps1;
  tASN1Component*       ExtAddComps;
  tASN1Component*       RootComps2;
  unsigned char         RootExtFlags;
  CODER_NumOf_TYPE      NumOfRC1;
  CODER_NumOf_TYPE      NumOfEAC;
  CODER_NumOf_TYPE      NumOfRC2;
#if defined(CODER_VMS_TTCN) || !defined(CODER_REMOVE_PER)
  CODER_NumOf_TYPE      NumOfOptDef;
  CODER_NumOf_TYPE      NumOfExtAdd;
#endif
} tASN1Struct;

typedef tASN1Struct tASN1Sequence; /* type_ASN1_SEQUENCE */
typedef tASN1Struct tASN1Set;      /* type_ASN1_SET      */

typedef const struct
{
  tCUCFTypeClass        TypeClass;
#ifdef CODER_VMS_VRTYPE
  tVMSPointer           VRType;
#endif
#ifdef CODER_TI_NAMES
  char*                 TypeName;
#endif
  tASN1TypeInfo*        BaseType;
} tASN1StructOf;

typedef tASN1StructOf tASN1SequenceOf; /* type_ASN1_SEQUENCE_OF */
typedef tASN1StructOf tASN1SetOf;      /* type_ASN1_SET_OF      */

typedef const struct
{
  tCUCFTypeClass        TypeClass;
#ifdef CODER_VMS_VRTYPE
  tVMSPointer           VRType;
#endif
#ifdef CODER_TI_NAMES
  char*                 TypeName;
#endif
  tASN1TypeInfo*        BaseType;
#ifndef CODER_REMOVE_CONSTRAINTS
  tASN1SizeConstraint   SizeConstraint;
#endif
} tASN1CStructOf;

typedef tASN1CStructOf tASN1CSequenceOf; /* type_ASN1_CSEQUENCE_OF */
typedef tASN1CStructOf tASN1CSetOf;      /* type_ASN1_CSET_OF      */

typedef const struct
{
  tCUCFTypeClass         TypeClass;
#ifdef CODER_VMS_VRTYPE
  tVMSPointer            VRType;
#endif
#ifdef CODER_TI_NAMES
  char*                  TypeName;
#endif
  tASN1TypeInfo*         BaseType;
#ifndef CODER_REMOVE_CONSTRAINTS
  tASN1BSizeConstraint   SizeConstraint;
#endif
} tASN1BStructOf;

typedef tASN1BStructOf tASN1BSequenceOf; /* type_ASN1_BSEQUENCE_OF */
typedef tASN1BStructOf tASN1BSetOf;      /* type_ASN1_BSET_OF      */

typedef const struct
{
  tASN1TypeInfo*        TypeInfo;
#ifdef CODER_TI_NAMES
  char*                 Name;
#endif
  tASN1ComponentType    Type;
  CODER_NumOf_TYPE      Index;
} tASN1Alternative;

typedef const struct
{
  tCUCFTypeClass        TypeClass;
#ifdef CODER_VMS_VRTYPE
  tVMSPointer           VRType;
#endif
#ifdef CODER_TI_NAMES
  char*                 TypeName;
#endif
  long                  ExtMarker;
  tASN1Alternative*     Alternatives;
  CODER_NumOf_TYPE      NumOfAlts;
} tASN1Choice;  /* type_ASN1_CHOICE */

typedef const struct
{
  tCUCFTypeClass        TypeClass;
#ifdef CODER_VMS_VRTYPE
  tVMSPointer           VRType;
#endif
#ifdef CODER_TI_NAMES
  char*                 TypeName;
#endif
  tASN1TypeInfo*        BaseType;
} tASN1OpenId;  /* type_ASN1_OPEN_ID */

typedef void* (*tCUCFObjectInitFunc)(tCoder* Coder);

typedef const struct
{
  tASN1TypeInfo*        TypeInfo;
#ifdef CODER_TI_NAMES
  char*                 Name;
#endif
  tCUCFObjectInitFunc   InitFunc;
  CODER_NumOf_TYPE      Index;
} tASN1Object;

typedef const struct
{
  tCUCFTypeClass        TypeClass;
#ifdef CODER_VMS_VRTYPE
  tVMSPointer           VRType;
#endif
#ifdef CODER_TI_NAMES
  char*                 TypeName;
#endif
  tASN1TypeInfo*        OpenIdType;
  tASN1Object*          Objects;
  CODER_NumOf_TYPE      NumOfObjects;
} tASN1Open;  /* type_ASN1_OPEN */

typedef const struct 
{
  tCUCFTypeClass        TypeClass;
#ifdef CODER_VMS_VRTYPE
  tVMSPointer           VRType;
#endif
#ifdef CODER_TI_NAMES
  char*                 TypeName;
#endif
  tASN1TypeInfo*        BaseType;
} tASN1Defined; /* type_ASN1_DEFINED */

typedef const struct
{
  tASN1TagClass         Class;
  tASN1TagClassNumber   Number;  
} tASN1Tag;

typedef const struct 
{
  tCUCFTypeClass        TypeClass;
#ifdef CODER_VMS_VRTYPE
  tVMSPointer           VRType;
#endif
#ifdef CODER_TI_NAMES
  char*                 TypeName;
#endif
  tASN1TypeInfo*        BaseType;
#if defined(CODER_VMS_TTCN) || !defined(CODER_REMOVE_BER)
  tASN1Tag*             Tags;
  CODER_NumOf_TYPE      NumOfTags;
#endif
} tASN1Tagged; /* type_ASN1_TAGGED */

#endif /* __vms_type_h */

