#
########################################################################
#                                                                      #
# makefile to build makegen using the gcc compiler                     #
#                                                                      #
########################################################################

########################################################################
#                                                                      #
#              Section 1: Tool dependent stuff, independent of Config  #
#                                                                      #
########################################################################

TOOL=makegen

CC=gcc
CC_FLAGS=-DMAKEGEN -DXMK_UNIX -c

LD=gcc
LDFLAGS=

########################################################################
#                                                                      #
#              Section 2: Targets                                      #
#                                                                      #
########################################################################

default: $(TOOL)
	@echo "$(TOOL).m -> DONE"


$(TOOL): makegen.o
	$(LD) makegen.o makegenlib.a -o makegen

########################################################################
#                                                                      #
#              Section 3: Dependencies                                 #
#                                                                      #
########################################################################

makegen.o: makegen.c makegen.h 
makegen.o: ini_api.h pdm_api.h 
	  $(CC) $(CC_FLAGS) makegen.c -o makegen.o

