/*************************************************************
Generated for IBM Rational SDL & TTCN Suite 6.3.0.2.22510 at Mon Nov 21 03:16:44 PM MET 2011
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 1993, 2011.  All Rights Reserved.

U.S. Government Users Restricted Rights:  
Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/
#include "gci.h"

extern int SimMain(int, char*[]);

int main(int c, char *argv[])
{
  return SimMain(c, argv);
}

/*********************************************************************
 * Name: GciLog
 * Author: ITEX C Code Generator
 *
 * This function is called every time something needs to be
 * logged. Normally the user would have to write this function too,
 * but we provide here an implementation to give some extra help on
 * the way. The user is of course free to totally rewrite this
 * function.  Returns GciOk if the logging went fine.  GciNotOk if the
 * logging couldn't be performed.
 ********************************************************************/

GciStatus GciLog(int id, const char *message)
{
  switch (id)
  {
  case GciLogStartTC:
    GciLogPrint( "Start Test Case:", message, 0 );
    break;
  case GciLogStopTC:
    GciLogPrint( "Test Case ended:", message, 0 );
    break;
  case GciLogVerdict:
    GciLogPrint( "Final verdict:", message, 0 );
    break;
  case GciLogPVerdict:
    GciLogPrint( "Preliminary verdict:", message, 0 );
    break;
  case GciLogSendE:
    GciLogPrint( "Send event:", message, 1 );
    break;
  case GciLogRecE:
    GciLogPrint( "Receive event:", message, 1 );
    break;
  case GciLogOtherE:
    GciLogPrint( "Otherwise event:", message, 1 );
    break;
  case GciLogTimeoutE:
    GciLogPrint( "TimeOut:", message, 1 );
    break;
  case GciLogAssign:
    GciLogPrint( "Assignment:", message, 1 );
    break;
  case GciLogStartT:
    GciLogPrint( "StartTimer:", message, 1 );
    break;
  case GciLogCancelT:
    GciLogPrint( "CancelTimer:", message, 1 );
    break;
  case GciLogReadT:
    GciLogPrint( "ReadTimer:", message, 1 );
    break;
  case GciLogAttach:
    GciLogPrint( "Attach:", message, 1 );
    break;
  case GciLogImplSend:
    GciLogPrint( "ImplicitSend:", message, 1 );
    break;
  case GciLogTimeout:
    GciLogPrint( "Timed out Timer:", message, 0 );
    break;
  case GciLogError:
    GciLogPrint( "TEST CASE ERROR:", message, 0);
    break;
  case GciLogCreate:
    GciLogPrint( "Create:", message, 1);
    break;
  case GciLogDone:
    GciLogPrint( "Done:", message, 1);
    break;
  case GciLogActivate:
    GciLogPrint( "Activate:", message, 1);
    break;
  case GciLogMessage:
    GciLogPrint("Message: ", message, 0);
    break;
  case GciLogMatchFailed:
    GciLogPrint( "Match failed:", message, 0);
    break;
  case GciLogBeginMatchType:
    GciLogPrint("Begin match type: ", message, 0);
    break;
  case GciLogSuccMatchType:
    GciLogPrint("End      succeed: ", message, 0);
    break;
  case GciLogFailMatchType:
    GciLogPrint("End         fail: ", message, 0);
    break;
  case GciLogSuccMatchValue:
    GciLogPrint("Match    succeed: ", message, 0);
    break;
  case GciLogFailMatchValue:
    GciLogPrint("Match       fail: ", message, 0);
    break;
  case GciLogFailAssignSignal:
    GciLogPrint("Failed to assign the incoming signal: ", message, 0);
    break;
  case GciLogStartPTC:
    GciLogPrint( "Start PTC:", message, 0 );
    break;
  case GciLogStopPTC:
    GciLogPrint( "PTC ended:", message, 0 );
    break;
  case GciLogCallQueue:
    GciLogPrint( message, "", 0 );
    break;
  case GciLogErrorPos:
    GciLogPrint( message, "", 0 );
    break;

  default:
    return GciNotOk;
  }
  
  return GciOk;
}
