/*************************************************************
Generated for IBM Rational SDL & TTCN Suite 6.3.0.2.22510 at Mon Nov 21 03:16:40 PM MET 2011
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 1990, 2011.  All Rights Reserved.

U.S. Government Users Restricted Rights:  
Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/

#ifndef X_SCTTYPES_H
#define X_SCTTYPES_H

/* Contents:
01   Main User oriented #ifdef
02   Dependent #ifdef
03   C Library
04   SDL Model macro expansions
05   Utility #ifdef
06   Macros
07   Global Variables
07   Type Forward Declarations
08   Execution Mode Def
     Includes
09   SDL_PId
10   Signal Set
12   Procedure ( = Prd )
13   Process ( = Prs )
14   Timer
15   Signal
15   xChannelQueue
15   xChannelQueueList
08   SYSTEM STATE
     MSCE
08   TRACE
08   ERROR
08   CTRL
16   Symbol Table
     LOW-LEVEL READ/WRITE
     READ/WRITE UTILITIES
17   sctOS
18   sctEnv
19   sctKernel
     TRACE
     2.3 COMPATIBILITY 
30   Access functions for test values in symbol table
*/

/****+***************************************************************
01   Main User oriented #ifdef
********************************************************************/

#ifndef XUSE_GENERIC_FUNC
#define XUSE_GENERIC_FUNC
#endif

#define HAVE_STRNCASECMP 1

/*---+---------------------------------------------------------------
     #ifdef SCTSBA
-------------------------------------------------------------------*/
/* Suitable for SBA */

#ifdef SCTSBA

#define XVALIDATOR_LIB /* Switch to inform generated and user-defined code */
                       /* that this program is a validator kernel program  */
#define XVALIDATOR /* Switch to inform generated and user-defined code */
                   /* that this program is a validator                 */
#define XEALL
/* #define XGRTRACE */
#define XMONITOR
#define XSIGPRSPRIO
/* #define XPRSPRIO */
#define XTRACE
/* #define XSIMULATORUI */
#define XMSCE
#define XCOVERAGE
#define XASSERT
/* #define XCLOCK */
/*#define XFREEVARS */ /* The process vars are release by SDL_Stop */
#define XFREEFUNCS
/*#define XFREESIGNALFUNCS*/
#define XSYNTVAR
#define XUSESYNONYMIDNODES

#endif

/*---+---------------------------------------------------------------
     #ifdef SCTSBAUI
-------------------------------------------------------------------*/
/* Suitable for SBA (executing from Sim-UI incl MSC generation) */

#ifdef SCTSBAUI

#define XVALIDATOR_LIB /* Switch to inform generated and user-defined code */
                       /* that this program is a validator kernel program  */
#define XVALIDATOR /* Switch to inform generated and user-defined code */
                   /* that this program is a validator                 */
#define XEALL
#define XGRTRACE
#define XMONITOR
#define XSIGPRSPRIO
/* #define XPRSPRIO */
#define XTRACE
#define XSIMULATORUI
#define XMSCE
#define XCOVERAGE
#define XASSERT
/* #define XCLOCK */
/*#define XFREEVARS */ /* The process vars are release by SDL_Stop */
#define XFREEFUNCS
/*#define XFREESIGNALFUNCS*/
#define XSYNTVAR
#define XUSESYNONYMIDNODES

#endif

/*---+---------------------------------------------------------------
     #ifdef XTTCNLINK
-------------------------------------------------------------------*/
/* Suitable for TTCN Link */

#ifdef XTTCNLINK

#define XVALIDATOR_LIB /* Switch to inform generated and user-defined code */
                       /* that this program is a validator kernel program  */
/* #define XVALIDATOR */
#define XEALL
#define XGRTRACE
#define XMONITOR
#define XSIGPRSPRIO
/* #define XPRSPRIO */
#define XTRACE
#define XSIMULATORUI
#define XMSCE
#define XCOVERAGE
/* #define XASSERT */
/* #define XCLOCK */
/*#define XFREEVARS */ /* The process vars are release by SDL_Stop */
#define XFREEFUNCS
/*#define XFREESIGNALFUNCS*/
#define XSYNTVAR
#define XUSESYNONYMIDNODES

#endif

#ifdef DEBUG
#define XEOWN
#endif

/****+***************************************************************
02   Dependent #ifdef
********************************************************************/
/*---+---------------------------------------------------------------
     Dependent user oriented #ifdef
-------------------------------------------------------------------*/
#ifdef XEALL
/* Turn on all XE... .*/
#define XEOUTPUT
#define XEINTDIV
#define XEREALDIV
#define XECSOP
#define XEFIXOF
#define XERANGE
#define XEINDEX
#define XECREATE
#define XEDECISION
#define XEEXPORT
#define XEVIEW
#define XEERROR
#define XEUNION
#define XEOPTIONAL
#define XECHOICE
#define XEREF
#endif

#ifdef XOPT
#define XOPTSIGPARA
#define XOPTDCL
#define XOPTFPAR
#define XOPTSTRUCT
#define XOPTLIT
#define XOPTSORT
#define XNOUSEOFREAL
#define XNOUSEOFEXPORT
#endif

#ifdef XTENV
#define XENV
#endif

#ifdef XSDLENVUI
#define XPMCOMM
#endif

/*---+---------------------------------------------------------------
     Dependent function oriented #ifdef
-------------------------------------------------------------------*/

#ifdef XEDECISION
#define XERRORSTATE
#endif

#if defined(XERANGE) || defined(XEINDEX) || defined(XMONITOR)
#define XTESTF
#endif

#if defined(XECSOP) || defined(XEFIXOF) || defined(XEINTDIV) || defined(XEREALDIV)
#define XOPERRORF
#endif

#if defined(XPMCOMM) || defined(XGRTRACE)
#define XCONNECTPM
#endif

#if defined(XTESTF) || defined(XOPERRORF) || defined(XEOUTPUT) || defined(XECREATE) || defined(XEDECISION) || defined(XEEXPORT) || defined(XEVIEW) || defined(XEUNION) || defined(XEOPTIONAL) || defined(XCHOICE) || defined(XMONITOR) || defined(XTRACE) || defined(XCONNECTPM)
#define XREADANDWRITEF
#endif

#if defined(XMONITOR) || defined(XSIGLOG)
#define XNRINST
#define XSIGPATH
#endif

#if defined(XMONITOR) || defined(XSIGLOG) || defined(XPMCOMM) || defined(XREADANDWRITEF)
#define XIDNAMES
#endif

#ifdef XMONITOR
#define XPRSSENDER
#define XCOUNTRESETS
#define XREMOVETIMERSIG
#ifndef XENVSIGNALLIMIT
#define XENVSIGNALLIMIT 20
#endif
#define XCASELABELS
#endif
#define XCASEAFTERPRDLABELS

#if defined(XMONITOR) || defined(XGRTRACE)
#define XBREAKBEFORE
#endif

#if defined(XSIGPRSPRIO) || defined(XPRSSIGPRIO)
#ifdef XSIGPRIO
#undef XSIGPRIO
#endif
#ifdef XPRSPRIO
#undef XPRSPRIO
#endif
#endif

#ifdef XCALENDARCLOCK
#ifndef XCLOCK
#define XCLOCK
#endif
#endif

#if ! ( defined(XOPTSIGPARA) && defined(XOPTDCL) && defined(XOPTFPAR) && defined(XOPTSTRUCT) && defined(XOPTLIT) && defined(XNOUSEOFEXPORT) )
#ifdef XOPTSORT
  ERROR ILLEGAL_COMBINATION_OF_DEFINES
#endif
#endif

#if defined(XSIGPRSPRIO) && defined(XPRSSIGPRIO)
  ERROR ILLEGAL_COMBINATION_OF_DEFINES__XSIGPRSPRIO_XPRSSIGPRIO
#endif

#if defined(XSIGPRIO) && defined(XPRSPRIO)
  ERROR ILLEGAL_COMBINATION_OF_DEFINES__XSIGPRIO_XPRSPRIO
#endif

#if defined(XCOVERAGE) && !defined(XMONITOR)
  ERROR ILLEGAL_COMBINATION_OF_DEFINES__XCOVERAGE_!XMONITOR
#endif

#ifndef XINPUTREFTYPE
#define XINPUTREFTYPE  int
#endif

#define XALLOC(SIZE,SORTIDNODE) xAlloc(SIZE)
#define XFREE(P,SIZE) xFree(P,SIZE)
#define XFREE_REF_VAL(P,SIZE) xSysFree(P,SIZE)
#define XALLOC_REF_VAL(SIZE,REF_SORT) xSysMalloc2(SIZE,REF_SORT)

/****+***************************************************************
03   C Library
********************************************************************/

#define XINPUTACTION xInputAction

/*---+---------------------------------------------------------------
     SUN4_1_1CC and SUN4_1_1GCC
-------------------------------------------------------------------*/
#if defined(SUN4_1_1CC) || defined(SUN4_1_1GCC)

#ifdef SUN
#undef SUN
#endif

#include <sys/param.h>

#ifdef SUN4_1_1CC
#define XPP(x)  ()
#define XNOPROTO
#define XCAT(P1,P2)     P1/**/P2
#else
#define XPP(x)  x
#define XCAT(P1,P2)     P1##P2
#endif

#define xptrint unsigned
#define xint32 long int

#ifdef SUN4_1_1CC
extern  char * memcpy  XPP((char *s1, char *s2, int size));
extern  char * memset  XPP((char *s, int c, int size));
extern  int    strlen  XPP((char *s));
extern  int    strcmp  XPP((char *s1, char *s2));
extern  int    strcasecmp  XPP((char *s1, char *s2));
extern  int    strncasecmp  XPP((char *s1, char *s2, int i));
extern  char * strcpy  XPP((char *s1, char *s2));
extern  int    strncpy XPP((char *s1, char *s2, int n));
extern  char * strcat  XPP((char *s1, char *s2));
extern  char * strchr  XPP((char *s, int c));
extern  char * strdup  XPP((char *s1));
#ifdef XREADANDWRITEF
extern  char * strncat XPP((char *s1, char *s2, int n));
#endif
extern  char * calloc  XPP((unsigned nelem, unsigned elsize));
extern  int    free    XPP((void * ptr));
extern  void   exit    XPP((int status));
extern  char * getenv  XPP((char *name));
#endif /* SUN4_1_1CC */

#ifdef SUN4_1_1GCC
#include <stdlib.h>
#include <string.h>

extern  int    strcasecmp  (char *s1, char *s2);
extern  int    strncasecmp (char *s1, char *s2, int i);

/* Declarations consistent with ansiprot.h */

extern void *memset(
  void *s,
  int c,
  int n
);

#endif


#ifdef SUN4_1_1CC
#define XNO_STDARG_H
#include <varargs.h>
#else
#include <stdarg.h>
#endif

#define XPQ(x)

#ifdef XREADANDWRITEF
#include <stdio.h>  /* Need definition of FILE and EOF */
extern  int    fputc   XPP((int c, FILE *stream));
extern  int    fgetc   XPP((FILE *stream));
extern  int    ungetc  XPP((int c, FILE *stream));
extern  int    printf  XPP((char *format, ...));
/* extern  char * sprintf XPP((char *s, char *format, ...)); */
extern  int    fprintf XPP((FILE *stream, const char *format, ...));
extern  int    sscanf  XPP((char *s, char *format, ...));
extern  int    fscanf  XPP((FILE *stream, const char *format, ...));
extern  FILE * fopen   XPP((const char *filename, const char *type));
extern  int    fclose  XPP((FILE *stream));

/* Conflict between stdio.h and extern declaration of sprintf */
#endif

#ifdef XCLOCK
#include <time.h>    /* includes <sys/stdtypes.h> where time_t is defined */
extern time_t time  XPP((time_t * tloc));
#endif

#if defined(XMONITOR) && !defined(XNOOSSIGNALS)
#include <signal.h>
#endif

#if defined(XPMCOMM) && !defined(XENV)
extern int getpid XPP((void));
#endif

#if defined(XMONITOR) && !defined(XNOSELECT)
#include <sys/types.h>
#include <sys/time.h>
typedef fd_set xfd_set;
#define xconst
extern int select
    XPP((int width,
         xfd_set *readfds, xfd_set *writefds, xfd_set *exceptfds,
         xconst struct timeval *timeout));
#endif

#endif

/*---+---------------------------------------------------------------
     SUN_CXX
-------------------------------------------------------------------*/
#ifdef SUN_CXX

#ifdef SUN
#undef SUN
#endif

#define XPP(x)  x
#define XCAT(P1,P2)     P1##P2

#define xptrint unsigned
#define xint32 long int
#define xconst const

#include <string.h>
#include <stdlib.h>
#include <stdarg.h>
#define XPQ(x)

#ifdef XREADANDWRITEF
#include <stdio.h>
#ifndef NO_MULTIBYTE_SUPPORT
#include <locale.h>
#endif
#endif

#ifdef XCLOCK
#include <time.h>
#endif

#if defined(XMONITOR) && !defined(XNOOSSIGNALS)
#include <signal.h>
#endif

#if defined(XPMCOMM) && !defined(XENV)
#include <unistd.h>
    /* for getpid() */
#endif

#if defined(XMONITOR) && !defined(XNOSELECT)
#include <sys/types.h>
#include <sys/time.h>
typedef fd_set xfd_set;
#endif

#endif

/*---+---------------------------------------------------------------
     SUN4_ANSICC
-------------------------------------------------------------------*/

#if defined(SUN4_ANSICC)

#ifdef SUN
#undef SUN
#endif

#include <sys/param.h>

#define XPP(x)  x
#define XCAT(P1,P2)     P1##P2

#define xptrint unsigned
#define xint32 long int
#define xconst

#include <string.h>
#include <stdlib.h>
#include <stdarg.h>

extern  char * strdup  XPP((xconst char *s1));
extern  int    strcasecmp  XPP((xconst char *s1, xconst char *s2));
extern  int    strncasecmp  XPP((xconst char *s1, xconst char *s2, int i));

#define XPQ(x)

#ifdef XREADANDWRITEF
#include <stdio.h>  /* Need definition of FILE and EOF */
#ifndef NO_MULTIBYTE_SUPPORT
#include <locale.h>
#endif
#endif

#ifdef XCLOCK
#include <time.h>    /* includes <sys/stdtypes.h> where time_t is defined */
extern time_t time  XPP((time_t * tloc));
#endif

#if defined(XMONITOR) && !defined(XNOOSSIGNALS)
#include <signal.h>
#endif

#if defined(XPMCOMM) && !defined(XENV)
extern int getpid XPP((void));
#endif

#if defined(XMONITOR) && !defined(XNOSELECT)
#include <sys/types.h>
#include <sys/time.h>
typedef fd_set xfd_set;
extern int select
    XPP((int width,
         xfd_set *readfds, xfd_set *writefds, xfd_set *exceptfds,
         xconst struct timeval *timeout));
#endif

#endif

/*---+---------------------------------------------------------------
     SUN5_ANSICC
-------------------------------------------------------------------*/
#if defined(SUN5_ANSICC)

#ifdef SUN
#undef SUN
#endif

#define XPP(x)  x
#define XCAT(P1,P2)     P1##P2

#define xptrint unsigned
#define xint32 long int
#define xconst const

#include <string.h>
#include <stdlib.h>
#include <stdarg.h>

extern  char * strdup  XPP((xconst char *s1));
extern  int    strcasecmp  XPP((xconst char *s1, xconst char *s2));
extern  int    strncasecmp  XPP((xconst char *s1, xconst char *s2, int i));

#define XPQ(x)

#ifdef XREADANDWRITEF
#include <stdio.h>  /* Need definition of FILE and EOF */
#ifndef NO_MULTIBYTE_SUPPORT
#include <locale.h>
#endif
#endif

#ifdef XCLOCK
#include <time.h>    /* includes <sys/stdtypes.h> where time_t is defined */
extern time_t time  XPP((time_t * tloc));
#endif

#if defined(XMONITOR) && !defined(XNOOSSIGNALS)
#include <signal.h>
#endif

#if defined(XPMCOMM) && !defined(XENV)
extern int getpid XPP((void));
#endif

#if defined(XMONITOR) && !defined(XNOSELECT)
#include <sys/select.h>
typedef fd_set xfd_set;
#endif

#endif

/*---+---------------------------------------------------------------
     SUN5_CC
-------------------------------------------------------------------*/
#if defined(SUN5_CC)

#ifdef SUN
#undef SUN
#endif

#define XPP(x)  ()
#define XNOPROTO
#define XCAT(P1,P2)     P1/**/P2

#define xptrint unsigned
#define xint32 long int
#define xconst

#include <string.h>
#include <stdlib.h>

#define XNO_STDARG_H
#include <varargs.h>

extern  char * strdup  XPP((xconst char *s1));
extern  int    strcasecmp  XPP((xconst char *s1, xconst char *s2));
extern  int    strncasecmp  XPP((xconst char *s1, xconst char *s2, int i));

#define XPQ(x)

#ifdef XREADANDWRITEF
#include <stdio.h>  /* Need definition of FILE and EOF */
#ifndef NO_MULTIBYTE_SUPPORT
#include <locale.h>
#endif
#endif

#ifdef XCLOCK
#include <time.h>    /* includes <sys/stdtypes.h> where time_t is defined */
extern time_t time  XPP((time_t * tloc));
#endif

#if defined(XMONITOR) && !defined(XNOOSSIGNALS)
#include <signal.h>
#endif

#if defined(XPMCOMM) && !defined(XENV)
extern int getpid XPP((void));
#endif

#if defined(XMONITOR) && !defined(XNOSELECT)
#include <sys/select.h>
typedef fd_set xfd_set;
#endif

#endif

/*---+---------------------------------------------------------------
     SUN5_GCC - GNU compiler
-------------------------------------------------------------------*/
#if defined(SUN5_GCC)

#ifdef SUN
#undef SUN
#endif

#define XPP(x)  x
#define XCAT(P1,P2)     P1##P2

#define xptrint unsigned
#define xint32 long int
#define xconst const

#include <string.h>
#include <stdlib.h>
#include <stdarg.h>

extern  char * strdup  XPP((xconst char *s1));
extern  int    strcasecmp  XPP((xconst char *s1, xconst char *s2));
#ifdef __STRICT_ANSI__ /* defined by gcc -ansi */
extern  int    strncasecmp  XPP((xconst char *s1, xconst char *s2, int i));
#endif

#define XPQ(x)

#ifdef XREADANDWRITEF
#include <stdio.h>  /* Need definition of FILE and EOF */
#ifndef NO_MULTIBYTE_SUPPORT
#include <locale.h>
#endif
#endif

#ifdef XCLOCK
#include <time.h>    /* includes <sys/stdtypes.h> where time_t is defined */
extern time_t time  XPP((time_t * tloc));
#endif

#if defined(XMONITOR) && !defined(XNOOSSIGNALS)
#include <signal.h>
#endif

#if defined(XPMCOMM) && !defined(XENV)
extern int getpid XPP((void));
#endif

#if defined(XMONITOR) && !defined(XNOSELECT)
#include <sys/select.h>
typedef fd_set xfd_set;
#endif

#endif

/*---+---------------------------------------------------------------
     HPUXANSICC
-------------------------------------------------------------------*/
#ifdef HPUXANSICC

#define _HPUX_SOURCE 1

#define XPP(x)  x
#define XCAT(P1,P2)     P1##P2

#define xptrint unsigned
#define xint32 long int

#include <string.h>
#include <stdlib.h>
#include <stdarg.h>
#define XPQ(x)

#ifdef XREADANDWRITEF
#include <stdio.h>
#ifndef NO_MULTIBYTE_SUPPORT
#include <locale.h>
#endif
#endif

#ifdef XCLOCK
#include <time.h>
#endif

#if defined(XMONITOR) && !defined(XNOOSSIGNALS)
#include <signal.h>
#endif

#if (defined(XMONITOR) && !defined(XNOSELECT)) || (defined(XCLOCK) && !defined(XENV))
#include <sys/types.h>
#include <time.h>
typedef int xfd_set;
#define xconst const
#endif

#endif

/*---+---------------------------------------------------------------
     HPUXCC
-------------------------------------------------------------------*/
#ifdef HPUXCC

#define XNOPROTO
#define XPP(x)  ()
#define XCAT(P1,P2)     P1/**/P2

#define xptrint unsigned
#define xint32 long int

#include <string.h>
#include <stdlib.h>
#define XNO_STDARG_H
#include <varargs.h>

#define XPQ(x)

#ifdef XREADANDWRITEF
#include <stdio.h>
#ifndef NO_MULTIBYTE_SUPPORT
#include <locale.h>
#endif
#endif

#ifdef XCLOCK
#include <time.h>
#endif

#if defined(XMONITOR) && !defined(XNOOSSIGNALS)
#include <signal.h>
#endif

#if (defined(XMONITOR) && !defined(XNOSELECT)) || (defined(XCLOCK) && !defined(XENV))
#include <time.h>
typedef int xfd_set;
#define xconst
extern int select
    XPP((int width,
         xfd_set *readfds, xfd_set *writefds, xfd_set *exceptfds,
         xconst struct timeval *timeout));
  /* select in xCheckForKeyboardInput and xSleepUntil */
#endif

#endif

/*---+---------------------------------------------------------------
     Linux
-------------------------------------------------------------------*/
#ifdef linux

#define XPP(x)  x
#define XCAT(P1,P2)     P1##P2

#define xptrint unsigned
#define xint32 long int

#include <string.h>
#include <stdlib.h>
#include <stdarg.h>
#include <stdio.h>  /* Need definition of FILE */
#define XPQ(x)

#ifdef XREADANDWRITEF
#ifdef NULL
#undef NULL
#endif
#ifndef NO_MULTIBYTE_SUPPORT
#include <locale.h>
#endif
#endif

#ifdef XCLOCK
#include <time.h>
#include <sys/time.h>
#endif

#if defined(XMONITOR) && !defined(XNOOSSIGNALS)
#include <signal.h>
#endif

#if (defined(XMONITOR) && !defined(XNOSELECT)) || (defined(XCLOCK) && !defined(XENV))
#include <sys/types.h>
#include <time.h>
typedef fd_set xfd_set;
#define xconst
#endif

#include <limits.h>
#include <float.h>

#endif

/*---+---------------------------------------------------------------
     ULTRIXCC
-------------------------------------------------------------------*/
#ifdef ULTRIXCC

#define XPP(x)  x
#define XCAT(P1,P2)     P1/**/P2

#define xptrint unsigned
#define xint32 long int

#include <string.h>
#include <stdlib.h>
#include <stdarg.h>
#define XPQ(x)

#ifdef XREADANDWRITEF
#ifdef NULL
#undef NULL
#endif
#include <stdio.h>  /* Need definition of FILE */
#ifndef NO_MULTIBYTE_SUPPORT
#include <locale.h>
#endif
#endif

#ifdef XCLOCK
#include <time.h>
#endif

#if defined(XMONITOR) && !defined(XNOOSSIGNALS)
#include <signal.h>
#endif

#if (defined(XMONITOR) && !defined(XNOSELECT)) || (defined(XCLOCK) && !defined(XENV))
#include <sys/types.h>
#include <time.h>
typedef int xfd_set;
#define xconst
#endif

#include <limits.h>
#include <float.h>

#endif

/*---+---------------------------------------------------------------
     ALPHACC
-------------------------------------------------------------------*/
#ifdef ALPHACC

#define XPP(x)  x
#define XCAT(P1,P2)     P1##P2

#define xptrint unsigned long
    /* if xptrint is long, #define X_XPTRINT_LONG */
#define X_XPTRINT_LONG
#define xint32 int
    /* if xint32 is int, #define X_XINT32_INT */
#define X_XINT32_INT

#include <string.h>
#include <stdlib.h>
#include <stdarg.h>
#define XPQ(x)

#ifdef XREADANDWRITEF
#ifdef NULL
#undef NULL
#endif
#include <stdio.h>  /* Need definition of FILE */
#ifndef NO_MULTIBYTE_SUPPORT
#include <locale.h>
#endif
#endif

#ifdef XCLOCK
#include <time.h>
#include <sys/time.h>
#endif

#if defined(XMONITOR) && !defined(XNOOSSIGNALS)
#include <signal.h>
#endif

#if (defined(XMONITOR) && !defined(XNOSELECT)) || (defined(XCLOCK) && !defined(XENV))
#include <sys/types.h>
#include <time.h>
#include <sys/time.h>
typedef fd_set xfd_set;
#define xconst const
#endif

#include <limits.h>
#include <float.h>

#endif

/*---+---------------------------------------------------------------
     VAXVMSCC
-------------------------------------------------------------------*/
#ifdef VAXVMSCC

#define XPP(x)  x
#define XCAT(P1,P2)     P1##P2

#define xconst

#define xptrint unsigned
#define xint32 long int

/* #include <stddef.h> */
#include <string.h>
#include <stdlib.h>
#include <stdarg.h>
#define XPQ(x)

#ifdef XREADANDWRITEF
#include <stdio.h>
#endif

#ifdef XCLOCK
#include <types.h>
#include <time.h>
#endif

#if defined(XMONITOR) && !defined(XNOOSSIGNALS)
#include <signal.h>
#endif

/* getpid, xCheckForKeyboardInput, xSleepUntil handled in sctOS.c */

#endif

/*---+---------------------------------------------------------------
     AIXV3CC
-------------------------------------------------------------------*/
#ifdef AIXV3CC

#define XPP(x)      x
#define XCAT(P1,P2)     P1##P2
#define xconst const

#define xptrint unsigned
#define xint32 long int

#include <string.h>
#include <stdlib.h>
#include <stdarg.h>
#define XPQ(x)

#ifdef XREADANDWRITEF
#include <stdio.h>
#endif

#ifdef XCLOCK
#include <time.h>
#endif

#if defined(XMONITOR) && !defined(XNOOSSIGNALS)
#include <signal.h>
#endif

#if defined(XPMCOMM) && !defined(XENV)
#include <unistd.h>
#endif

#if (defined(XMONITOR) && !defined(XNOSELECT)) || (defined(XCLOCK) && !defined(XENV))
#include <sys/types.h>
#include <time.h>
#include <sys/time.h>
#include <sys/select.h>
typedef fd_set xfd_set;
#endif

#endif

/*---+---------------------------------------------------------------
     OASYS_CXX
-------------------------------------------------------------------*/
#ifdef OASYS_CXX

#define XPP(x)  x
#define XCAT(P1,P2)     P1##P2

#define xptrint unsigned
#define xint32 long int

#include <string.h>
#include <stdlib.h>
#include <stdarg.h>
#define XPQ(x)

#ifdef XREADANDWRITEF
#include <stdio.h>
#endif

#ifdef XCLOCK
#include <time.h>
#endif

#if defined(XMONITOR) && !defined(XNOOSSIGNALS)
#include <signal.h>
#endif

/* getpid, xCheckForKeyboardInput, xSleepUntil handled in sctOS.c */

#endif


/*---+---------------------------------------------------------------
     IC86
-------------------------------------------------------------------*/
#ifdef IC86

#define XPP(x)  x
#define XCAT(P1,P2)     P1##P2

#define xptrint unsigned long
    /* if xptrint is long, #define X_XPTRINT_LONG */
#define X_XPTRINT_LONG
#define xint32 long int

#include <string.h>
#define strcasecmp stricmp
#define strncasecmp strnicmp
#include <stdlib.h>
#include <stdarg.h>
#define XPQ(x)

#ifdef XREADANDWRITEF
#include <stdio.h>
#ifndef NO_MULTIBYTE_SUPPORT
#include <locale.h>
#endif
#endif

#ifdef XCLOCK
#include <time.h>
#endif

#define XNOOSSIGNALS

#if defined(XPMCOMM) && !defined(XENV)
extern int getpid XPP((void));
#endif

#if defined(XMONITOR) && !defined(XNOSELECT)
#ifndef XCLOCK
#include <time.h>
#endif
#include <conio.h>  /* Need definition of kbhit() */
#endif

#define xconst

#endif


/*---+---------------------------------------------------------------
     MSWINDOWS
-------------------------------------------------------------------*/
#if defined(MSWINDOWS)

#define XPP(x)  x
#define XCAT(P1,P2)     P1##P2

#define xptrint unsigned
#define xint32 int
#define xconst const

#include <string.h>
#define strcasecmp stricmp
#define strncasecmp strnicmp
#include <stdlib.h>
#include <stdarg.h>
#define XPQ(x)

#ifdef XREADANDWRITEF
#include <stdio.h>
#ifndef NO_MULTIBYTE_SUPPORT
#include <locale.h>
#endif
#endif

#include <time.h>

#if defined(XMONITOR) && !defined(XNOOSSIGNALS)
#include <signal.h>
#endif

#if defined(XPMCOMM) && !defined(XENV)
extern int getpid XPP((void));
#endif

#endif

/********************************************************************/

#ifdef XNOPROTO
#define XPP_PROTO(P)
#define XPP_NOPROTO(P)  P
#else
#define XPP_PROTO(P)    P
#define XPP_NOPROTO(P)
#endif


/****+***************************************************************
04   SDL Model macro expansions
********************************************************************/

#define GETINTRAND      1
#define GETINTRAND_MAX  2147483647

#define COMMENT(P)
/* to be used for inserting comments in in-line C-code in SDL.
   the syntax is: COMMENT(( your free format comment text )) */

#define XCONST
#define XCONST_COMP

/* ----------------- Extra components in IdNodes ----------------- */

#define XCOMMON_EXTRAS , 0, 0

  /* System, system type */
#define XSYS_EXTRAS 

  /* Package */
#define XPAC_EXTRAS

  /* Block, Block type */
#define XBLO_EXTRAS

  /* Block substructure */
#define XBLS_EXTRAS

  /* Process, Process type */
#define XPRS_EXTRAS(PRS_NAME) , 0, 0, 0, 0, 0, 0, 0

  /* Service, Service type */
#define XSRV_EXTRAS ,0

  /* Procedure */
#define XPRD_EXTRAS ,0

  /* Signal */
#define XSIG_EXTRAS , 0, (xSignalNode *)NULL, 0, 0

  /* Signal parameter */
#define XSPA_EXTRAS

  /* Variable, formal parameter, struct component */
#define XVAR_EXTRAS , (void **)NULL, 0, 0

  /* Channel, signal route, gate */
#define XCHA_EXTRAS , 0, 0, 0

  /* State */
#define XSTA_EXTRAS

  /* Sort, syntype */
#define XSRT_EXTRAS , (void **)NULL, 0, 0

  /* Literal */
#define XLIT_EXTRAS

  /* Synonym */
#define XSYN_EXTRAS

/* ------------------ Symbol table initialization ------------------ */

#define xSymbTLink(p1,p2) , p1, p2
#define xBreakB(p) , p

#ifndef XTRACHANNELSTOENV
#define XTRACHANNELSTOENV  0
#define XTRACHANNELLIST
#endif

#if defined(XPRSPRIO) || defined(XSIGPRSPRIO) || defined(XPRSSIGPRIO)
#define xPrsPrioPar(p)  , p
#else
#define xPrsPrioPar(p)
#endif

#if defined(XSIGPRIO) || defined(XSIGPRSPRIO) || defined(XPRSSIGPRIO)
#define xSigPrioPar(p)  , p
#else
#define xSigPrioPar(p)
#endif

#define xTestF(p)  , p
#define xRaWF(p)  , p
#define xFreF(p)  , p
#define xFreS(p)

#define xAssF(p)
#define xEqF(p)

#define xIdNames(p)  , p
#define xOptChan(p), p
#define xOptChanZ(p) p
#define xGRTrace(p)  , p
#define xMSCETrace(p)  , p
#define xTrace(p)  , p
#define xCoverage(p)  , p
#define xNrInst(p)  , p
#define xeView(p)  p,
#define xCTrace(p)

#ifndef XNOUSEOFSERVICE
#define xService(p)  , p
#else
#define xService(p)
#endif

#define xThreadName(p)

/* ------------------ Variables at system level ------------------ */

#define XSYSTEMVARS
#define XSYSTEMVARS_H

/* ---------------- Variables in the PAD function ---------------- */

#ifndef ULTRIXCC
#define XPAD_STRUCT_COMP  void (*RestartPAD) XPP((xPrsNode  VarP, int ndstate));
#else
#define XPAD_STRUCT_COMP  void (*RestartPAD) ();
#endif

#ifndef XNOUSEOFSERVICE
#define XSERVICE_COMP   xSrvNode ActiveSrv; xSrvNode SrvList;
#else
#define XSERVICE_COMP
#endif

#define PROCESS_VARS \
   xPrsNode       Pre; \
   xPrsNode       Suc; \
   int            RestartAddress; \
   xPrdNode       ActivePrd; \
   XPAD_STRUCT_COMP \
   XSERVICE_COMP \
   xPrsNode       NextPrs; \
   SDL_PId        Self; \
   xPrsIdNode     NameNode; \
   int            State; \
   xSignalNode    Signal; \
   xInputPortRec  InputPort; \
   SDL_PId        Parent; \
   SDL_PId        Offspring; \
   int            BlockInstNumber; \
   XSIGTYPE       pREPLY_Waited_For; \
   xSignalNode    pREPLY_Signal; \
   SDL_PId  Sender; \
   int Trace_Default; \
   int GRTrace; \
   int  MSCETrace; \
   xbool InTransition; \
   int          NoOfReferences; \
   int          GlobalInstanceId; \
   int          StateBeforeRPC; \
   int          MSCInstance; /* Index in xMSCInstances of the MSC */ \
                             /* instances that corresponds to this */ \
                             /* process */

#define SERVICE_VARS \
   xSrvNode       NextSrv; \
   xPrsNode       ContainerPrs; \
   int            RestartAddress; \
   xPrdNode       ActivePrd; \
   XPAD_STRUCT_COMP \
   xSrvIdNode     NameNode; \
   int            State; \
   XSIGTYPE       pREPLY_Waited_For; \
   xSignalNode    pREPLY_Signal; \
   xbool          InTransition; \
   int            StateBeforeRPC;

#ifndef ULTRIXCC
#define XPRD_STRUCT_COMP  int (*RestartPRD) XPP((xPrsNode  VarP, int ndstate));
#else
#define XPRD_STRUCT_COMP  int (*RestartPRD) ();
#endif

#define PROCEDURE_VARS \
   xPrdIdNode   NameNode; \
   xPrdNode     StaticFather; \
   xPrdNode     DynamicFather; \
   int          RestartAddress; \
   XPRD_STRUCT_COMP \
   xSignalNode  pREPLY_Signal; \
   int          State;

#define YPAD_TEMP_VARS \
   xSignalNode  yOutputSignal; \
   xPrdNode     yTempPrd;
#define YPRD_TEMP_VARS \
   xSignalNode  yOutputSignal; \
   xPrdNode     yTempPrd;
#define YPAD_YSVARP             void  *ySVarP = VarP->Signal;
#define YPAD_YVARP(VDEF_TYPE) \
   register VDEF_TYPE * yVarP = (VDEF_TYPE *)VarP;
#define YGLOBALSRV_YVARP \
   xPrsNode yVarP = (xPrsNode)VarP;
#define YPRD_YVARP(VDEF_TYPE) \
   register VDEF_TYPE * yVarP = (VDEF_TYPE *)VarP;
#define YGLOBALPRD_YVARP \
   xPrsNode yVarP = (xPrsNode)VarP;

#define SDL_SELF                yVarP->Self
#define SDL_PARENT              yVarP->Parent
#define SDL_OFFSPRING           yVarP->Offspring
#define SDL_SENDER              yVarP->Sender
#define XPRSNODE                xPrsNode
#define XNAMENODE               yVarP->NameNode
#define XNAMENODE_SRV           ySrvVarP->NameNode
#define XNAMENODE_PRD           yPrdVarP->NameNode

/* ------------------ Structure of PAD function ------------------ */

#define YPAD_PROTOTYPE(PAD)     extern void PAD (xPrsNode  VarP, int ndstate);
#define YPAD_FUNCTION(PAD)      extern void PAD (xPrsNode  VarP, int ndstate)
#define YPRD_PROTOTYPE(PAD)     extern int PAD (xPrsNode  VarP, int ndstate);
#define YPRD_FUNCTION(PAD)      extern int PAD (xPrsNode  VarP, int ndstate)

#define BEGIN_PAD(VDEF_TYPE)
#define LOOP_LABEL
#define LOOP_LABEL_SERVICEDECOMP
#define LOOP_LABEL_PRD
#define LOOP_LABEL_PRD_NOSTATE
#define BEGIN_START_TRANSITION(STARTUP_PAR_TYPE)

#define XEND_PRD return 0;

#define SIGNAL_NAME(SIG_NAME, SIG_IDNODE) \
   SIG_IDNODE
#define XNONE_SIGNAL \
   xNoneSigId
#define XRPC_WAIT_STATE \
   -3
#define ERROR_STATE \
   -2
#define ASTERISK_STATE \
   -1
#define START_STATE \
   0
#define START_STATE_PRD \
   0

#define CHECK_STARTUP_SIGNAL(PROC_NAME, SIG_IDNODE)
#define INSIGNAL_NAME           yVarP->Signal->NameNode
#define SAVE_SIGNAL(SIG_NAME, SIG_IDNODE, SIG_NAME_STRING)
#define ENABL_COND(EXPR)
#define DISCARD_OTHER_SIGNALS
#define CALL_SUPER_PAD(PAD)
#define CALL_SUPER_PAD_START(PAD) \
   yVarP->RestartPAD = PAD; \
   PAD(VarP,ndstate); \
   return;
#define CALL_SUPER_PRD(PRD)
#define CALL_SUPER_SRV_START(PAD) \
   yVarP->ActiveSrv->RestartPAD = PAD; \
   PAD(VarP,ndstate); \
   return;
#define CALL_SUPER_PRD_START(PRD, THISPRD) \
   yPrdVarP->RestartPRD = PRD; \
   return PRD(VarP,ndstate);

#define CALL_SERVICE \
   if (yVarP->ActiveSrv != (xSrvNode)0) { \
     (*yVarP->ActiveSrv->RestartPAD)(VarP,ndstate); \
     return; \
   }

#define START_SERVICES \
   xStart_Services((xPrsNode)yVarP);



/* --------------------- Transition functions -------------------- */
#define XPTFUNC(PROC_NAME)      static void PROC_NAME (xPrsNode VarP, int ndstate)
#define XPTCALL(PROC_NAME)      PROC_NAME (VarP, ndstate); return;



/* ------------------------ yInit function ----------------------- */
/* Variables and function used to describe the static structure of
   the SDL system */

#define YINIT_TEMP_VARS
#define BEGIN_YINIT

#define XPROCESSDEF_C(PROC_NAME, PROC_NAME_STRING, PREFIX_PROC_NAME, PAD_FUNCTION, VDEF_TYPE)
#define XPROCESSDEF_H(PROC_NAME, PROC_NAME_STRING, PREFIX_PROC_NAME, PAD_FUNCTION, VDEF_TYPE)

#define XSIGTYPE xSignalIdNode
#define xSigCode(P)
#define SIGCODE(P)

#define XCREATE_ENV_PROCESS 

/* ------------------ Actions within transitions ----------------- */


/* ---------------------------- Output --------------------------- */

#define SIGNAL_VARS \
   xSignalNode   Pre; \
   xSignalNode   Suc; \
   int           Prio; \
   SDL_PId       Receiver; \
   SDL_PId       Sender; \
   xSignalIdNode NameNode; \
   xptrint       MSCId; /* The id of the corresponding MSC Event  */ \
                        /* Used during MSC verification to handle */ \
                        /* message overtaking                     */ \
   int          GlobalInstanceId; /* Id in MSC trace */ \
   int          NoOfReferences; \
   xChannelIdNode EnvChannel; /* Used if env split into channels in MSC trace */

#define XSIGNALHEADERTYPE xSignalRec

#define ALLOC_SIGNAL(SIG_NAME, SIG_IDNODE, RECEIVER, SIG_PAR_SIZE) \
   yOutputSignal = xGetSignal(SIG_IDNODE, xNotDefPId, SDL_SELF);
#define ALLOC_SIGNAL_PAR(SIG_NAME, SIG_IDNODE, RECEIVER, SIG_PAR_TYPE) \
   yOutputSignal = xGetSignal(SIG_IDNODE, xNotDefPId, SDL_SELF);
#define TRANSFER_SIGNAL(SIG_NAME, SIG_IDNODE, RECEIVER, SIG_PAR_TYPE) \
   if (SIG_IDNODE == INSIGNAL_NAME) { \
     yOutputSignal = xGetSignal(SIG_IDNODE, xNotDefPId, yVarP->Signal->Sender); \
   } else { \
     xSDLOutputError(5, yVarP->Signal, 0); \
     yOutputSignal = xGetSignal(SIG_IDNODE, xNotDefPId, SDL_SELF); \
   }
#define TRANSFER_SIGNAL_PAR(SIG_NAME, SIG_IDNODE, RECEIVER, SIG_PAR_TYPE) \
   if (SIG_IDNODE == INSIGNAL_NAME) { \
     yOutputSignal = xGetSignal(SIG_IDNODE, xNotDefPId, yVarP->Signal->Sender); \
     memcpy(yOutputSignal, ySVarP, SIG_IDNODE->VarSize); \
     yOutputSignal->Receiver = RECEIVER; \
   } else { \
     xSDLOutputError(5, yVarP->Signal, 0); \
     yOutputSignal = xGetSignal(SIG_IDNODE, xNotDefPId, SDL_SELF); \
   }

#define SIGNAL_ALLOC_ERROR
#define SIGNAL_ALLOC_ERROR_END
#define OUTSIGNAL_DATA_PTR \
   yOutputSignal

#if defined(XSIGPRIO) || defined(XSIGPRSPRIO) || defined(XPRSSIGPRIO)

#define SDL_2OUTPUT(PRIO, VIA, SIG_NAME, SIG_IDNODE, RECEIVER, SIG_PAR_SIZE, SIG_NAME_STRING) \
   OUTSIGNAL_DATA_PTR->Receiver = RECEIVER; \
   SDL_Output(OUTSIGNAL_DATA_PTR, PRIO, VIA);

#define SDL_2OUTPUT_NO_TO(PRIO, VIA, SIG_NAME, SIG_IDNODE, RECEIVER, SIG_PAR_SIZE, SIG_NAME_STRING) \
   SDL_Output(OUTSIGNAL_DATA_PTR, PRIO, VIA);

#define SDL_2OUTPUT_COMPUTED_TO(PRIO, VIA, SIG_NAME, SIG_IDNODE, RECEIVER, SIG_PAR_SIZE, SIG_NAME_STRING) \
   SDL_Output(OUTSIGNAL_DATA_PTR, PRIO, VIA);

#define SDL_ALT2OUTPUT(PRIO, VIA, SIG_NAME, SIG_IDNODE, RECEIVER, SIG_PAR_SIZE, SIG_NAME_STRING) \
   OUTSIGNAL_DATA_PTR->Receiver = RECEIVER; \
   SDL_Output(OUTSIGNAL_DATA_PTR, PRIO, VIA);

#define SDL_ALT2OUTPUT_NO_TO(PRIO, VIA, SIG_NAME, SIG_IDNODE, RECEIVER, SIG_PAR_SIZE, SIG_NAME_STRING) \
   SDL_Output(OUTSIGNAL_DATA_PTR, PRIO, VIA);

#define SDL_ALT2OUTPUT_COMPUTED_TO(PRIO, VIA, SIG_NAME, SIG_IDNODE, RECEIVER, SIG_PAR_SIZE, SIG_NAME_STRING) \
   SDL_Output(OUTSIGNAL_DATA_PTR, PRIO, VIA);

#else

#define SDL_2OUTPUT(PRIO, VIA, SIG_NAME, SIG_IDNODE, RECEIVER, SIG_PAR_SIZE, SIG_NAME_STRING) \
   OUTSIGNAL_DATA_PTR->Receiver = RECEIVER; \
   SDL_Output(OUTSIGNAL_DATA_PTR, VIA);

#define SDL_2OUTPUT_NO_TO(PRIO, VIA, SIG_NAME, SIG_IDNODE, RECEIVER, SIG_PAR_SIZE, SIG_NAME_STRING) \
   SDL_Output(OUTSIGNAL_DATA_PTR, VIA);

#define SDL_2OUTPUT_COMPUTED_TO(PRIO, VIA, SIG_NAME, SIG_IDNODE, RECEIVER, SIG_PAR_SIZE, SIG_NAME_STRING) \
   SDL_Output(OUTSIGNAL_DATA_PTR, VIA);

#define SDL_ALT2OUTPUT(PRIO, VIA, SIG_NAME, SIG_IDNODE, RECEIVER, SIG_PAR_SIZE, SIG_NAME_STRING) \
   OUTSIGNAL_DATA_PTR->Receiver = RECEIVER; \
   SDL_Output(OUTSIGNAL_DATA_PTR, VIA);

#define SDL_ALT2OUTPUT_NO_TO(PRIO, VIA, SIG_NAME, SIG_IDNODE, RECEIVER, SIG_PAR_SIZE, SIG_NAME_STRING) \
   SDL_Output(OUTSIGNAL_DATA_PTR, VIA);

#define SDL_ALT2OUTPUT_COMPUTED_TO(PRIO, VIA, SIG_NAME, SIG_IDNODE, RECEIVER, SIG_PAR_SIZE, SIG_NAME_STRING) \
   SDL_Output(OUTSIGNAL_DATA_PTR, VIA);

#endif


#define SDL_THIS                yVarP->Self

#define TO_PROCESS(PROC_NAME, PROC_IDNODE) \
  xFindToReceiver(PROC_IDNODE,(xPrsNode)yVarP, yOutputSignal)
   


/* ----------------------------- RPC ----------------------------- */

/* Output of pCALL signal */
#if defined(XSIGPRIO) || defined(XSIGPRSPRIO) || defined(XPRSSIGPRIO)
#define SDL_2OUTPUT_RPC_CALL(PRIO, VIA, SIG_NAME, SIG_IDNODE, RECEIVER, SIG_PAR_SIZE, SIG_NAME_STRING) \
   yOutputSignal->Receiver = RECEIVER; \
   SDL_Output(OUTSIGNAL_DATA_PTR, PRIO, VIA);
#else
#define SDL_2OUTPUT_RPC_CALL(PRIO, VIA, SIG_NAME, SIG_IDNODE, RECEIVER, SIG_PAR_SIZE, SIG_NAME_STRING) \
   yOutputSignal->Receiver = RECEIVER; \
   SDL_Output(OUTSIGNAL_DATA_PTR, VIA);
#endif

/* Input of pREPLY signal */
#ifndef XNOUSEOFSERVICE
#define XRPC_REPLY_INPUT \
   if (yVarP->ActiveSrv != (xSrvNode)0) \
     yVarP->ActiveSrv->State=yVarP->ActiveSrv->StateBeforeRPC; \
   else \
     yVarP->State=yVarP->StateBeforeRPC;
#define XRPC_REPLY_INPUT_PRD \
   if (yVarP->ActiveSrv != (xSrvNode)0) \
     yPrdVarP->State=yVarP->ActiveSrv->StateBeforeRPC; \
   else \
     yPrdVarP->State=yVarP->StateBeforeRPC;
#else
#define XRPC_REPLY_INPUT \
   yVarP->State=yVarP->StateBeforeRPC;
#define XRPC_REPLY_INPUT_PRD \
   yPrdVarP->State=yVarP->StateBeforeRPC;
#endif

/* Output of pREPLY signal */
#define XRPC_SAVE_SENDER
#define XRPC_SENDER_IN_ALLOC       yVarP->Signal->Sender
#define XRPC_SENDER_IN_OUTPUT      Not_Used
#define XRPC_SAVE_SENDER_PRD
#define XRPC_SENDER_IN_ALLOC_PRD   yVarP->Signal->Sender
#define XRPC_SENDER_IN_OUTPUT_PRD  Not_Used

#define ALLOC_REPLY_SIGNAL(SIG_NAME, SIG_IDNODE, RECEIVER, SIG_PAR_TYPE) \
   REPLYSIGNAL_DATA_PTR = xGetSignal(SIG_IDNODE, RECEIVER, SDL_SELF);
#define ALLOC_REPLY_SIGNAL_PAR(SIG_NAME, SIG_IDNODE, RECEIVER, SIG_PAR_TYPE) \
   REPLYSIGNAL_DATA_PTR = xGetSignal(SIG_IDNODE, RECEIVER, SDL_SELF);
#define ALLOC_REPLY_SIGNAL_PRD(SIG_NAME, SIG_IDNODE, RECEIVER, SIG_PAR_TYPE) \
   REPLYSIGNAL_DATA_PTR_PRD = xGetSignal(SIG_IDNODE, RECEIVER, SDL_SELF);
#define ALLOC_REPLY_SIGNAL_PRD_PAR(SIG_NAME, SIG_IDNODE, RECEIVER, SIG_PAR_TYPE) \
   REPLYSIGNAL_DATA_PTR_PRD = xGetSignal(SIG_IDNODE, RECEIVER, SDL_SELF);

#define REPLYSIGNAL_DATA_PTR \
   yVarP->pREPLY_Signal
#define REPLYSIGNAL_DATA_PTR_PRD \
   yPrdVarP->pREPLY_Signal

#if defined(XSIGPRIO) || defined(XSIGPRSPRIO) || defined(XPRSSIGPRIO)
#define SDL_2OUTPUT_RPC_REPLY(PRIO, VIA, SIG_NAME, SIG_IDNODE, RECEIVER, SIG_PAR_SIZE, SIG_NAME_STRING) \
   SDL_Output(REPLYSIGNAL_DATA_PTR, PRIO, VIA); \
   REPLYSIGNAL_DATA_PTR = NULL;
#define SDL_2OUTPUT_RPC_REPLY_PRD(PRIO, VIA, SIG_NAME, SIG_IDNODE, RECEIVER, SIG_PAR_SIZE, SIG_NAME_STRING) \
   SDL_Output(REPLYSIGNAL_DATA_PTR_PRD, PRIO, VIA); \
   REPLYSIGNAL_DATA_PTR_PRD = NULL;
#else
#define SDL_2OUTPUT_RPC_REPLY(PRIO, VIA, SIG_NAME, SIG_IDNODE, RECEIVER, SIG_PAR_SIZE, SIG_NAME_STRING) \
   SDL_Output(REPLYSIGNAL_DATA_PTR, VIA); \
   REPLYSIGNAL_DATA_PTR = NULL;
#define SDL_2OUTPUT_RPC_REPLY_PRD(PRIO, VIA, SIG_NAME, SIG_IDNODE, RECEIVER, SIG_PAR_SIZE, SIG_NAME_STRING) \
   SDL_Output(REPLYSIGNAL_DATA_PTR_PRD, VIA); \
   REPLYSIGNAL_DATA_PTR_PRD = NULL;
#endif

#define XGETEXPORTINGPRS(REMOTENODE) \
   xGetExportingPrs(REMOTENODE, VarP)

#define SDL_RPCWAIT_NEXTSTATE(PREPLY_IDNODE, PREPLY_NAME, RESTARTADDR) \
   SDL_RPC_WaitState(VarP, RESTARTADDR, PREPLY_IDNODE); \
   return;

#define SDL_RPCWAIT_NEXTSTATE_PRD(PREPLY_IDNODE, PREPLY_NAME, RESTARTADDR) \
   SDL_RPC_WaitState(VarP, RESTARTADDR, PREPLY_IDNODE); \
   return 1;

#define SDL_RPCWAIT_NEXTSTATE_XPT(PREPLY_IDNODE, PREPLY_NAME, RESTARTADDR) \
   SDL_RPC_WaitState(VarP, RESTARTADDR, PREPLY_IDNODE); \
   return;


/* ---------------------------- IMPORT --------------------------- */

#define XGETEXPORTADDR(REMOTENODE, EXPORTER, IS_DEF_EXPORTER) \
  xGetExportAddr(REMOTENODE, EXPORTER, IS_DEF_EXPORTER, VarP)


/* ---------------------------- Create --------------------------- */

#define STARTUP_VARS

#define ALLOC_STARTUP(PROC_NAME, STARTUP_IDNODE, STARTUP_PAR_TYPE) \
   yOutputSignal = xGetSignal(STARTUP_IDNODE, SDL_NULL, SDL_SELF);
#define ALLOC_STARTUP_PAR(PROC_NAME, STARTUP_IDNODE, STARTUP_PAR_TYPE) \
   yOutputSignal = xGetSignal(STARTUP_IDNODE, SDL_NULL, SDL_SELF);
#define ALLOC_STARTUP_THIS \
   yOutputSignal = xGetSignal((XSIGTYPE) \
               ((xPrsIdNode)yVarP->NameNode)->Super->Suc, SDL_NULL, SDL_SELF);

#define STARTUP_ALLOC_ERROR
#define STARTUP_ALLOC_ERROR_END
#define STARTUP_DATA_PTR \
   yOutputSignal

#define SDL_CREATE(PROC_NAME, PROC_IDNODE, PROC_NAME_STRING) \
   SDL_Create(STARTUP_DATA_PTR, PROC_IDNODE, yVarP->BlockInstNumber);
#define SDL_CREATE_THIS \
   SDL_Create(STARTUP_DATA_PTR, yVarP->NameNode, yVarP->BlockInstNumber);


/* ------------------------- Static Create ------------------------ */

#define INIT_PROCESS_TYPE(PROC_NAME, PREFIX_PROC_NAME, PROC_IDNODE, PROC_NAME_STRING, MAX_NO_OF_INST, STATIC_INST, PRIV_DATA_TYPE, PRIO, PAD_FUNCTION) \
  PROC_IDNODE->StaticInst = STATIC_INST;

#define SDL_STATIC_CREATE(PROC_NAME, PREFIX_PROC_NAME, PROC_IDNODE, PROC_NAME_STRING, STARTUP_IDNODE, STARTUP_PAR_TYPE, PRIV_DATA_TYPE, PRIO, PAD_FUNCTION, BLOCK_INST_NUMBER) \
   SDL_Create(xGetSignal(STARTUP_IDNODE, SDL_NULL, SDL_NULL), PROC_IDNODE, BLOCK_INST_NUMBER);


/* ----------------------------- Stop ---------------------------- */

#define SDL_STOP \
   SDL_Stop(VarP); \
   return;

#define SDL_STOP_XPT \
   SDL_Stop(VarP); \
   return;

#ifdef XFREEVARS
#define FREE_PROCESS_VARS
#endif



/* ---------------------------- Timers --------------------------- */

#define TIMER_VARS \
   SIGNAL_VARS \
   SDL_Time      TimerTime;
/* NOTE!!! TIMER_VARS HAS TO BE IDENTICAL TO SIGNAL_VARS, EXCEPT FOR TimerTime */

#define XTIMERHEADERTYPE xTimerRec


/* Set without parameters */
#define SDL_SET(TIME_EXPR, TIMER_NAME, TIMER_IDNODE, TIMER_VAR, TIMER_NAME_STRING) \
   SDL_Set(TIME_EXPR, xGetSignal(TIMER_IDNODE, SDL_SELF, SDL_SELF));

#define SDL_SET_DUR(TIME_EXPR, DUR_EXPR, TIMER_NAME, TIMER_IDNODE, TIMER_VAR, TIMER_NAME_STRING) \
   SDL_Set(TIME_EXPR, xGetSignal(TIMER_IDNODE, SDL_SELF, SDL_SELF));

#define SDL_SET_TICKS(TIME_EXPR, DUR_EXPR, TIMER_NAME, TIMER_IDNODE, TIMER_VAR, TIMER_NAME_STRING) \
   SDL_Set(TIME_EXPR, xGetSignal(TIMER_IDNODE, SDL_SELF, SDL_SELF));

/* Set with parameters */
#define ALLOC_TIMER_SIGNAL_PAR(TIMER_NAME, TIMER_IDNODE, TIMER_PAR_TYPE) \
   yOutputSignal = xGetSignal(TIMER_IDNODE, SDL_SELF, SDL_SELF);
#define TIMER_SIGNAL_ALLOC_ERROR
#define TIMER_SIGNAL_ALLOC_ERROR_END
#define TIMER_DATA_PTR \
   yOutputSignal

#define SDL_SET_WITH_PARA(TIME_EXPR, TIMER_NAME, TIMER_IDNODE, TIMER_PAR_TYPE, EQ_FUNC, TIMER_VAR, TIMER_NAME_STRING) \
   SDL_Set(TIME_EXPR, yOutputSignal);

#define SDL_SET_DUR_WITH_PARA(TIME_EXPR, DUR_EXPR, TIMER_NAME, TIMER_IDNODE, TIMER_PAR_TYPE, EQ_FUNC, TIMER_VAR, TIMER_NAME_STRING) \
   SDL_Set(TIME_EXPR, yOutputSignal);

#define SDL_SET_TICKS_WITH_PARA(TIME_EXPR, DUR_EXPR, TIMER_NAME, TIMER_IDNODE, TIMER_PAR_TYPE, EQ_FUNC, TIMER_VAR, TIMER_NAME_STRING) \
   SDL_Set(TIME_EXPR, yOutputSignal);


/* Reset without parameters */
#define SDL_RESET(TIMER_NAME, TIMER_IDNODE, TIMER_VAR, TIMER_NAME_STRING) \
   SDL_SimpleReset(VarP, TIMER_IDNODE);

/* Reset with parameters */
#define SDL_RESET_WITH_PARA(EQ_FUNC, TIMER_VAR, TIMER_NAME_STRING) \
   SDL_Reset(&yOutputSignal);

/* Active (timer active) */
#define SDL_ACTIVE(TIMER_NAME, TIMER_IDNODE, TIMER_VAR) \
   SDL_Active(TIMER_IDNODE, VarP)

#define DEF_TIMER_VAR(NAME)
#define INIT_TIMER_VAR(NAME)
#define RELEASE_TIMER_VAR(NAME)
#define INPUT_TIMER_VAR(NAME)
#define OFFSET_TIMER_VAR(TIMER_VAR,PRS)
#define ZERO_OFFSET
#define TIMER_PARA_VARS TIMER_VARS

#define DEF_TIMER_VAR_PARA(TIMER_VAR)
#define INIT_TIMER_VAR_PARA(TIMER_VAR)
#define INPUT_TIMER_VAR_PARA(TIMER_VAR)
#define RELEASE_TIMER_VAR_PARA(TIMER_VAR)

/* Now */
#define SDL_NOW                  SDL_Now()


/* ------------------------ Procedure call ----------------------- */

#define ALLOC_PROCEDURE(PROC_NAME, PROC_IDNODE, VAR_SIZE) \
   yTempPrd = xGetPrd(PROC_IDNODE);
#define ALLOC_VIRT_PROCEDURE(PROC_IDNODE) \
   yTempPrd = xGetPrd(PROC_IDNODE);
#define ALLOC_THIS_PROCEDURE \
   yTempPrd = xGetPrd(yPrdVarP->NameNode);
#define PROCEDURE_ALLOC_ERROR
#define PROCEDURE_ALLOC_ERROR_END
#define PROC_DATA_PTR \
   yTempPrd

#define CALL_PROCEDURE(PROC_NAME, PROC_IDNODE, LEVELS, RESTARTADDR) \
   xAddPrdCall(yTempPrd, (xPrsNode)yVarP, LEVELS, RESTARTADDR); \
   if ( PROC_NAME (VarP, ndstate) ) return;

#define CALL_PROCEDURE_IN_PRD(PROC_NAME, PROC_IDNODE, LEVELS, RESTARTADDR) \
   xAddPrdCall(yTempPrd, (xPrsNode)yVarP, LEVELS, RESTARTADDR); \
   if ( PROC_NAME (VarP, ndstate) ) return 1;

#define CALL_COMPSTMT_IN_COMPSTMT(PROC_NAME, PROC_IDNODE, LEVELS, RESTARTADDR) \
   { int i; \
     xAddPrdCall(yTempPrd, VarP, LEVELS, RESTARTADDR); \
     i = PROC_NAME(VarP, ndstate); \
     if (i == 1) return 1; \
     if (i < 0) { SDL_BREAK(i+1) } \
   }

#define CALL_PROCEDURE_XPT(PROC_NAME, PROC_IDNODE, LEVELS, RESTARTADDR) \
   xAddPrdCall(yTempPrd, (xPrsNode)yVarP, LEVELS, RESTARTADDR); \
   if ( PROC_NAME (VarP, ndstate) ) return;

#define CALL_VIRT_PROCEDURE(PROC, LEVELS, RESTARTADDR) \
   xAddPrdCall(yTempPrd, (xPrsNode)yVarP, LEVELS, RESTARTADDR); \
   if ( (*PROC->Assoc_Function)(VarP, ndstate) ) return;

#define CALL_VIRT_PROCEDURE_IN_PRD(PROC, LEVELS, RESTARTADDR) \
   xAddPrdCall(yTempPrd, (xPrsNode)yVarP, LEVELS, RESTARTADDR); \
   if ( (*PROC->Assoc_Function)(VarP, ndstate) ) return 1;

#define CALL_VIRT_PROCEDURE_XPT(PROC_IDNODE, LEVELS, RESTARTADDR) \
   xAddPrdCall(yTempPrd, (xPrsNode)yVarP, LEVELS, RESTARTADDR); \
   if ( (*PROC_IDNODE->Assoc_Function)(VarP, ndstate) ) return;

#define CALL_THIS_PROCEDURE(RESTARTADDR) \
   xAddPrdCall(yTempPrd, (xPrsNode)VarP, 1, RESTARTADDR); \
   if ( (*yPrdVarP->NameNode->Assoc_Function)(VarP, ndstate) ) return 1;

#define CALL_PROCEDURE_STARTUP \
  { int i; \
    i = (*yVarP->ActivePrd->RestartPRD)(VarP, ndstate); \
    if (i == 1) return; \
    while (i<0) {xRemovePrdCall(VarP); i++;} \
  }

#define CALL_PROCEDURE_STARTUP_SRV \
  { int i; \
    i = (*ySrvVarP->ActivePrd->RestartPRD)(VarP, ndstate); \
    if (i == 1) return; \
    while (i<0) {xRemovePrdCall(VarP); i++;} \
  }


/* ----------------------- Procedure return ---------------------- */

#define SDL_RETURN \
   xRemovePrdCall((xPrsNode)yVarP); \
   return 0;
#define SDL_BREAK(LEVELS) \
   xRemovePrdCall((xPrsNode)yVarP); \
   return LEVELS;


/* --------------------------- Nextstate ------------------------- */

#define SDL_NEXTSTATE(STATE_NAME, STATE_IDNODE, STATE_NAME_STRING) \
   SDL_NextState(VarP, STATE_IDNODE); \
   return;
#define SDL_DASH_NEXTSTATE \
   SDL_NextState(VarP, yVarP->State); \
   return;
#define SDL_DASH_NEXTSTATE_SRV \
   SDL_NextState(VarP, yVarP->ActiveSrv->State); \
   return;
#define SDL_NEXTSTATE_PRD(STATE_NAME, STATE_IDNODE, STATE_NAME_STRING) \
   SDL_NextState(VarP, STATE_IDNODE); \
   return 1;
#define SDL_NEXTSTATE_XPT(STATE_NAME, STATE_IDNODE, STATE_NAME_STRING) \
   SDL_NextState(VarP, STATE_IDNODE); \
   return;
#define SDL_DASH_NEXTSTATE_XPT \
   SDL_NextState(VarP, yVarP->State); \
   return;

#ifndef XNOUSEOFSERVICE
#define SDL_DASH_NEXTSTATE_PRD \
   SDL_NextState(VarP, (yVarP->ActiveSrv == (xSrvNode)0 \
                        ? yVarP->ActivePrd->State \
                        : yVarP->ActiveSrv->ActivePrd->State) ); \
   return 1;
#else
#define SDL_DASH_NEXTSTATE_PRD \
   SDL_NextState(VarP, yVarP->ActivePrd->State); \
   return 1;
#endif

/* ----------------------------- Join ---------------------------- */
#define XJOIN_XPT(RESTARTADDR) \
   yVarP->RestartAddress = RESTARTADDR; \
   return;

#define XJOIN_SUPER_PRS(RESTARTADDR,RESTARTPAD) \
   yVarP->RestartAddress = RESTARTADDR; \
   yVarP->RestartPAD = RESTARTPAD; \
   RESTARTPAD(VarP, ndstate); \
   return;

#define XJOIN_SUPER_PRD(RESTARTADDR,RESTARTPRD) \
   yPrdVarP->RestartAddress = RESTARTADDR; \
   yPrdVarP->RestartPRD = RESTARTPRD; \
   return RESTARTPRD(VarP, ndstate);

#define XJOIN_SUPER_SRV(RESTARTADDR,RESTARTSRV) \
   yVarP->ActiveSrv->RestartAddress = RESTARTADDR; \
   yVarP->ActiveSrv->RestartPAD = RESTARTSRV; \
   RESTARTSRV(VarP, ndstate); \
   return;

/* --------------------------- Decision -------------------------- */

/* Informal decisions */
#define BEGIN_INFORMAL_DECISION(NO_OF_PATHS, QUESTION) \
   xMoreAlternatives = (ndstate < NO_OF_PATHS);
#define DEF_INFORMAL_PATH(PATH_NO, ANSWER, SYMBOLNUMBER) \
  if (ndstate==PATH_NO) { \
    xTraceInformalDecision( ANSWER ); \
  }
#define DEF_INFORMAL_ELSE_PATH(PATH_NO, SYMBOLNUMBER) \
  if (ndstate==PATH_NO) { \
    xTraceInformalDecision( "Lelse" ); \
  }
#define END_DEFS_INFORMAL_PATH(NO_OF_PATHS) 
#define BEGIN_FIRST_INFORMAL_PATH(PATH_NO) \
   if (ndstate==PATH_NO) {
#define BEGIN_INFORMAL_PATH(PATH_NO) \
   else if (ndstate==PATH_NO) {
#define END_INFORMAL_PATH \
   }
#define BEGIN_INFORMAL_ELSE_PATH(PATH_NO) \
   else if (ndstate==PATH_NO) {
#define END_INFORMAL_ELSE_PATH \
   }
#define END_INFORMAL_DECISION

/* Non-deterministic decisions */
#define BEGIN_ANY_DECISION(NO_OF_PATHS) \
   xMoreAlternatives = (ndstate < NO_OF_PATHS); \
   xTraceNondetDecision( ndstate, NO_OF_PATHS );
#define DEF_ANY_PATH(PATH_NO, SYMBOLNUMBER)
#define END_DEFS_ANY_PATH(NO_OF_PATHS) 
#define BEGIN_FIRST_ANY_PATH(PATH_NO) \
   if (ndstate==PATH_NO) {
#define BEGIN_ANY_PATH(PATH_NO) \
   else if (ndstate==PATH_NO) {
#define END_ANY_PATH \
   }
#define END_ANY_DECISION


/* ----------------------------- View ---------------------------- */

#define SDL_VIEW(PID_EXPR, HAS_EXPR, VAR_NAME_STRING, REVEALED_LIST, SORT_SIZE) \
   SDL_View(REVEALED_LIST, PID_EXPR, HAS_EXPR, VarP, xeView(VAR_NAME_STRING) SORT_SIZE)


/* ------------------------ Execution trace and Debug ---------------------- */

#define YPRSNAME_VAR(PRS_NAME_STRING)
#define YPRDNAME_VAR(PRD_NAME_STRING)
#define XOS_TRACE_INPUT(SIG_NAME_STRING)  \
  yAssF_SDL_PId(yVarP->Sender, ((xSignalNode)ySVarP)->Sender, XASS_MR_ASS_NF);
#define XDEBUG_LABEL(LABEL_NAME)

#ifdef XEUNION
#define XCHECK_UNION_TAG(TAG,VALUE,ASSTAG,NEQTAG,COMPNAME,CURR_VALUE,TYPEINFO) \
   if (NEQTAG(TAG,VALUE)) { \
     xUnionTagError(COMPNAME,xWriteSort((CURR_VALUE),(TYPEINFO)->SortIdNode),(xbool)1); \
     ASSTAG(TAG,VALUE,XASS_MR_ASS_NF); \
   }
#define XCHECK_UNION_TAG_FREE(TAG,VALUE,ASSTAG,NEQTAG,FREEFUNC,COMPNAME,CURR_VALUE,TYPEINFO) \
   if (NEQTAG(TAG,VALUE)) { \
     xUnionTagError(COMPNAME,xWriteSort((CURR_VALUE),(TYPEINFO)->SortIdNode),(xbool)1); \
     FREEFUNC((void **)&(TAG)); \
     ASSTAG(TAG,VALUE,XASS_MR_ASS_NF); \
   }
#define XCHECK_UNION_TAG_USAGE(TAG,VALUE,NEQTAG,COMPNAME,CURR_VALUE,TYPEINFO) \
   if (NEQTAG(TAG,VALUE)) { \
     xUnionTagError(COMPNAME,xWriteSort((CURR_VALUE),(TYPEINFO)->SortIdNode),(xbool)0); \
   }
#else
#define XCHECK_UNION_TAG(TAG,VALUE,ASSTAG,NEQTAG,COMPNAME,CURR_VALUE,TYPEINFO) \
   if (NEQTAG(TAG,VALUE)) { \
     ASSTAG(TAG,VALUE,XASS_MR_ASS_NF); \
   }
#define XCHECK_UNION_TAG_FREE(TAG,VALUE,ASSTAG,NEQTAG,FREEFUNC,COMPNAME,CURR_VALUE,TYPEINFO) \
   if (NEQTAG(TAG,VALUE)) { \
     FREEFUNC((void **)&(TAG)); \
     ASSTAG(TAG,VALUE,XASS_MR_ASS_NF); \
   }
#define XCHECK_UNION_TAG_USAGE(TAG,VALUE,NEQTAG,COMPNAME,CURR_VALUE,TYPEINFO)
#endif

#ifdef XEOPTIONAL
#define XCHECK_OPTIONAL_USAGE(PRESENT_VAR,COMPNAME) \
   if (! PRESENT_VAR) xOptionalError(COMPNAME);
#else
#define XCHECK_OPTIONAL_USAGE(PRESENT_VAR,COMPNAME)
#endif

#define XSET_CHOICE_TAG(TAG,VALUE,ASSTAG,NEQTAG,COMPNAME,CURR_VALUE,TYPEINFO) \
   if (NEQTAG(TAG,VALUE)) { \
     ASSTAG(TAG,VALUE,XASS_MR_ASS_NF); \
   }
#define XSET_CHOICE_TAG_FREE(TAG,VALUE,ASSTAG,NEQTAG,FREEFUNC,COMPNAME,CURR_VALUE,TYPEINFO) \
   if (NEQTAG(TAG,VALUE)) { \
     FREEFUNC((void **)&(TAG)); \
     ASSTAG(TAG,VALUE,XASS_MR_ASS_NF); \
   }
#ifdef XECHOICE
#define XCHECK_CHOICE_USAGE(TAG,VALUE,NEQTAG,COMPNAME,CURR_VALUE,TYPEINFO) \
   if (NEQTAG(TAG,VALUE)) { \
     xChoiceError(COMPNAME,xWriteSort((CURR_VALUE),(TYPEINFO)->SortIdNode)); \
   }
#else
#define XCHECK_CHOICE_USAGE(TAG,VALUE,NEQTAG,COMPNAME,CURR_VALUE,TYPEINFO)
#endif

#ifdef XEOWN
#define XCHECK_OREF(VALUE,REF_SORTIDNODE,REF_SORT) \
   if (VALUE == 0) { \
     VALUE = (REF_SORT)xSysMalloc2((REF_SORTIDNODE)->SortIdNode->CompOrFatherSort->SortSize, \
                                   (REF_SORTIDNODE)->SortIdNode); \
     xRefError((void *)&(VALUE), (REF_SORTIDNODE)->SortIdNode); \
   } else { \
     xCheckRefOwn((void *)(VALUE)); \
   }
#define XCHECK_OREF2(VALUE) \
   if (VALUE != 0) xCheckRefOwn((void *)(VALUE));
#define XCHECK_OWN(VALUE,REF_SORTIDNODE,REF_SORT) \
   if (VALUE == 0) { \
     VALUE = (REF_SORT)xSysMalloc2(REF_SORTIDNODE->CompOrFatherSort->SortSize,REF_SORTIDNODE->SortIdNode); \
     xRefError((void *)&(VALUE), REF_SORTIDNODE); \
   }
#else
#define XCHECK_OREF(VALUE,REF_SORTIDNODE,REF_SORT) \
   if (VALUE == 0) { \
     VALUE = (REF_SORT)xSysMalloc2((REF_SORTIDNODE)->SortIdNode->CompOrFatherSort->SortSize, \
                                   (REF_SORTIDNODE)->SortIdNode); \
     xRefError((void *)&(VALUE), (REF_SORTIDNODE)->SortIdNode); \
   }
#define XCHECK_OREF2(VALUE)
#define XCHECK_OWN(VALUE,REF_SORTIDNODE,REF_SORT) \
   if (VALUE == 0) { \
     VALUE = (REF_SORT)xSysMalloc2((REF_SORTIDNODE)->SortIdNode->CompOrFatherSort->SortSize, \
                                   (REF_SORTIDNODE)->SortIdNode); \
     xRefError((void *)&(VALUE), (REF_SORTIDNODE)->SortIdNode); \
   }
#endif

#ifdef XEREF
#define XCHECK_REF(VALUE,REF_SORTIDNODE,REF_SORT) \
   if (VALUE == 0) { \
     VALUE = (REF_SORT)xSysMalloc2((REF_SORTIDNODE)->SortIdNode->CompOrFatherSort->SortSize, \
                                   (REF_SORTIDNODE)->SortIdNode); \
     xRefError((void *)&(VALUE), (REF_SORTIDNODE)->SortIdNode); \
   }
#else
#define XCHECK_REF(VALUE,SORTIDNODE,REF_SORT)
#endif

/* -------------------------- Simulation ------------------------- */

#define XAT_FIRST_SYMBOL(SYMB_NO) \
   xGRSetSymbol(SYMB_NO);
#define XBETWEEN_SYMBOLS(SYMB_NO, C_LINE_NO) \
   if ( xBreakBefore(VarP, xCTrace(xFileName) \
        xCTrace(C_LINE_NO)  SYMB_NO ) ) return;
#define XBETWEEN_SYMBOLS_PRD(SYMB_NO, C_LINE_NO ) \
   if ( xBreakBefore(VarP, xCTrace(xFileName) \
        xCTrace(C_LINE_NO)  SYMB_NO) ) return 1;
#define XBETWEEN_STMTS(SYMB_NO, C_LINE_NO) \
   if ( xBreakBefore(VarP, xCTrace(xFileName) \
        xCTrace(C_LINE_NO)  SYMB_NO) ) return;
#define XBETWEEN_STMTS_PRD(SYMB_NO, C_LINE_NO) \
   if ( xBreakBefore(VarP, xCTrace(xFileName) \
        xCTrace(C_LINE_NO)  SYMB_NO) ) return 1;
#define XAFTER_VALUE_RET_PRDCALL(SYMB_NO) \
   { xSymbolType DUMMYSYMBTYPE; xSetupGRCov(VarP, SYMB_NO, &DUMMYSYMBTYPE);}
#define XAT_LAST_SYMBOL \
   xGRSetSymbol(-1);




/****+***************************************************************
06   Macros
********************************************************************/

/*-------------- GENERAL -----------------*/

#define XASN1_SYNTAX  xUse_ASN1_Syntax

#define XNEWREF_SYNTAX  xUse_NewRef_Syntax
#define XDEREF_SYNTAX   xUse_DeRef_Syntax

#define XVALUE_SYNTAX   xValue_Syntax  /* E.g. struct should start with (. */
#define XSHOWDEFAULT    xShowDefault   /* Print struct default attributes */

#define XINTEGER_OUTPUT_MODE  xIntegerOutputMode
#define XPRINT_INT_FORMAT  xPrintIntFormat
#define XSCAN_INT_FORMAT   xScanIntFormat

/* ----------------------- State properties ---------------------- */
#define NEEDSRECALC(STATEID)   ( STATEID->StateProperties & (int)1 )
#define HASINPUTNONE(STATEID)  ( STATEID->StateProperties & (int)2 )
#define HASVIRTINPUTNONE(STATEID)  ( STATEID->StateProperties & (int)4 )
#define HASPRIOINPUT(STATEID)  ( STATEID->StateProperties & (int)8 )

#define XIS_NONEID_SIGNAL(SIGID)  (SIGID == xNoneSigId)

#if !defined(XPMCOMM) && !defined(XENV)
#define xGlobalNodeNumber() 1
#endif

#define xSizeOfPathStack 50

#ifndef xOffsetOf
#define xOffsetOf(type, field)  ((xptrint) &((type *) 0)->field)
#endif
#define xToLower(C) \
        ((C >= 'A' && C <= 'Z') ? (char)((int)C - (int)'A' + (int)'a') : C)

#define xDefaultPrioProcess      100
#define xDefaultPrioSignal       100
#define xDefaultPrioTimerSignal  100
#define xDefaultPrioContSignal   100
#define xDefaultPrioCreate       100

#define xbool int

#define NIL 0

#ifndef MAX_READ_LENGTH
#define MAX_READ_LENGTH 50000
                        /* max length of input line */
#endif

#ifndef MAX_WRI_LENGTH
#define MAX_WRI_LENGTH 10000
#endif

#ifndef MAX_M_WRI_LENGTH
#define MAX_M_WRI_LENGTH (2*MAX_WRI_LENGTH)
#endif

/*---------- PRINT MACROS ----------------*/

/* Macros to print on stdout or using postmaster */
#define PRINTF(f) {xPrintString(f);}
#define PRINTF2(f,v) {(void)sprintf(PrintStr,f,v); xPrintString(PrintStr);}
#define PRINTF3(f,a,b) {(void)sprintf(PrintStr,f,a,b); xPrintString(PrintStr);}
#define PRINTF4(f,a,b,c) {(void)sprintf(PrintStr,f,a,b,c); xPrintString(PrintStr);}
#define PRINTF5(f,a,b,c,d) {(void)sprintf(PrintStr,f,a,b,c,d); xPrintString(PrintStr);}
#define PRINTF6(f,a,b,c,d,e) {(void)sprintf(PrintStr,f,a,b,c,d,e); xPrintString(PrintStr);}

/*----------- Simulator Kernel Compatibility ------------*/

#define XIS_PID_IN_SYSTEM(PID) (PID != xEnv && PID != SDL_NULL)
#define XPID_TO_PRS(PID)       GetPrs(PID)


/****+***************************************************************
07   Type Forward Declarations
********************************************************************/
typedef struct xIdStruct           *xIdNode;
typedef struct xBlockSubstIdStruct *xBlockSubstIdNode;
typedef struct xLiteralIdStruct    *xLiteralIdNode;
typedef struct xPackageIdStruct    *xPackageIdNode;
typedef struct xSystemIdStruct     *xSystemIdNode;
typedef struct xChannelIdStruct    *xChannelIdNode;
typedef struct xBlockIdStruct      *xBlockIdNode;
typedef struct xPrsIdStruct        *xPrsIdNode;
typedef struct xSrvIdStruct        *xSrvIdNode;
typedef struct xPrdIdStruct        *xPrdIdNode;
typedef struct xRemotePrdIdStruct  *xRemotePrdIdNode;
typedef struct xSignalIdStruct     *xSignalIdNode;
typedef struct xStateIdStruct      *xStateIdNode;
typedef struct xSortIdStruct       *xSortIdNode;
typedef struct xVarIdStruct        *xVarIdNode;
typedef struct xRemoteVarIdStruct  *xRemoteVarIdNode;
typedef struct xSynonymIdStruct    *xSynonymIdNode;

typedef struct xPrsStruct     *xPrsNode;
typedef struct xPrdStruct     *xPrdNode;
typedef struct xSrvStruct     *xSrvNode;

typedef struct xTimerStruct   *xTimerNode;

typedef struct xSignalStruct  *xSignalNode;
typedef xptrint SDL_PId;

/****+***************************************************************
07   Global Variables
********************************************************************/

/*------------ XREADANDWRITEF -------------*/

extern int       WriteSortLevel;    /* used by xWriteSort */

extern xbool      xUse_ASN1_Syntax;

extern xbool      xUse_NewRef_Syntax;
extern xbool      xUse_DeRef_Syntax;

extern xbool      xValue_Syntax;
extern xbool      xShowDefault;

extern int        xIntegerOutputMode;
extern char       xPrintIntFormat[10];
extern char       xScanIntFormat[10];

extern   char      PrintStr[];
         /* Buffer for printing using PRINTXX macros */
extern   char      CTempTemp[];
         /* Buffer for printing predefined SDL data types */

/* --- STATE SPACE GENERATION ---*/
/*** Global variables updated by the state space generation functions ***/

extern int xMoreAlternatives;
    /* Set to 1 in generated code when more alternatives exists
       than the currently executed alternative in a e.g. a
       nondeterministic or informal choice */
extern int xGenErrorAction;
    /* The error action given by the reports generated during the transition
       0 - continue
       1 - prune
       2 - abort */
extern SDL_PId xGenActivePrs;
    /* The process that was active in the current transition. */

/****+***************************************************************
     SCOPE
********************************************************************/

extern xPrsNode   xPrsScope;
extern xPrdNode   xPrdScope;
#ifndef XNOUSEOFSERVICE
extern xSrvNode   xSrvScope;
#endif

/****+***************************************************************
08   Execution Mode Def
********************************************************************/

typedef enum {
  xSim,
  xExEx,
  xBSSEx,
  xInit
} xModeType;

extern xModeType xValMode;


/****+***************************************************************
     Includes
********************************************************************/


#include "sctpred.h"

/****+***************************************************************
09   SDL_PId
********************************************************************/

/* In Type Forward Declarations :
typedef xptrint SDL_PId;
*/

#define SDL_pid SDL_PId
#define SDL_Pid SDL_PId

#define xDef_SDL_PId(V) (*(V) = SDL_NULL)
extern SDL_PId SDL_NULL;
extern SDL_PId xStoppedPId;
#ifndef XOPTCHAN
extern SDL_PId xNotDefPId;
#endif
extern SDL_PId xMinPId;
extern int     xNotDefTimer;
extern int     xNotDefChannel;

extern int xRead_SDL_PId XPP((void * Result));
extern char * xWri_SDL_PId XPP((void  * C));

extern SDL_Boolean xEq_SDL_PId XPP(( SDL_PId A, SDL_PId B));

extern SDL_Boolean xEq_SDL_PId_NULL  XPP(( SDL_PId A ));

#define yDef_SDL_PId(V)       xDef_SDL_PId(V)
#define yEq_SDL_PId xEq_SDL_PId
#define yNEq_SDL_PId(p1,p2) (!xEq_SDL_PId(p1,p2))
#define yEqF_SDL_PId xEq_SDL_PId
#define yNEqF_SDL_PId(p1,p2) (!xEq_SDL_PId(p1,p2))

#define yAssF_SDL_PId(V,E,A)  (V = E)

extern void xPIDLock XPP((void));
extern void xPIDUnLock XPP((void));

typedef struct xCommandFileStruct *xCommandFileNode;

typedef struct xCommandFileStruct {
  FILE  *File;
  xCommandFileNode Next;
} xCommandFileRec;

extern xCommandFileRec * CommandFile;

extern xPrsNode xReadProcess(
  char       * Prompt,
  xPrsIdNode * xIdNodeProcess,
  xIdNode      LimId);

/****+***************************************************************
10   Signal Set
********************************************************************/
typedef unsigned char xInputAction;
 
#define xDiscard         (xInputAction)0
#define xInput           (xInputAction)1
#define xSave            (xInputAction)2
#define xEnablCond       (xInputAction)3
#define xPrioInput       (xInputAction)4


/****+***************************************************************
14   Timer
********************************************************************/
/*typedef xTimerRec  *xTimerNode; See Forward Declarations.*/

typedef struct xTimerStruct {
  TIMER_VARS
}  xTimerRec;

#define TIMERRECSIZE sizeof(xTimerRec)

/****+***************************************************************
15   Signal
********************************************************************/
typedef struct xSignalStruct {
  SIGNAL_VARS
}  xSignalRec;

#define SIGNALRECSIZE sizeof(xSignalRec)

typedef struct xInputPortStruct {
   xSignalNode   Pre;
   xSignalNode   Suc;
   int           Prio;
}  xInputPortRec;      /* HAS TO BE FIRST THREE COMPONENTS IN SIGNAL_VARS !!! */

/****+***************************************************************
12   Procedure ( = Prd )
********************************************************************/
typedef struct xPrdStruct {
   PROCEDURE_VARS
}  xPrdRec;

#define PRDRECSIZE sizeof(xPrdRec)

#define GetStateNodePrd( Prs ) \
  (Prs->State==START_STATE ? \
   xStartStateId : \
   (Prs->State==ERROR_STATE ? \
    xErrorStateId : \
    (Prs->State==XRPC_WAIT_STATE ? \
     &xRPCWaitStateIdRec : \
     Prs->NameNode->StateList[Prs->State] \
     ) \
    ) \
   )

/****+***************************************************************
13   Process ( = Prs )
********************************************************************/

typedef struct xPrsStruct {
   PROCESS_VARS
}  xPrsRec;

typedef struct xSrvStruct {
   SERVICE_VARS
}  xSrvRec;
#define SRVRECSIZE sizeof(xSrvRec)

#define PRSRECSIZE sizeof(xPrsRec)

#ifndef XNOUSEOFSERVICE
#define GetStateNode1( Prs ) \
  (Prs->ActivePrd ? \
   GetPrdStateNode( Prs ) : \
   GetPrsStateNode( Prs ) \
   )
#define GetStateNode( Prs ) \
  (Prs->ActiveSrv ? \
   GetStateNode1( Prs->ActiveSrv ) : \
   GetStateNode1( Prs ) \
   )
#else
#define GetStateNode( Prs ) \
  (Prs->ActivePrd ? \
   GetPrdStateNode( Prs ) : \
   GetPrsStateNode( Prs ) \
   )
#endif

#define GetState( Prs ) \
  (Prs->ActivePrd ? \
   Prs->ActivePrd->State : \
   Prs->State \
   )

#define GetPrsStateNode( Prs )\
  (Prs->State==START_STATE ? \
   xStartStateId : \
   (Prs->State==ERROR_STATE ? \
    xErrorStateId : \
    (Prs->State==XRPC_WAIT_STATE ? \
     &xRPCWaitStateIdRec : \
     Prs->NameNode->StateList[Prs->State] \
     ) \
    ) \
   )

#define GetPrdStateNode( Prs ) GetStateNodePrd( Prs->ActivePrd )

/****+***************************************************************
15   xChannelQueueRec
********************************************************************/
/*
Channel queues are implemented as NULL-terminated lists of signals.
Since differential storage is used the list is embedded in a struct
with a counter of the number of references to this data area.

Note that a NULL pointer is used to represent an empty queue.
*/

typedef struct {
  xSignalNode * List;
  int           NoOfRefs;
} xChannelQueueRec, *xChannelQueue;

/****+***************************************************************
15   xChannelQueueList
********************************************************************/
/*
A channel queue list is implemented as an array of ChannelQueues with
one element for each channel in the system.

The total number of channels in the system (== the length of the array)
is defined by the global variable xNoOfChannels.

The global array xChannelIdNode keeps for each index a pointer to 
the corresponding channel node in the symbol table.
*/

typedef xChannelQueue * xChannelQueueList;

extern int xNoOfChannels;
extern xChannelIdNode * xChannelIdNodeList;

/****+***************************************************************
08   SYSTEM STATE
********************************************************************/

typedef struct xMSCStateTag xMSCStateRec;

typedef struct {
  xSortIdNode sortNode;
  void       *data;
  xbool       referenced;
} dynMemRec, *dynMem;

extern void UserMalloc XPP((void *data));
extern void UserFree XPP((void *data));

extern void *xSysMalloc XPP((xptrint Size));
extern void *xSysMalloc2 XPP((xptrint Size, xSortIdNode refSort));
extern void xSysFree XPP((void **P, xptrint size));

typedef struct {
  xPrsNode        * ActivePrs;   /* NL array for active prs */
  SDL_PId         * ReadyQueue;  /* NL array for ready queue */
  xTimerNode      * TimerQueue;  /* NL array for timer queue */
  SDL_PId         * CheckList;   /* NL array for ? */
  dynMemRec       **dynMemList;  /* NL array for dynamically allocated memory */
  xptrint           HashValue;   /* Used for determining equivalence among
                                    states */
  xptrint           HashValue2;  /* Efficient, but approximate */
  xChannelQueueList ChannelQueues;
  xMSCStateRec    * MSCState;    /* The current MSC state */
} xStateRec;
typedef xStateRec *xStateNode;

#define GetPrsRQ(I) xCurrentSystemState->ActivePrs[xCurrentSystemState->ReadyQueue[I]]

#define GetPrs(P) (P==xEnv ? xCurrentSystemState->ActivePrs[0] : xCurrentSystemState->ActivePrs[P])
#define GetPrs2(S,P) (P==xEnv ? S->ActivePrs[0] : S->ActivePrs[P])

extern xStateNode xCurrentSystemState;
                    /* The current system state during */
                    /* state space exploration */
extern xStateNode xStartSystemState;
                    /* The root of the state space */
extern xPrsNode   xCurrentPrs;
                    /* The current process instance during */
                    /* state space exploration */

extern xStateNode xCopySystemState
       XPP((xStateNode State, SDL_PId Prs, int TimerIndex, int ChNo));
extern void xTouchSystemState
       XPP((xStateNode State, SDL_PId Prs, int TimerIndex, int ChNo));
extern void xReleaseSystemState
       XPP((xStateNode State));
extern int xEqSystemState
       XPP((xStateNode State1, xStateNode State2));
extern void xResetMSCInstance XPP((xStateNode State));

/*********************** HANDLING PIDS ***********************/
extern SDL_PId xInsertPrsInSystemState XPP((xPrsNode Prs, xSignalNode 
           StartUpSig));
extern void    xRemoveFromSystemState  XPP((SDL_PId P));


extern int xNoOfActivePrs XPP(( xPrsIdNode  PrsType ));
extern xPrsNode xFirstActivePrs XPP(( xPrsIdNode  PrsType ));
extern xPrsNode xNextActivePrs XPP(( xPrsNode  Prs ));
extern xPrsNode xFirstActivePrs2 XPP(( xPrsIdNode  PrsType, 
                                       xBlockIdNode BlockSet, int BlockNo ));
extern xPrsNode xNextActivePrs2 XPP(( xPrsNode  Prs ));
extern void xRemovePrsFromRQueue XPP(( xPrsNode  P ));

/****+***************************************************************
08   TRACE
********************************************************************/
#define xShouldBeTraced( TraceType, Process ) 0

/****+***************************************************************
08   ERROR
********************************************************************/

/* Note! Keep consistent with xErrTypeNames in valutil.c */
/*       and DEFAULTxErrAction and DEFAULTxErrLog        */
typedef enum {
  erDeadlock, erImplSigCons,
  erMaxQLen, erChannelOutput,
  erOutput, erOperator, erSubrange, erIndex, erDecision,
  erCreate, erExport, erView,
  erMaxTransLen,
  erUserRule,
  erMSC, erMSCVer,
  erUser, /* Error generated in user written code */
  erUserSpec,
  erLoop,
  erObserver,
  erOptional, erUnionTag,
  erRefError,
  erChoice,
  erTreeWalk,
  erMaxError  /* Used to indicate the number of exploration error types */
              /* "MaxError" is NOT an error type */
} xErrType;

typedef struct xErrTag xErrRec, * xErrNode;
struct xErrTag {
  xErrNode   Suc;  /* Single-linked list in ErrHashTab */
  xErrType   ErrType;
  char     * ErrId;
  xptrint  * Path;
  long       HashVal;
};

extern xErrNode * xErrList;

extern void xReportError XPP((xErrType ErrType, char * ErrId, long HashVal));
extern void xReleaseErrorNode XPP((xErrNode *errnode));
extern void xReleaseError XPP((void));
extern void xAssertError XPP((char * str));
#ifdef XEUNION
extern void xUnionTagError XPP((char *, char *, xbool));
#endif
#ifdef XEOPTIONAL
extern void xOptionalError XPP((char *));
#endif
#ifdef XECHOICE
extern void xChoiceError XPP((char *, char *));
#endif
#ifdef XEREF
extern void xRefError XPP(( void *, xSortIdNode ));
#endif
#ifdef XEOWN
extern void xInsertOwnList XPP((void *, tSDLTypeInfo *));
extern void xRemoveOwnList XPP((void *Ptr));
extern void xSetUpOwner XPP((void **Ptr, xbool ToSignal));
extern void xCheckRefOwn XPP(( void * ));
extern void xCheckForOwnLoops XPP((void));
#endif

extern int xMaxQueueLen ;
    /* The max queue length in input ports */

/****+***************************************************************
08   CTRL
********************************************************************/

typedef struct {
  int    prio;
  int    etype;
  long int ndState1;
  long int ndState2;
#ifndef XNOUSEOFSERVICE
  long int ndState3;
#endif
} xCtrlRec;
typedef xCtrlRec * xCtrlNode;

/* 

Note the usage of ndState1 in xCtrlRec in input from env functions
(where 0 is the most significant bit). Normal case:

Bits:    Usage:
0-11     PrsNo
12-21    SignalNo
22-31    SignalInstNo

MSC verification:

Bits:    Usage:
0-15     InstNo
16-31    PIdNo

*/

#define xRQINDEX(ndstate) ((ndstate >> 16) &  0xffff)
#define xPADNDSTATE(ndstate) (ndstate & 0xffff)
#define xSETINTERNALNDSTATE(ndstate,rqindex,pidno) \
{\
  ndstate=rqindex;\
  ndstate=((ndstate<<16) | (pidno));\
}

#define xPRSNO(ndstate) ((ndstate >> 20) &  0xfff)
#define xSIGNALNO(ndstate) ((ndstate >> 10) &  0x3ff)
#define xSIGNALINSTNO(ndstate) (ndstate & 0x3ff)
#define xSETNDSTATE(ndstate,prsno,signalno,signalinstno) \
{\
  ndstate=prsno;\
  ndstate=((ndstate<<10) | (signalno));\
  ndstate=((ndstate<<10) | (signalinstno));\
}

#define xINSTNO(ndstate) ((ndstate >> 20) &  0xfff)
#define xPIDNO(ndstate) ((ndstate >> 10) &  0x3ff)
#define xMSCSIGNO(ndstate) (ndstate & 0x3ff)
#define xSETMSCNDSTATE(ndstate,instno,pidno, signo) \
{\
  ndstate=instno;\
  ndstate=((ndstate<<10) | (pidno));\
  ndstate=((ndstate<<10) | (signo));\
}


#define MAXEVENTTYPES      5
#define MAXPRIORITYCLASSES 5
#define INTERNAL           0
#define EXTERNAL           1
#define TIMER              2
#define CHANNELOUTPUT      3
#define INPUTNONE          4

extern xbool xEventPriority [MAXPRIORITYCLASSES][MAXEVENTTYPES];

extern xbool xBreakAfterSymbol;
extern xbool xStopAfterOutput;
extern xbool xStopAfterOutputToEnv;
extern xbool xStopAfterCreate;
extern xbool xStopAfterExport;
extern xbool xAllInReadyQueue;
extern int xNoOfSymbolsInTrans;
extern int xMaxNoOfSymbolsInTrans;
extern int xMaxNoOfInst;
extern xbool xZeroSymbolTime;

/****+***************************************************************
16   Symbol Table
********************************************************************/

#define xSignalOrTimer ((1L << ((long)xSignalEC)) | (1L << ((long)xRPCSignalEC)) | (1L << ((long)xTimerEC)))
#define xVariableOrFormalPar ((1L<<((long)xVariableEC)) | (1L<<((long)xFormalParEC)))
#define xChannelOrSignalRoute ((1L<<((long)xChannelEC)) | (1L<<((long)xSignalrouteEC)))


typedef enum {
  xRemoteVarEC,
  xRemotePrdEC,
  xSignalrouteEC,
  xStateEC,
  xTimerEC,
  xFormalParEC,
  xLiteralEC,
  xVariableEC,
  xBlocksubstEC,
  xPackageEC,
  xProcedureEC,
  xOperatorEC,
  xProcessEC,
  xProcessTypeEC,
  xGateEC,
  xSignalEC,
  xSignalParEC,
  xStartUpSignalEC,
  xRPCSignalEC,
  xSortEC,
  xSyntypeEC,
  xSystemEC,
  xSystemTypeEC,
  xBlockEC,
  xBlockTypeEC,
  xChannelEC,
  xServiceEC,
  xServiceTypeEC,
  xCompoundStmtEC,
  xSyntVariableEC,
  xMonitorCommandEC,
  xSynonymEC
  /* xExportEC */
  /* xViewEC */
  /* xChannelsubstEC */
  /* xEnvironmentEC */
  /* xConnectEC */
  /* xGeneratorEC */
  /* xImportedE, */
  /* xLabelEC */
  /* xSignallistEC */
  /* xSynonymEC */
}   xEntityClassType;

typedef enum {
  xPredef, xUserdef, xEnum,
  xStruct, xArray, xGArray, xCArray, xRef, xOwn, xORef, xString, xLString,
  xPowerSet, xGPowerSet, xBag, xInherits, xSyntype,
  xUnion, xUnionC, xChoice
}   xTypeOfSort;


/* KEEP xSymbolType UPDATED WITH xSymbolTypeStr AS DEFINED
   IN sctutil.c */
typedef enum {
   xsStart, xsInput, xsPriorityInput, xsContinuousSignal,
   xsTask, xsAssignmentStatement, xsAssignment2Statement, xsOutput, 
   xsCreateRequest, xsDecision, xsDecisionAny, xsDecisionInformal,
   xsTransitionOption, xsSet, xsReset, xsExport,
   xsProcedureCall, xsValueReturningProcedureCall, xsRPC, xsValueReturningRPC,
   xsIf, xsLoop, xsLoopTest, xsLoopUpdate, xsBreak, xsContinue,
   xsNextstate, xsJoin, xsStop, xsReturn,
   xspCALLInput, xspCALLProcedureCall, xspREPLYOutput, xspCALLNextstate,
   xspREPLYInput, xsLabel, xsNoSuchSymbolType
} xSymbolType;

extern char * xSymbolTypeStr [];
  /* Defined in sctutil.c. KEEP UPDATED WITH xSymbolType */


typedef char  *xNameType;

                                  /*VIEW*/
typedef struct xViewListStruct {
   xPrsIdNode  ViewingPrs;
#ifndef XNOUSEOFSERVICE
   xSrvIdNode  SrvId;
#endif
   xptrint     Offset;
}  xViewListRec;

typedef struct xViewIndexStruct {
   char       *ViewName;   /* var name, prefix for type */
   int         Index;      /* index in xViewListRec */
}  xViewIndexRec;


typedef struct xIdStruct {
   xEntityClassType  EC;
   xIdNode           First;
   xIdNode           Suc;
   xIdNode           Parent;
   xNameType         Name;
   int               Number; /* Unique id that is the same every time  */
                             /* the program is executed. Used for hash */
                             /* value computation */
   int               NeedsQualStatus;
                     /* Cache to store if a unit needs qualifiers
                        ==0  initially
                        ==1  if the unit needs qualifiers
                        ==-1 if the unit does NOT need qualifiers */
}  xIdRec;


                                  /*BLOCKSUBSTRUCTURE*/
typedef struct xBlockSubstIdStruct {
   xEntityClassType  EC;
   xIdNode           First;
   xIdNode           Suc;
   xIdNode           Parent;
   xNameType         Name;
   int               Number; /* Unique id that is the same every time  */
                             /* the program is executed. Used for hash */
                             /* value computation */
   int               NeedsQualStatus;
                     /* Cache to store if a unit needs qualifiers
                        ==0  initially
                        ==1  if the unit needs qualifiers
                        ==-1 if the unit does NOT need qualifiers */
}  xBlockSubstIdRec;


                                  /*LITERAL*/
typedef struct xLiteralIdStruct {
   xEntityClassType  EC;
   xIdNode           First;
   xIdNode           Suc;
   xIdNode           Parent;
   xNameType         Name;
   int               Number; /* Unique id that is the same every time  */
                             /* the program is executed. Used for hash */
                             /* value computation */
   int               NeedsQualStatus;
                     /* Cache to store if a unit needs qualifiers
                        ==0  initially
                        ==1  if the unit needs qualifiers
                        ==-1 if the unit does NOT need qualifiers */
   int               LiteralValue;
}  xLiteralIdRec;


                                  /*PACKAGE*/
typedef struct xPackageIdStruct {
   xEntityClassType  EC;
   xIdNode           First;
   xIdNode           Suc;
   xIdNode           Parent;
   xNameType         Name;
   int               Number; /* Unique id that is the same every time  */
                             /* the program is executed. Used for hash */
                             /* value computation */
   int               NeedsQualStatus;
                     /* Cache to store if a unit needs qualifiers
                        ==0  initially
                        ==1  if the unit needs qualifiers
                        ==-1 if the unit does NOT need qualifiers */
   xNameType         ModuleName;
}  xPackageIdRec;

                                  /*SYSTEM*/
typedef struct xSystemIdStruct {
   xEntityClassType  EC;
   xIdNode           First;
   xIdNode           Suc;
   xIdNode           Parent;
   xNameType         Name;
   int               Number; /* Unique id that is the same every time  */
                             /* the program is executed. Used for hash */
                             /* value computation */
   int               NeedsQualStatus;
                     /* Cache to store if a unit needs qualifiers
                        ==0  initially
                        ==1  if the unit needs qualifiers
                        ==-1 if the unit does NOT need qualifiers */
   xIdNode         * Contents;
   xPrdIdNode      * VirtPrdList;
   xSystemIdNode     Super;
   int               Trace_Default; /* Not used */
   int               GRTrace; /* Not used */
   int               MSCETrace; /* Not used */
}  xSystemIdRec;


                                  /*CHANNEL,SIGNALROUTE*/
typedef struct xChannelIdStruct {
   xEntityClassType  EC;
   xIdNode           First;
   xIdNode           Suc;
   xIdNode           Parent;
   xNameType         Name;
   int               Number; /* Unique id that is the same every time  */
                             /* the program is executed. Used for hash */
                             /* value computation */
   int               NeedsQualStatus;
                     /* Cache to store if a unit needs qualifiers
                        ==0  initially
                        ==1  if the unit needs qualifiers
                        ==-1 if the unit does NOT need qualifiers */
   xSignalIdNode    *SignalSet; /*Array*/
   xIdNode          *ToId;      /*Array*/
   xChannelIdNode    Reverse;
   int               Delay; /* =1 if delay queue otherwise 0 */
                             /* Only relevant for channels */
   int               ChNo; /* Unique number identifying this channel */
                            /* Only relevant for channels */
   int               cDisabled;
                     /* ==1 if the channel has been disabled for ENV signals */
}  xChannelIdRec;   /* And USignalRouteEC.*/


                                  /*BLOCK*/
typedef struct xBlockIdStruct {
   xEntityClassType  EC;
   xIdNode           First;
   xIdNode           Suc;
   xIdNode           Parent;
   xNameType         Name;
   int               Number; /* Unique id that is the same every time  */
                             /* the program is executed. Used for hash */
                             /* value computation */
   int               NeedsQualStatus;
                     /* Cache to store if a unit needs qualifiers
                        ==0  initially
                        ==1  if the unit needs qualifiers
                        ==-1 if the unit does NOT need qualifiers */
   xBlockIdNode      Super;
   xIdNode         * Contents;
   xPrdIdNode      * VirtPrdList;
   xViewListRec    * ViewList;
   xViewIndexRec   * ViewIndex;
   int               NumberOfInst; /* The number of instances in this
                                      block instance set. If this
                                      block is not a block instance
                                      set then 1 */
   int               Trace_Default; /* Not used */
   int               GRTrace; /* Not used */
   int               MSCETrace; /* Not used */
   int               GlobalInstanceId; /* Not used ? */
}  xBlockIdRec;


                                  /*PROCESS*/
typedef struct xPrsIdStruct {
   xEntityClassType  EC;
   xIdNode           First;
   xIdNode           Suc;
   xIdNode           Parent;
   xNameType         Name;
   int               Number; /* Unique id that is the same every time  */
                             /* the program is executed. Used for hash */
                             /* value computation */
   int               NeedsQualStatus;
                     /* Cache to store if a unit needs qualifiers
                        ==0  initially
                        ==1  if the unit needs qualifiers
                        ==-1 if the unit does NOT need qualifiers */
   xStateIdNode     *StateList;
   xSignalIdNode    *SignalSet; /*Used as an array of xIdNode.*/
#ifndef XNOUSEOFSERVICE
   xIdNode          *Contents;
#endif
   xIdNode          *ToId; /*Array*/
   int               MaxNoOfInst;
   int               NextNr;
   int               NoOfStaticInst;
   xPrsNode         *ActivePrsList;
   xptrint           VarSize;
#if defined(XPRSPRIO) || defined(XSIGPRSPRIO) || defined(XPRSSIGPRIO)
   int               Prio;
#endif
   xPrsNode         *AvailPrsList; /* Not used */
   int               Trace_Default; /* Not used */
   int               GRTrace; /* Not used */
#ifndef ULTRIXCC
   char             *(*GRrefFunc) XPP((int, xSymbolType *));
#else
   char             *(*GRrefFunc) ();
#endif
   int               MaxSymbolNumber;
   int               SignalSetLength;
   int               MSCETrace;
         /* Dummy field not used in Validator. It is used in simulator
            and set up in generated code in the init function for
            a not included process (in the e_xx.c file) when 
            generating a partition */
   long int         *CoverageArray;
   long int          NoOfStartTransitions;
   long int          MaxQueueLength;
   void              (*PAD_Function) XPP((xPrsNode,int));
   void              (*Free_Vars) XPP((void *));
   xPrsIdNode        Super;
   xPrdIdNode      * VirtPrdList;
   xBlockIdNode      InBlockInst; /* Pointer to the block node that
                                     represents the block instance
                                     set that this process types 
                                     instantiation is part of */
#ifdef XBREAKBEFORE
   char            * RefToDefinition;
#endif
   int               Observer;   /* =1 if process of this type are
                                    observer processes */
   int               ContainsPointers;
   int               PrsNo;
   int               StaticInst;
   int               senderSkip; /* ==1 it the user has declared that
                                    sender does not change */
   int               offspringSkip; /* as above */
   int               parentSkip; /* as above */
}  xPrsIdRec;


                                  /*SERVICE*/
typedef struct xSrvIdStruct {
   xEntityClassType  EC;
   xIdNode           First;
   xIdNode           Suc;
   xIdNode           Parent;
   xNameType         Name;
   int               Number; /* Unique id that is the same every time  */
                             /* the program is executed. Used for hash */
                             /* value computation */
   int               NeedsQualStatus;
                     /* Cache to store if a unit needs qualifiers
                        ==0  initially
                        ==1  if the unit needs qualifiers
                        ==-1 if the unit does NOT need qualifiers */
   xStateIdNode     *StateList;
   xSignalIdNode    *SignalSet; /*Used as an array of xIdNode.*/
   xIdNode          *ToId; /*Array*/
   xptrint           VarSize;
#ifndef ULTRIXCC
   char             *(*GRrefFunc) XPP((int, xSymbolType *));
#else
   char             *(*GRrefFunc) ();
#endif
   int               MaxSymbolNumber;
   int               SignalSetLength;
   long int         *CoverageArray;
   long int          NoOfStartTransitions;
   xSrvNode         *AvailSrvList;
   void              (*PAD_Function) XPP((xPrsNode,int));
   void              (*Free_Vars) XPP((void *));
   xSrvIdNode        Super;
   xPrdIdNode      * VirtPrdList;
   int               ContainsPointers;
}  xSrvIdRec;


                                  /*PROCEDURE*/
typedef struct xPrdIdStruct {
   xEntityClassType  EC;
   xIdNode           First;
   xIdNode           Suc;
   xIdNode           Parent;
   xNameType         Name;
   int               Number; /* Unique id that is the same every time  */
                             /* the program is executed. Used for hash */
                             /* value computation */
   int               NeedsQualStatus;
                     /* Cache to store if a unit needs qualifiers
                        ==0  initially
                        ==1  if the unit needs qualifiers
                        ==-1 if the unit does NOT need qualifiers */
   xStateIdNode     *StateList;
   xSignalIdNode    *SignalSet; /*Used as an array of xIdNode.*/
   int               (*Assoc_Function) XPP((xPrsNode,int));
   void              (*Free_Vars) XPP((void *));
   xptrint           VarSize;
   xPrdNode         *AvailPrdList;
#ifndef ULTRIXCC
   char             *(*GRrefFunc) XPP((int, xSymbolType *));
#else
   char             *(*GRrefFunc) ();
#endif
   int               MaxSymbolNumber;
   int               SignalSetLength;
   long int         *CoverageArray;
   xPrdIdNode        Super;
   xPrdIdNode      * VirtPrdList;
   int               ContainsPointers;
}  xPrdIdRec;


                                  /*REMOTE PROCEDURE*/
typedef struct xRemotePrdListStruct *xRemotePrdListNode;
typedef struct xRemotePrdListStruct {
   xRemotePrdListNode  Next;
   xPrsIdNode          ExportedPrs;
}  xRemotePrdListRec;

typedef struct xRemotePrdIdStruct {
   xEntityClassType    EC;
   xIdNode             First;
   xIdNode             Suc;
   xIdNode             Parent;
   xNameType           Name;
   int                 Number; /* Unique id that is the same every time  */
                               /* the program is executed. Used for hash */
                               /* value computation */
   int               NeedsQualStatus;
                     /* Cache to store if a unit needs qualifiers
                        ==0  initially
                        ==1  if the unit needs qualifiers
                        ==-1 if the unit does NOT need qualifiers */
   xRemotePrdListNode  RemoteList;   
}  xRemotePrdIdRec;



                                  /*SIGNAL,TIMER,STARTUPSIGNAL*/
typedef struct xSignalIdStruct {
   xEntityClassType  EC;
   xIdNode           First;
   xIdNode           Suc;
   xIdNode           Parent;
   xNameType         Name;
   int               Number; /* Unique id that is the same every time  */
                             /* the program is executed. Used for hash */
                             /* value computation */
   int               NeedsQualStatus;
                     /* Cache to store if a unit needs qualifiers
                        ==0  initially
                        ==1  if the unit needs qualifiers
                        ==-1 if the unit does NOT need qualifiers */
   xptrint           VarSize;
   xSignalNode      *AvailSignalList;
#ifndef ULTRIXCC
   xbool             (*Equal_Timer) XPP((void *, void *));
#else
   xbool             (*Equal_Timer) ();
#endif
#ifdef XFREESIGNALFUNCS
#ifndef ULTRIXCC
   void              (*Free_Signal) XPP((void *));
#else
   void              (*Free_Signal) ();
#endif
#endif
   char               *RefToDefinition;
#if defined(XSIGPRIO) || defined(XSIGPRSPRIO) || defined(XPRSSIGPRIO)
   int               Prio;
#endif
   int               ContainsPointers; /* 1 if some parameter is a */
                                        /* pointer */
   xSignalNode     * EnvSignals; /* NL-list of signals sent from ENV */
   int               dirtyTestValues; /* ==1 if the ENV signals has been manually modified */
   int               sDisabled; /* ==1 if the ENV signals has been disabled */
}  xSignalIdRec;   /* And UTimerEC, UStartUpSignalEC and xRPCSignalEC.*/


                                  /*STATE*/
typedef struct xStateIdStruct {
   xEntityClassType  EC;
   xIdNode           First;
   xIdNode           Suc;
   xIdNode           Parent;
   xNameType         Name;
   int               Number; /* Unique id that is the same every time  */
                             /* the program is executed. Used for hash */
                             /* value computation */
   int               NeedsQualStatus;
                     /* Cache to store if a unit needs qualifiers
                        ==0  initially
                        ==1  if the unit needs qualifiers
                        ==-1 if the unit does NOT need qualifiers */
   int               StateNumber;
   xInputAction     *SignalHandlArray;
                         /*Used as an array of xInputAction.*/
   XINPUTREFTYPE    *InputRef;
#ifndef ULTRIXCC
   xInputAction      (*EnablCond_Function) XPP((XSIGTYPE, void *));
   void              (*ContSig_Function) XPP((void *, int *, xIdNode *, int *));
#else
   xInputAction      (*EnablCond_Function) ();
   void              (*ContSig_Function) ();
#endif
   int               StateProperties;
   long int         *CoverageArray;
   xStateIdNode      Super;
   char              *RefToDefinition;
}  xStateIdRec;




                                  /*SORT*/
typedef struct xSortIdStruct {
   xEntityClassType  EC;
   xIdNode           First;
   xIdNode           Suc;
   xIdNode           Parent;
   xNameType         Name;
   int               Number; /* Unique id that is the same every time  */
                             /* the program is executed. Used for hash */
                             /* value computation */
   int               NeedsQualStatus;
                     /* Cache to store if a unit needs qualifiers
                        ==0  initially
                        ==1  if the unit needs qualifiers
                        ==-1 if the unit does NOT need qualifiers */
   void              (*Free_Function) XPP((void **));
   xbool             (*Test_Function) XPP((void *));
   xptrint           SortSize;
   xTypeOfSort       SortType;
   xSortIdNode       CompOrFatherSort;
   xSortIdNode       IndexSort;
   long int          LowestValue;
      /* xSyntype with one closed range  : lowest value */
      /* xGArray,xString,xGPowerset,xBag : offset of Data in type_yrec */
      /* xLString                        : offset of Data in type */
      /* otherwise                       : 0 */
   long int          HighestValue;
      /* xSyntype with one closed range  : highest value */
      /* xGArray,xString,xGPowerset,xBag : sizeof type_yrec */
      /* xCArray,xLString                : number of elements */
      /* SDL_Character                   : 255 */
      /* SDL_Boolean                     : 1 */
      /* otherwise                       : 0 */
   long int          yrecIndexOffset;
      /* xGArray                         : offset of Index in type_yrec */
      /* otherwise                       : 0 */
   long int          typeDataOffset;
      /* xGArray                         : offset of Data in type (default value) */
      /* otherwise                       : 0 */
   tSDLTypeInfo     *TypeInfo;
   void           ** ValueSet; /* NL list of values used in signals from ENV */
   int               dirtyTestValues;
                       /* ==1 if ValueSet has been manually modified */
   int               ContainsPointers;
}  xSortIdRec;


                                  /*VARIABLE,...*/
typedef struct xVarIdStruct {
   xEntityClassType  EC;
   xIdNode           First;
   xIdNode           Suc;
   xIdNode           Parent;
   xNameType         Name;
   int               Number; /* Unique id that is the same every time  */
                             /* the program is executed. Used for hash */
                             /* value computation */
   int               NeedsQualStatus;
                     /* Cache to store if a unit needs qualifiers
                        ==0  initially
                        ==1  if the unit needs qualifiers
                        ==-1 if the unit does NOT need qualifiers */
   xSortIdNode       SortNode;
   tSDLTypeInfo     *TypeNode;
   xptrint           Offset;
   xptrint           Offset2;
                      /* Offset in startupsignal. Used for process fpar */
                      /* or: Offset for exported value. For process dcl */
   int               IsAddress;
                      /* Used if procedure/operator fpar: */
                      /* first bit = is address */
                      /* second-third bit IN(=0) - IN/OUT(=2) - OUT(=4) */
   void           ** ValueSet; /* NL list of values used in signals from ENV */
                               /* Used only for parameters to signal from ENV */
   int               dirtyTestValues;
                       /* ==1 if the ValueSet has been manually modified */
   int               Skip;
                     /* ==1 it the user has declared that this variable shall */
                     /* not be checked when comparing states in the state space */
}  xVarIdRec;    /* And UFormalParEC and USignalParEC.*/

#define XIS_ADDRESS(P)     ((P)->IsAddress & (int)1)
#define XIS_INOUT_PARA(P)  ((P)->IsAddress & (int)2)
#define XIS_RESULT_PARA(P) ((P)->IsAddress & (int)4)


                                  /*REMOTE VAR*/
typedef struct xRemoteVarListStruct *xRemoteVarListNode;
typedef struct xRemoteVarListStruct {
   xRemoteVarListNode  Next;
   xPrsIdNode          ExportingPrs;
#ifndef XNOUSEOFSERVICE
   xSrvIdNode          SrvId;
#endif
   xptrint             Offset;
}  xRemoteVarListRec;

typedef struct xRemoteVarIdStruct {
   xEntityClassType     EC;
   xIdNode              First;
   xIdNode              Suc;
   xIdNode              Parent;
   xNameType            Name;
   int                  Number; /* Unique id that is the same every time  */
                             /* the program is executed. Used for hash */
                             /* value computation */
   int               NeedsQualStatus;
                     /* Cache to store if a unit needs qualifiers
                        ==0  initially
                        ==1  if the unit needs qualifiers
                        ==-1 if the unit does NOT need qualifiers */
   xptrint              SortSize;
   xRemoteVarListNode   RemoteList;
}  xRemoteVarIdRec;


                                  /*SYNONYM*/
typedef struct xSynonymIdStruct {
   xEntityClassType  EC;
   xIdNode           First;
   xIdNode           Suc;
   xIdNode           Parent;
   xNameType         Name;
   int               Number; /* Unique id that is the same every time  */
                             /* the program is executed. Used for hash */
                             /* value computation */
   int               NeedsQualStatus;
                     /* Cache to store if a unit needs qualifiers
                        ==0  initially
                        ==1  if the unit needs qualifiers
                        ==-1 if the unit does NOT need qualifiers */
   xSortIdNode       SortNode;
}  xSynonymIdRec;    /* And UFormalParEC and USignalParEC.*/


                                  /*MONITORCOMMAND*/
typedef struct xMonitorCommandIdStruct  *xMonitorCommandIdNode;

typedef struct xMonitorCommandIdStruct {
   xEntityClassType  EC;
   xIdNode           First;
   xIdNode           Suc;
   xIdNode           Parent;
   xNameType         Name;
   int               Number; /* Unique id that is the same every time  */
                             /* the program is executed. Used for hash */
                             /* value computation */
   int               NeedsQualStatus;
                     /* Cache to store if a unit needs qualifiers
                        ==0  initially
                        ==1  if the unit needs qualifiers
                        ==-1 if the unit does NOT need qualifiers */
   int               CommandNo;
}  xMonitorCommandIdRec;


#ifdef XGRTRACE
  typedef struct xGRRefStruct{
    char                *GRRef;
    struct xGRRefStruct *Next;
  } *xGRRefList;
#endif


extern XCONST struct xPackageIdStruct yPacR_Predefined;
extern XCONST struct xSortIdStruct    xSrtR_SDL_Boolean;
extern XCONST struct xSortIdStruct    xSrtR_SDL_Bit;
extern XCONST struct xSortIdStruct    xSrtR_SDL_Bit_String;
extern XCONST struct xSortIdStruct    xSrtR_SDL_Octet;
extern XCONST struct xSortIdStruct    xSrtR_SDL_Octet_String;
extern XCONST struct xSortIdStruct    xSrtR_SDL_Character;
extern XCONST struct xSortIdStruct    xSrtR_SDL_Charstring;
extern XCONST struct xSortIdStruct    xSrtR_SDL_IA5String;
extern XCONST struct xSortIdStruct    xSrtR_SDL_NumericString;
extern XCONST struct xSortIdStruct    xSrtR_SDL_PrintableString;
extern XCONST struct xSortIdStruct    xSrtR_SDL_VisibleString;
extern XCONST struct xSortIdStruct    xSrtR_SDL_Duration;
extern XCONST struct xSortIdStruct    xSrtR_SDL_Integer;
extern XCONST struct xSortIdStruct    xSrtR_SDL_Natural;
extern XCONST struct xSortIdStruct    xSrtR_SDL_Null;
extern XCONST struct xSortIdStruct    xSrtR_SDL_Object_Identifier;
extern XCONST struct xSortIdStruct    xSrtR_SDL_PId;
extern XCONST struct xSortIdStruct    xSrtR_SDL_Real;
extern XCONST struct xSortIdStruct    xSrtR_SDL_Time;
#define xSrtN_SDL_Boolean             (&xSrtR_SDL_Boolean)
#define xSrtN_SDL_Bit                 (&xSrtR_SDL_Bit)
#define xSrtN_SDL_Bit_String          (&xSrtR_SDL_Bit_String)
#define xSrtN_SDL_Octet               (&xSrtR_SDL_Octet)
#define xSrtN_SDL_Octet_String        (&xSrtR_SDL_Octet_String)
#define xSrtN_SDL_Character           (&xSrtR_SDL_Character)
#define xSrtN_SDL_Charstring          (&xSrtR_SDL_Charstring)
#define xSrtN_SDL_IA5String           (&xSrtR_SDL_IA5String)
#define xSrtN_SDL_NumericString       (&xSrtR_SDL_NumericString)
#define xSrtN_SDL_PrintableString     (&xSrtR_SDL_PrintableString)
#define xSrtN_SDL_VisibleString       (&xSrtR_SDL_VisibleString)
#define xSrtN_SDL_Duration            (&xSrtR_SDL_Duration)
#define xSrtN_SDL_Integer             (&xSrtR_SDL_Integer)
#define xSrtN_SDL_Natural             (&xSrtR_SDL_Natural)
#define xSrtN_SDL_Null                (&xSrtR_SDL_Null)
#define xSrtN_SDL_Object_Identifier   (&xSrtR_SDL_Object_Identifier)
#define xSrtN_SDL_PId                 (&xSrtR_SDL_PId)
#define xSrtN_SDL_Real                (&xSrtR_SDL_Real)
#define xSrtN_SDL_Time                (&xSrtR_SDL_Time)


extern XCONST struct xIdStruct        xSymbolTableIdRec;
#define xSymbolTableRoot      (&xSymbolTableIdRec)
extern XCONST struct xPrsIdStruct yEnvR_env;
extern xIdNode yEnvO_env[];

extern xSignalIdNode     xUtilSigId;
extern xStateIdNode      xStartStateId;
extern xStateIdRec       xStartStateIdRec;
extern xStateIdRec       xRPCWaitStateIdRec;
extern xStateIdNode      xErrorStateId;
extern xSignalIdNode     xContSigId;
extern xSignalIdNode     xNoneSigId;

extern void xInsertIdNode XPP((xIdNode Node));
extern void xInsertExportedVar XPP((xRemoteVarListNode ExportedVarNode,
                                    xRemoteVarIdNode   RemoteVarNode));
extern void xInsertExportedPrd XPP((xRemotePrdListNode ExportedPrdNode,
                                    xRemotePrdIdNode   RemotePrdNode));

#ifdef XCONNECTPM
typedef  struct {
    int         StartedFromPostmaster;
    xbool       PMConnected;
    int         MyPID;
    int         ReportViewerPId;
    int         SimulatorUIStarted;
    int         MSCEPId;
    int         navigatorPId;
    int         CoveragePID;
  } xNoticeBoardType;
#endif

/****+***************************************************************
     LOW-LEVEL READ/WRITE
********************************************************************/

/* --- Type defs --- */
typedef enum {
  xxId, xxString, xxASN1String, xxSlash, xxColon, xxMinus, xxPlus, xxStar,
  xxComma, xxSemicolon, xxArrowHead,
  xxLPar, xxRPar, xxLParDot, xxRParDot, xxLParColon, xxRParColon, xxDot,
  xxLBracket, xxRBracket, xxLCurlyBracket, xxRCurlyBracket, xxAt,
  xxQuaStart, xxQuaEnd,
  xxLT, xxLE, xxGT, xxGE, xxEQ, xxNE,
  xxQuestionMark, xx2QuestionMark, xxExclMark, xxRArrow, xxStarArrow,
  xxSystem, xxPackage, xxBlock, xxProcess, xxService, xxProcedure,
  xxOperator, xxSubstructure, xxChannel, xxSignalroute, xxType,
  xxNull, xxEnv, xxSelf, xxParent, xxOffspring, xxSender,
  xxEoln, xxEOF, xxErrorToken
} xxToken;

/* --- Global vars --- */
extern  char      * xInputLine;
extern  char      * xInputPos;
extern  char      * xSaveLine;
extern  char      * xSavePos;

extern  FILE      * ExtSynFile;
extern  xbool       First_Call; /* to xReadSynonym */
extern  char        ExtSynFileName[256];

/* --- Macros and function prototypes --- */
extern xxToken xScanToken XPP((char * strVar));
extern void xUngetToken XPP(( xxToken Token, char  * strVar));
extern void xSkipLine XPP((void));
#define xChangeInputLine(strVar) \
  xSaveLine = xInputLine; \
  xSavePos = xInputPos; \
  xInputLine = strVar; \
  xInputPos = strVar
#define xRestoreInputLine() \
  xInputLine = xSaveLine; \
  xInputPos = xSavePos; \
  xSaveLine = (char *)0;
extern int xNextInputChar XPP(( void ));
#define xUngetChar()    (void)xInputPos--



/****+***************************************************************
     READ/WRITE UTILITIES
********************************************************************/
extern int   xScanS XPP(( char * strVar));
extern void  xReadSynonym XPP((void *Result_Addr, tSDLTypeInfo* RootSortNode,
                               char *Synonym_Name));
extern void xWriteOpParameter (char *, void *, tSDLTypeInfo *);
extern xbool xReadOperator XPP((void *Result_Addr, tSDLTypeInfo* SortNode));
extern void  xPrintString XPP((char * Str));
extern char *xWriteSort XPP((void *In_Addr, xSortIdNode SortNode));
extern xxToken xPromptQuestionMark XPP((char *Prompt, char *QuestionPrompt,
                                        char *strVar));
extern int   xfEqualIdString XPP((char *Id, char *ToCompareWith));

extern unsigned int lenNL(void **);
extern void addNL(void ***, void *);
extern int indexNL(void **, void *);
extern void releaseNL(void ***);

extern void xGetQualifier (WriteBuf *, xIdNode, int);

/****+***************************************************************
     In generated code
********************************************************************/
extern void yInit XPP((void));


/****+***************************************************************
17   sctOS
********************************************************************/

#ifdef XCLOCK
extern SDL_Time SDL_Clock XPP(( void ));
#endif

extern void xInitOS XPP((void));

extern void * xAlloc XPP(( xptrint  Size ));

extern void xFree XPP(( void **P, xptrint size ));

extern void xHalt XPP(( void ));

#if defined(XPMCOMM) && !defined(XENV)
extern int  xGlobalNodeNumber XPP(( void ));
#endif

#if defined(XMONITOR) && !defined(XNOSELECT)
extern xbool xCheckForKeyboardInput XPP((long xKeyboardTimeout));
#endif

/****+***************************************************************
19   sctKernel
********************************************************************/

extern xSystemIdNode xSystemId;
extern SDL_PId       xEnv;
extern xPrsIdNode    xEnvId;
extern xPrsIdNode    xNullId;

#if defined(XGRTRACE) || defined(XMONITOR)
extern char * xCurrentSymbolRef;
extern char * xPreviousSymbolRef;
#endif

#ifdef XCONNECTPM
extern xNoticeBoardType  xNoticeBoard;
#endif

#ifdef XMONITOR
extern char * xTranslatorVersion;  /* from generated code */
#endif

#define xFindState(PrsP) \
  ( PrsP->ActivePrd == (xPrdNode)0 \
  ? PrsP->State \
  : PrsP->ActivePrd->State )

#ifdef XEOUTPUT
extern void xSDLOutputError XPP((int ErrorNumber, xSignalNode  S,
                                 int NrReceivers));
#endif

#ifdef XOPERRORF
extern void xSDLOpError  XPP(( char  *OpName, char  *ErrText ));
#endif

#define xErrorSubrange(S, V) xxErrorSubrange((S)->SortIdNode, xWriteSort(V, (S)->SortIdNode))
#define xErrorIndex(S, V) xxErrorIndex((S)->SortIdNode, xWriteSort(V, (S)->SortIdNode))
#define xErrorDecision(S, V) xxErrorDecision(xWriteSort(V, (S)->SortIdNode))

#ifdef XERANGE
extern void xxErrorSubrange  XPP(( xSortIdNode SortNode, char *Value));
#endif

#ifdef XEINDEX
extern void xxErrorIndex  XPP(( xSortIdNode SortNode, char *Value));
#endif

#ifdef XEDECISION
extern void xxErrorDecision  XPP(( char *Value ));
#endif

#ifdef XEERROR
extern void * SDL_Error XPP(( int  Size ));
#endif

#ifdef XBREAKBEFORE
extern xbool xBreakBefore  XPP((
                xPrsNode  P,
        xCTrace(char     *FileName)
        xCTrace(long int  LineNo)
                int       RestartAddress));

extern void xSetupGRCov XPP((xPrsNode P, int SymbolNumber,
                             xSymbolType *SymbolType));

extern void xGRSetSymbol XPP((int SymbolNumber));
#endif

extern xSortIdNode xGetRootSort XPP(( xSortIdNode node ));

extern void ClearObservers XPP(( xIdNode node ));
extern void PrintObserverCommands XPP(( xIdNode node, FILE * f, int printAll ));

extern xbool xInList XPP(( xSignalIdNode Id, xSignalIdNode  *IdList ));

extern int xEqValue XPP((void * Addr1, void * Addr2, xSortIdNode SortId));

extern xSignalNode xGetSignal XPP(( xSignalIdNode SType, SDL_PId Receiver,
                                    SDL_PId Sender ));

extern xSignalNode xTouchSignal XPP(( xSignalNode  S ));

extern void xReleaseSignal XPP(( xSignalNode  *S ));

extern int xEqSignal XPP(( xSignalNode  Sig1, xSignalNode  Sig2 ));

/* Disregards Sender/Receiver in the comparition */
extern int xEqSignal3 XPP(( xSignalNode  Sig1, xSignalNode  Sig2 ));
extern int xEqSignal4 XPP(( xSignalNode Sig1, xSignalNode Sig2, 
                            int *skip_pars ));

extern xSignalNode xCopySignal XPP((xSignalNode OldSig));
extern int HasParOfSort XPP((xSignalNode OldSig, xSortIdNode SortId));
extern int HasParameter XPP((xSignalIdNode OldSig));
extern int NoOfExtOccurences XPP((xSignalIdNode SigId));


extern xPrdNode xGetPrd  XPP(( xPrdIdNode  PrdId ));

extern void xAddPrdCall  XPP((
  xPrdNode   R,
  xPrsNode   P,
  int        StaticFatherLevel,
  int        RestartAddress ));

extern xIdNode xContentsInstNode XPP((xIdNode  CurrentInst,
                                      xIdNode  TypeToFindInstOf ));
extern xPrsIdNode xPrsInst(xIdNode, xIdNode, int);

extern void xRemovePrdCall  XPP(( xPrsNode P ));

extern SDL_PId xFindToReceiver XPP((xPrsIdNode PrsType,    /* Receiving type */
                                    xPrsNode Sender,       /* Sender */
                                    xSignalNode Signal )); /* Sent signal */

#if defined(XEOUTPUT) || defined(XMONITOR)
#ifdef XSIGPATH
extern int xIsPath XPP((xSignalNode Signal, xIdNode *ViaList,
                        xIdNode Path[], int *PathLength));
#else
extern int xIsPath XPP((xSignalNode Signal, xIdNode *ViaList));
#endif
#endif

#ifndef XOPTCHAN
#ifdef XSIGPATH
extern int xFindReceiver XPP((xSignalNode Signal, xIdNode *ViaList,
                              xIdNode *Path, int *PathLength));
#else
extern int xFindReceiver XPP((xSignalNode Signal, xIdNode *ViaList));
#endif
#endif

extern xInputAction xFindInputAction XPP((
  xSignalIdNode SignalId,
  xPrsNode      VarP,
  xIdNode     * IdNodeWithInput,
  int         * RestartAddress));

extern void xRemoveFromInputPort XPP((xSignalNode S));

extern int SignalsInPort XPP((xPrsNode PrsNode));

extern void SDL_Output XPP((xSignalNode S  xSigPrioPar(int Prio),
                            xIdNode ViaList[]));

extern void SDL_OutputTimerSignal XPP(( xTimerNode  T ));

extern void SDL_Create XPP((xSignalNode StartUpSig, xPrsIdNode PrsId,
                            int BlockInstNumber ));

extern void SDL_Stop  XPP(( xPrsNode  PrsP ));

extern void SDL_Set  XPP(( SDL_Time T, xSignalNode S ));

extern void SDL_Reset  XPP(( xSignalNode  *TimerS ));

extern void SDL_SimpleReset  XPP(( xPrsNode  P, xSignalIdNode   TimerId ));

extern SDL_Boolean SDL_Active  XPP(( xSignalIdNode   TimerId, xPrsNode  P ));

extern void SDL_NextState  XPP(( xPrsNode PrsP, int  InState ));

extern void SDL_RPC_WaitState XPP((xPrsNode PrsP, int RestartAddress,
                                   XSIGTYPE pREPLY_Waited_For ));

extern SDL_Time SDL_Now  XPP(( void ));

extern void * xGetExportAddr XPP((
  xRemoteVarIdNode RemoteVarNode,
  SDL_PId          P,
  xbool            IsDefP,
  xPrsNode         Importer ));

extern void xCheckCheckList  XPP(( void ));

extern SDL_PId xGetExportingPrs XPP((xRemotePrdIdNode RemotePrdNode,
                                     xPrsNode         Importer ));

extern void * SDL_View (
         xViewListRec *VList,       /* list of prs revealing this variable */
         SDL_PId       P,           /* PId expr in view */
         xbool         IsDefP,      /* is PId expression in view() */
         xPrsNode      ViewingPrs,  /* process instance perfoming view */
  xeView(char *        Reveal_Var)  /* viewed variable name as string */
         int           SortSize);   /* size of sort */
extern int SDL_View_Index XPP((xPrsNode, char *));


#ifndef XNOUSEOFSERVICE
extern void xStart_Services XPP(( xPrsNode Process ));
#endif


extern SDL_Charstring xStr2SDL XPP((char * str));

extern void SDL_Halt  XPP(( void ));

#ifdef XENV 
extern xSignalIdNode xEnvFindSignalId XPP((char *NameString));

extern xChannelIdNode xEnvFindChannelId XPP((char *NameString));
#endif
       /* XENV */


#ifdef XSDLENVUI
extern int xInit_UI_sdlenv  XPP(( void ));
#endif

extern void xSetHasBeenCopied XPP((xStateNode State));

extern char * xCopyStr XPP((char * S));

extern void xAddToEnv XPP((xChannelIdNode));

extern xbool xContainsPointers XPP((xSortIdNode SortId));


#ifdef XMSCE
/****+***************************************************************
     MSCE
********************************************************************/
extern void xMSCEProcedureReturn XPP((xPrsNode PrsP, xPrdNode PrdVarP));

extern void xMSCEDecision (xPrsNode, void *, tSDLTypeInfo *);

extern void xMSCETask XPP((xPrsNode, char *In_Str));

extern void xMSCEAssign (xPrsNode, char *, void *, tSDLTypeInfo *);
#endif
       /* XMSCE */


/****+***************************************************************
     TRACE
********************************************************************/

extern void xTraceOutput XPP((xSignalNode S, xChannelIdNode Channel));

extern void xTraceChannelOutput XPP((xChannelIdNode ChannelId, xSignalNode S));

extern void xTraceOutputDiscard XPP((xSignalNode S));

extern void xTraceReceive XPP((xSignalNode S, xChannelIdNode Channel));

extern void xTraceChannelReceive XPP((xChannelIdNode ChannelId, xSignalNode S));

extern void xTraceTimerOutput XPP((xSignalNode  S));

extern void xTraceTimerOutputDiscard XPP((xSignalNode S));

extern void xTraceCreate XPP((xSignalNode StartUpSig));

extern void xTraceUnsuccessfulCreate XPP((xPrsIdNode  PrsId));

extern void xTraceSet XPP((SDL_Time T, xTimerNode S));

extern void xTraceReset XPP((xTimerNode S));

extern void xTraceResetAction XPP((int Code, xTimerNode S));

extern void xTraceNextstate XPP((char * In_Str));

extern void xTraceNextstateDiscard XPP((xPrsNode PrsP, xSignalNode Signal));

extern void xTraceTask XPP((char * In_Str));

extern void xTraceAlg XPP((char * In_Str));

extern void xTraceAlgValue (char *, void *, tSDLTypeInfo *);
extern void xTraceAssign (char *, void *, tSDLTypeInfo *);
extern void xTraceDecision (void *, tSDLTypeInfo *);

extern void xTraceNondetDecision XPP(( int No, int MaxNo));
extern void xTraceInformalDecision XPP(( SDL_Charstring Str ));

extern void xTraceStop XPP((xPrsNode PrsP));

extern void xTraceTransition XPP((xPrsNode Process));

extern void xTraceSpontTransition XPP((xPrsNode Process, xStateIdNode StateId,
                                       int NoneNo));

extern void xTraceStartService XPP((xSrvNode Srv));

extern void xTraceProcedureStart XPP((xPrdNode PrdVarP));

extern void xTraceProcedureReturn XPP((xPrdNode PrdVarP));

extern void xTraceNotImplCreate XPP((char * S));

extern void xTraceNotImplProcedure XPP((char * S));

extern void xTraceExport XPP((char *In_Str));


/********************************************************************
    Interface functions for access data type 
********************************************************************/

#define vv( P, V, T ) (*(T *)xVarVal(P,V))

extern int xGetNoOfInstStr XPP((  char * str));
extern void * xVarVal XPP(( SDL_PId P, char * V ));
extern SDL_PId xFindPId XPP(( char * name, int no ));
extern SDL_PId xFindFirstPID XPP(( xPrsIdNode PType ));
extern char * xGetState XPP(( SDL_PId P ));
extern int xNoOfInst XPP(( xPrsIdNode PrsNode ));
extern int xTerminated XPP(( SDL_PId P ));
extern char * xGetProcedure XPP(( SDL_PId P ));
extern int xGetNoOfSignals XPP(( SDL_PId P ));
extern char * xGetSignalType XPP(( SDL_PId P, int i ));
extern int xInQueue XPP(( SDL_PId P, char * str ));
extern int topDepth XPP(( void ));
extern int xGetTotalSymb XPP(( void ));
extern int xGetExecSymb XPP(( void ));
extern int  xEnvOutput XPP(( char * ));

/**************************************************************************
30   Access functions for test values in symbol table
**************************************************************************/

extern int MaxNoOfSortTestValues;
extern int MaxSignalDefs;


extern void *xReadSortValue XPP(( xSortIdNode SortNode ));
extern void xListSortValues XPP(( xSortIdNode SortNode ));
extern void xReleaseSortValues XPP(( xSortIdNode SortNode ));
extern void *xReadParValue XPP(( xVarIdNode ParNode ));
extern void xListParValues XPP(( xVarIdNode ParNode ));
extern void xReleaseParValues XPP(( xVarIdNode ParNode ));
extern void xAddDefaultSortValues XPP(( xSortIdNode SortNode ));
extern void xReleaseAllSortValues XPP(( xIdNode Root ));
extern void xListAllParValues XPP(( void ));
extern void xReleaseSignalParValues XPP(( xSignalIdNode SignalNode ));
extern void xReleaseAllParValues XPP(( void ));
extern void xReleaseSignalDefs XPP(( int markAsDirty ));
extern void xReleaseOneSignalDefs XPP(( xSignalIdNode xSignalId ));
extern void xAddAllDefaultSignals XPP(( void ));
extern int  xCountSignalDefs XPP(( void ));
extern void xAddAllDefaultSortValues XPP(( void ));
extern void TVSaveAllSortValues XPP(( FILE * f, int saveAll ));
extern void TVSaveAllParameterValues XPP(( FILE * f, int saveAll ));


#endif
       /* X_SCTTYPES_H */
