/*************************************************************
Generated for IBM Rational SDL & TTCN Suite 6.3.0.2.22510 at Mon Nov 21 03:16:40 PM MET 2011
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 1990, 2011.  All Rights Reserved.

U.S. Government Users Restricted Rights:  
Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/
/*+MHDR*/
/*
+------------------------------------------------------------------------------+
#  Modulname: mk_outp.h
+------------------------------------------------------------------------------+
*/
/*-MHDR*/



#ifndef __MK_OUTP_H_
#define __MK_OUTP_H_

#ifdef XSYSID
  /*
  ** If partitioning is used, then redefine function names
  ** to make them unique in the whole system (over
  ** all partitions)
  */
  #define xmk_SendSimple                      XMAKENAME(XSYSID,SendSimple )
  #define xmk_Send                            XMAKENAME(XSYSID,Send)
  #define xmk_Determine_Receiver              XMAKENAME(XSYSID,Determine_Receiver )
  #define xmk_EnvSend                         XMAKENAME(XSYSID,EnvSend)
#endif /* ... XSYSID */


/*
** Definition of the Simple Output function with few parameters ...
*/
#ifdef XMK_USE_xmk_SendSimple
  #ifdef XMK_USE_RECEIVER_PID_IN_SIGNAL
    /*
    ** Each signal contains a Receiver PID
    */
    extern void xmk_SendSimple ( xmk_T_SIGNAL, xPID );
  #else
    /*
    ** No signal contains a Receiver PID
    */
    extern void xmk_SendSimple ( xmk_T_SIGNAL );
  #endif /* ... XMK_USE_RECEIVER_PID_IN_SIGNAL */
#endif

/*
** Definition of the complex Output function with lot of parameters ...
*/
#ifdef XMK_USED_SIGNAL_WITH_PARAMS
  #define XOUTP_PARA_NON_LAST xmk_T_MESS_LENGTH,void xmk_RAM_ptr,
  #define XOUTP_PARA_LAST     xmk_T_MESS_LENGTH,void xmk_RAM_ptr
#else
  #define XOUTP_PARA_NON_LAST
  #define XOUTP_PARA_LAST
#endif

#if defined(XMK_USE_SIGNAL_PRIORITIES) && defined(XMK_USE_RECEIVER_PID_IN_SIGNAL)
  /*
  ** Each signal contains a Signal priority
  ** Each signal contains a Receiver PID
  */
  extern void xmk_Send ( xmk_T_SIGNAL, xmk_T_PRIO, XOUTP_PARA_NON_LAST xPID );
#endif

#if defined(XMK_USE_SIGNAL_PRIORITIES) && !defined(XMK_USE_RECEIVER_PID_IN_SIGNAL)
  /*
  ** Each signal contains a Signal priority
  ** No   signal contains a Receiver PID
  */
  extern void xmk_Send ( xmk_T_SIGNAL, xmk_T_PRIO, XOUTP_PARA_LAST );
#endif

#if !defined(XMK_USE_SIGNAL_PRIORITIES) && defined(XMK_USE_RECEIVER_PID_IN_SIGNAL)
  /*
  ** No   signal contains a Signal priority
  ** Each signal contains a Receiver PID
  */
  extern void xmk_Send ( xmk_T_SIGNAL, XOUTP_PARA_NON_LAST xPID );

#endif

#if !defined(XMK_USE_SIGNAL_PRIORITIES) && !defined(XMK_USE_RECEIVER_PID_IN_SIGNAL)

  #ifdef XMK_USED_SIGNAL_WITH_PARAMS
    /*
    ** No   signal contains a Signal priority
    ** No   signal contains a Receiver PID
    */
    extern void xmk_Send ( xmk_T_SIGNAL, XOUTP_PARA_LAST );
  #else
    /*
    ** No   signal contains a Signal priority
    ** No   signal contains a Receiver PID
    ** No   signal contains parameters
    */
    extern void xmk_Send ( xmk_T_SIGNAL );
  #endif

#endif

#ifdef XMK_USE_SEND_ENV_FUNCTION

  #if defined(XMK_USE_SIGNAL_PRIORITIES) && defined(XMK_USE_RECEIVER_PID_IN_SIGNAL)
    /*
    ** Each signal contains a Signal priority
    ** Each signal contains a Receiver PID
    */
    extern void xmk_EnvSend ( xmk_T_SIGNAL, xmk_T_PRIO, XOUTP_PARA_NON_LAST xPID );
  #endif

  #if defined(XMK_USE_SIGNAL_PRIORITIES) && !defined(XMK_USE_RECEIVER_PID_IN_SIGNAL)
    /*
    ** Each signal contains a Signal priority
    ** No   signal contains a Receiver PID
    */
    extern void xmk_EnvSend ( xmk_T_SIGNAL, xmk_T_PRIO, XOUTP_PARA_LAST );
  #endif

  #if !defined(XMK_USE_SIGNAL_PRIORITIES) && defined(XMK_USE_RECEIVER_PID_IN_SIGNAL)
    /*
    ** No   signal contains a Signal priority
    ** Each signal contains a Receiver PID
    */
    extern void xmk_EnvSend ( xmk_T_SIGNAL, XOUTP_PARA_NON_LAST xPID );

  #endif

  #if !defined(XMK_USE_SIGNAL_PRIORITIES) && !defined(XMK_USE_RECEIVER_PID_IN_SIGNAL)

    #ifdef XMK_USED_SIGNAL_WITH_PARAMS
      /*
      ** No   signal contains a Signal priority
      ** No   signal contains a Receiver PID
      */
      extern void xmk_EnvSend ( xmk_T_SIGNAL, XOUTP_PARA_LAST );
    #else
      /*
      ** No   signal contains a Signal priority
      ** No   signal contains a Receiver PID
      ** No   signal contains parameters
      */
      extern void xmk_EnvSend ( xmk_T_SIGNAL );
    #endif

   #endif
#endif


#undef  XOUTP_PARA_NON_LAST
#undef  XOUTP_PARA_LAST

extern xPID xmk_Determine_Receiver ( xmk_T_PROCESS );

#endif
