/*************************************************************
Generated for IBM Rational SDL & TTCN Suite 6.3.0.2.22510 at Mon Nov 21 03:16:40 PM MET 2011
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 1990, 2011.  All Rights Reserved.

U.S. Government Users Restricted Rights:  
Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/
/*+MHDR*/
/*

+------------------------------------------------------------------------------+
#  Modulname: mk_time.h
+------------------------------------------------------------------------------+
*/
/*-MHDR*/



#ifndef __MK_TIME_H_
#define __MK_TIME_H_

#ifdef XSYSID
  /*
  ** If partitioning is used, then redefine function names
  ** to make them unique in the whole system (over
  ** all partitions)
  */
  #define xmk_InitTimer                       XMAKENAME(XSYSID,InitTimer)
  #define xmk_TimerSet                        XMAKENAME(XSYSID,TimerSet)
  #define xmk_TimerReset                      XMAKENAME(XSYSID,TimerReset)
  #define xmk_ActualTimerReset                XMAKENAME(XSYSID,ActualTimerReset)
  #define xmk_TimerActive                     XMAKENAME(XSYSID,TimerActive)
  #define xmk_ChkTimer                        XMAKENAME(XSYSID,ChkTimer)
  #define xmk_NextTimerExpiry                 XMAKENAME(XSYSID,NextTimerExpiry)
  #define xmk_ResetAllTimer                   XMAKENAME(XSYSID,ResetAllTimer)
  #define xmk_QueryTimer                      XMAKENAME(XSYSID,QueryTimer )
  #define xmk_FirstTimer                      XMAKENAME(XSYSID,FirstTimer)
  #define xmk_NextTimer                       XMAKENAME(XSYSID,NextTimer)
#endif /* ... XSYSID */

extern void   xmk_InitTimer ( void );

typedef struct _xmk_T_TIMER  
{
  struct _xmk_T_TIMER xmk_RAM_ptr next ;
  xmk_T_SIGNAL   Signal   ;
  xmk_T_TIME     Time     ;
  #ifdef XMK_USE_RECEIVER_PID_IN_SIGNAL
    /*
    ** The timer is owned by this PID :
    */
    xPID         OwnerProcessPID ;
  #endif
  #ifdef XMK_USED_TIMER_WITH_PARAMS
    SDL_Integer TimerParValue ;
  #endif
} xmk_T_TIMER ;

#ifndef XMK_USED_TIMER_WITH_PARAMS
  extern void   xmk_TimerSet ( xmk_T_TIME, xmk_T_SIGNAL );
#else
  extern void   xmk_TimerSet ( xmk_T_TIME, xmk_T_SIGNAL, SDL_Integer );
#endif

/*
** This function is used to differ between a reset
** due to timer set and an explicit reset in a SDL symbol.
** In addition, the function is used by the Cmicro Recorders 
** play mode.
*/
#ifndef XMK_USED_TIMER_WITH_PARAMS
  void xmk_ActualTimerReset ( xmk_T_SIGNAL );
#else
  void xmk_ActualTimerReset ( xmk_T_SIGNAL, SDL_Integer );
#endif


#if defined(XMK_SYSTEM_INFO) || defined(XMK_ADD_PROFILE) 
  xmk_T_TIMER xmk_RAM_ptr xmk_FirstTimer ( void );
  xmk_T_TIMER xmk_RAM_ptr xmk_NextTimer ( void );
#endif

#ifndef XMK_USED_TIMER_WITH_PARAMS
  extern void         xmk_TimerReset  (xmk_T_SIGNAL );
  extern xmk_T_BOOL   xmk_TimerActive (xmk_T_SIGNAL );
#else
  extern void         xmk_TimerReset  ( xmk_T_SIGNAL, SDL_Integer );
  extern xmk_T_BOOL   xmk_TimerActive ( xmk_T_SIGNAL, SDL_Integer) ;
#endif /* ... XMK_USED_TIMER_WITH_PARAMS */

extern void         xmk_ChkTimer ( void ) ;

#ifdef XMK_USE_INTERNAL_QUEUE_HANDLING
  extern xmk_T_BOOL   xmk_NextTimerExpiry ( xmk_T_TIME * );
#endif

extern void         xmk_ResetAllTimer ( xPID );

#ifdef XMK_USE_TIMER_SCALE
  extern int xmk_TimerScaleFactor;
#endif

#endif
