/*************************************************************
Generated for IBM Rational SDL & TTCN Suite 6.3.0.2.22510 at Mon Nov 21 03:16:40 PM MET 2011
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 1990, 2011.  All Rights Reserved.

U.S. Government Users Restricted Rights:  
Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/

#include "cucf.h"
#include "er/per/per_content.h"

#ifndef CODER_REMOVE_PER

/*************************************************/
/******************* DECODE **********************/
/*************************************************/

/**************************************************
 * NAME: PERDecode
 *       
 *
 */

int
PERDecode(tCoder* Coder, tASN1TypeInfo* Type, void* Val)
{
  int retCode;
  void* DecVal = NULL;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "PERDecode\n");
#endif

  if ((retCode = BufGetErrorCode(Coder)) != ec_SUCCESS)
    return retCode;

  CUCFSetErrorCatcher(Coder, retCode);
  if (retCode == 0)
    {
      tVMSULong Length;
      unsigned char* DataCurr;
      unsigned char BitCurr;

      EPInit(Coder, Type);
      VMSInit(Coder, Type, Val);
      Coder->ER.MemStart = BufGetMemory(Coder, &Length);
      Coder->ER.MemEnd   = Coder->ER.MemStart + Length;
      Coder->ER.DataEnd  = BufGetDataEnd(Coder, &Coder->ER.BitEnd);
      if (Coder->ER.BitEnd != 7)
        Coder->ER.DataEnd++;
      Coder->ER.DataCurr = BufGetDataCurr(Coder, &Coder->ER.BitCurr);
      DataCurr           = Coder->ER.DataCurr;
      BitCurr            = Coder->ER.BitCurr;
      if (!(Coder->ER.Rule & er_PER))
        Coder->ER.Rule = (er_PER | CUCF_PER_VARIANT);
      VMSGetValue(Coder, Val, Type, DecVal);

      PERDecVal(Coder, Type, DecVal ER_OLIST(NULL));

      if ((Coder->ER.DataCurr == DataCurr) && (Coder->ER.BitCurr == BitCurr))
        {
          PERGetByte(Coder);
        }
      if (!(Coder->ER.Rule & er_NoEndPad))
        {
          PERAlign(Coder);
        }
      BufSetDataCurr(Coder, Coder->ER.DataCurr - DataCurr, Coder->ER.BitCurr);
      Coder->ER.ValueBitLength = ((Coder->ER.DataCurr - DataCurr) << 3) + (BitCurr - Coder->ER.BitCurr);
      
	  VMSSetValue(Coder, Val, Type, DecVal);
    }

  Coder->EMS.IsAssigned = 0;
  return Coder->EMS.ErrorCode;
}

#endif /* !CODER_REMOVE_PER */
